=== modified file 'INSTALL'
--- INSTALL	2014-07-25 22:44:20 +0000
+++ INSTALL	2011-03-08 19:09:03 +0000
@@ -4,16 +4,15 @@
   
 ** Operating System
    
-   Debian 6.0 "squeeze" or Ubuntu 10.10 "Maverick Meerkat" (or later).
+   Debian 6.0 "squeeze" or Ubuntu 10.10 "Maverick Meerkat".
    
    This is mostly for the support scripts which make sure that the
    client is installed and started in the initial RAM disk environment
-   and that the initial RAM file system image file is automatically
-   made unreadable.  The server and client programs themselves *could*
-   be run in other distributions, but they *are* specific to GNU/Linux
-   systems, and are not written with portabillity to other Unixes in
-   mind.
-   
+   and that the initrd.img file is automatically made unreadable.  The
+   server and client programs themselves *could* be run in other
+   distributions, but they *are* specific to GNU/Linux systems, and
+   are not written with portabillity to other Unixes in mind.
+  
 ** Libraries
    
    The following libraries and packages are needed.  (It is possible
@@ -28,7 +27,7 @@
     + DocBook 4.5         http://www.docbook.org/
       Note: DocBook 5.0 is not compatible.
     + DocBook XSL stylesheets 1.71.0
-                         http://wiki.docbook.org/DocBookXslStylesheets
+                   http://wiki.docbook.org/topic/DocBookXslStylesheets
     
     Package names:
     docbook docbook-xsl
@@ -36,42 +35,34 @@
     To build just the documentation, run the command "make doc".  Then
     the manual page "mandos.8", for example, can be read by running
     "man -l mandos.8".
-    
+   
 *** Mandos Server
-    + GnuTLS 2.4          http://www.gnutls.org/
-      Note: GnuTLS 3 will only work with Python-GnuTLS 2
+    + GnuTLS 2.4          http://www.gnu.org/software/gnutls/
     + Avahi 0.6.16        http://www.avahi.org/
-    + Python 2.7          https://www.python.org/
-    + Python-GnuTLS 1.1.5 https://pypi.python.org/pypi/python-gnutls/
+    + Python 2.6          http://www.python.org/
+    + Python-GnuTLS 1.1.5 http://pypi.python.org/pypi/python-gnutls/
     + dbus-python 0.82.4  http://dbus.freedesktop.org/doc/dbus-python/
-    + PyGObject 2.14.2    https://developer.gnome.org/pygobject/
-    + pkg-config  http://www.freedesktop.org/wiki/Software/pkg-config/
-    + Urwid 1.0.1         http://urwid.org/
-      (Only needed by the "mandos-monitor" tool.)
+    + PyGObject 2.14.2    http://library.gnome.org/devel/pygobject/
+    + Urwid 0.9.8.3       http://excess.org/urwid/
     
     Strongly recommended:
-    + fping 2.4b2-to-ipv6      http://www.fping.org/
-    + ssh-keyscan from OpenSSH http://www.openssh.com/
+    + fping 2.4b2-to-ipv6 http://www.fping.com/
     
     Package names:
     python-gnutls avahi-daemon python python-avahi python-dbus
-    python-gobject python-urwid pkg-config fping ssh-client
-    
+    python-gobject python-urwid
+   
 *** Mandos Client
     + initramfs-tools 0.85i
-                        https://tracker.debian.org/pkg/initramfs-tools
-    + GnuTLS 2.4        http://www.gnutls.org/
-    + Avahi 0.6.16      http://www.avahi.org/
-    + GnuPG 1.4.9       https://www.gnupg.org/
-    + GPGME 1.1.6       https://www.gnupg.org/related_software/gpgme/
-    + pkg-config  http://www.freedesktop.org/wiki/Software/pkg-config/
-    
-    Strongly recommended:
-    + OpenSSH           http://www.openssh.com/
+                  http://packages.qa.debian.org/i/initramfs-tools.html
+    + GnuTLS 2.4          http://www.gnu.org/software/gnutls/
+    + Avahi 0.6.16        http://www.avahi.org/
+    + GnuPG 1.4.9         http://www.gnupg.org/
+    + GPGME 1.1.6         http://www.gnupg.org/related_software/gpgme/
     
     Package names:
     initramfs-tools libgnutls-dev libavahi-core-dev gnupg
-    libgpgme11-dev pkg-config ssh
+    libgpgme11-dev
 
 * Installing the Mandos server
   
@@ -107,11 +98,15 @@
      and append this to the file "/etc/mandos/clients.conf" *on the
      server computer*.
   
-  4. Configure the client to use any special configuration needed for
-     your local system.  Note: This is not necessary if the server is
-     present on the same wired local network as the client.  If you do
-     make changes to /etc/mandos/plugin-runner.conf, the initrd.img
-     file must be updated, possibly using the following command:
+  4. Configure the client to use the correct network interface.  The
+     interface to use is automatically chosen at boot, and if this
+     needs to be adjusted, it will be necessary to edit
+     /etc/initramfs-tools/initramfs.conf to change the DEVICE setting
+     there.  Alternatively, the file /etc/mandos/plugin-runner.conf
+     can be edited to add a "--device" parameter for the
+     mandos-client(8) plugin.  Please note: If any of those files are
+     changed, the initrd.img file must be updated, possibly using the
+     following command:
      
 	# update-initramfs -k all -u
   
@@ -131,14 +126,12 @@
      
      After this, the client computer should be able to reboot without
      needing a password entered on the console, as long as it does not
-     take more than five minutes to reboot.
+     take more than an hour to reboot.
 
 * Further customizations
   
   You may want to tighten or loosen the timeouts in the server
   configuration files; see mandos.conf(5) and mandos-clients.conf(5).
-  If IPsec is not used and SSH is not installed, it is suggested that
-  a more cryptographically secure checker program is used and
-  configured, since, without IPsec, ping packets can be faked.
-
-#+STARTUP: showall
+  If IPsec is not used, it is suggested that a more cryptographically
+  secure checker program is used and configured, since without IPsec
+  ping packets can be faked.

=== modified file 'Makefile'
--- Makefile	2014-07-17 03:24:57 +0000
+++ Makefile	2012-06-06 14:12:50 +0000
@@ -1,17 +1,14 @@
-WARN=-O -Wall -Wextra -Wdouble-promotion -Wformat=2 -Winit-self \
-	-Wmissing-include-dirs -Wswitch-default -Wswitch-enum \
-	-Wunused -Wuninitialized -Wstrict-overflow=5 \
-	-Wsuggest-attribute=pure -Wsuggest-attribute=const \
-	-Wsuggest-attribute=noreturn -Wfloat-equal -Wundef -Wshadow \
+WARN=-O -Wall -Wformat=2 -Winit-self -Wmissing-include-dirs \
+	-Wswitch-default -Wswitch-enum -Wunused-parameter \
+	-Wstrict-aliasing=1 -Wextra -Wfloat-equal -Wundef -Wshadow \
 	-Wunsafe-loop-optimizations -Wpointer-arith \
 	-Wbad-function-cast -Wcast-qual -Wcast-align -Wwrite-strings \
-	-Wconversion -Wlogical-op -Waggregate-return \
-	-Wstrict-prototypes -Wold-style-definition \
-	-Wmissing-format-attribute -Wnormalized=nfc -Wpacked \
-	-Wredundant-decls -Wnested-externs -Winline -Wvla \
-	-Wvolatile-register-var -Woverlength-strings
+	-Wconversion -Wstrict-prototypes -Wold-style-definition \
+	-Wpacked -Wnested-externs -Winline -Wvolatile-register-var
+#	-Wunreachable-code
 #DEBUG=-ggdb3
-# For info about _FORTIFY_SOURCE, see feature_test_macros(7)
+# For info about _FORTIFY_SOURCE, see
+# <http://www.kernel.org/doc/man-pages/online/pages/man7/feature_test_macros.7.html>
 # and <http://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>.
 FORTIFY=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC
 LINK_FORTIFY_LD=-z relro -z now
@@ -23,10 +20,10 @@
 LINK_FORTIFY += -pie
 endif
 #COVERAGE=--coverage
-OPTIMIZE=-Os -fno-strict-aliasing
+OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.6.7
+version=1.5.5
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
@@ -39,7 +36,6 @@
 # MANDIR=$(PREFIX)/man
 # INITRAMFSTOOLS=$(DESTDIR)/etc/initramfs-tools
 # STATEDIR=$(DESTDIR)/var/lib/mandos
-# LIBDIR=$(PREFIX)/lib
 ##
 
 ## These settings are for a package-type install
@@ -49,19 +45,8 @@
 MANDIR=$(PREFIX)/share/man
 INITRAMFSTOOLS=$(DESTDIR)/usr/share/initramfs-tools
 STATEDIR=$(DESTDIR)/var/lib/mandos
-LIBDIR=$(shell \
-	for d in \
-	"/usr/lib/`dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null`" \
-	"`rpm --eval='%{_libdir}' 2>/dev/null`" /usr/lib; do \
-		if [ -d "$$d" -a "$$d" = "$${d%/}" ]; then \
-			echo "$(DESTDIR)$$d"; \
-			break; \
-		fi; \
-	done)
 ##
 
-SYSTEMD=$(DESTDIR)$(shell pkg-config systemd --variable=systemdsystemunitdir)
-
 GNUTLS_CFLAGS=$(shell pkg-config --cflags-only-I gnutls)
 GNUTLS_LIBS=$(shell pkg-config --libs gnutls)
 AVAHI_CFLAGS=$(shell pkg-config --cflags-only-I avahi-core)
@@ -71,10 +56,10 @@
 	getconf LFS_LDFLAGS)
 
 # Do not change these two
-CFLAGS+=$(WARN) $(DEBUG) $(FORTIFY) $(COVERAGE) $(OPTIMIZE) \
+CFLAGS=$(WARN) $(DEBUG) $(FORTIFY) $(COVERAGE) $(OPTIMIZE) \
 	$(LANGUAGE) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) $(GPGME_CFLAGS) \
 	-DVERSION='"$(version)"'
-LDFLAGS+=-Xlinker --as-needed $(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))
+LDFLAGS=-Xlinker --as-needed $(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))
 
 # Commands to format a DocBook <refentry> document into a manual page
 DOCBOOKTOMAN=$(strip cd $(dir $<); xsltproc --nonet --xinclude \
@@ -85,10 +70,13 @@
 	--param man.authors.section.enabled	0 \
 	/usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
 	$(notdir $<); \
+	$(MANPOST) $(notdir $@);\
 	if locale --all 2>/dev/null | grep --regexp='^en_US\.utf8$$' \
 	&& type man 2>/dev/null; then LANG=en_US.UTF-8 MANWIDTH=80 \
 	man --warnings --encoding=UTF-8 --local-file $(notdir $@); \
 	fi >/dev/null)
+# DocBook-to-man post-processing to fix a '\n' escape bug
+MANPOST=$(SED) --in-place --expression='s,\\\\en,\\en,g;s,\\n,\\en,g'
 
 DOCBOOKTOHTML=$(strip xsltproc --nonet --xinclude \
 	--param make.year.ranges		1 \
@@ -239,11 +227,9 @@
 	$(LINK.c) $^ -lrt $(GNUTLS_LIBS) $(AVAHI_LIBS) $(strip\
 		) $(GPGME_LIBS) $(LOADLIBES) $(LDLIBS) -o $@
 
-.PHONY : all doc html clean distclean mostlyclean maintainer-clean \
-	check run-client run-server install install-html \
-	install-server install-client-nokey install-client uninstall \
-	uninstall-server uninstall-client purge purge-server \
-	purge-client
+.PHONY : all doc html clean distclean run-client run-server install \
+	install-server install-client uninstall uninstall-server \
+	uninstall-client purge purge-server purge-client
 
 clean:
 	-rm --force $(CPROGS) $(objects) $(htmldocs) $(DOCS) core
@@ -255,7 +241,6 @@
 
 check:	all
 	./mandos --check
-	./mandos-ctl --check
 
 # Run the client with a local config and key
 run-client: all keydir/seckey.txt keydir/pubkey.txt
@@ -264,18 +249,15 @@
 	@echo "# ignored.  The messages are caused by not running as root, but   #"
 	@echo "# you should NOT run \"make run-client\" as root unless you also    #"
 	@echo "# unpacked and compiled Mandos as root, which is NOT recommended. #"
-	@echo "# From plugin-runner: setgid: Operation not permitted             #"
-	@echo "#                     setuid: Operation not permitted             #"
+	@echo "# From plugin-runner: setuid: Operation not permitted             #"
 	@echo "# From askpass-fifo:  mkfifo: Permission denied                   #"
-	@echo "# From mandos-client:                                             #"
-	@echo "#             Failed to raise privileges: Operation not permitted #"
-	@echo "#             Warning: network hook \"*\" exited with status *      #"
+	@echo "# From mandos-client: setuid: Operation not permitted             #"
+	@echo "#                     seteuid: Operation not permitted            #"
+	@echo "#                     klogctl: Operation not permitted            #"
 	@echo "###################################################################"
-# We set GNOME_KEYRING_CONTROL to block pam_gnome_keyring
 	./plugin-runner --plugin-dir=plugins.d \
 		--config-file=plugin-runner.conf \
 		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt,--network-hook-dir=network-hooks.d \
-		--env-for=mandos-client:GNOME_KEYRING_CONTROL= \
 		$(CLIENTARGS)
 
 # Used by run-client
@@ -296,7 +278,7 @@
 	install --directory confdir
 	install --mode=u=rw $< $@
 # Add a client password
-	./mandos-keygen --dir keydir --password --no-ssh >> $@
+	./mandos-keygen --dir keydir --password >> $@
 statedir:
 	install --directory statedir
 
@@ -309,12 +291,8 @@
 
 install-server: doc
 	install --directory $(CONFDIR)
-	if install --directory --mode=u=rwx --owner=$(USER) \
-		--group=$(GROUP) $(STATEDIR); then \
-		:; \
-	elif install --directory --mode=u=rwx $(STATEDIR); then \
-		chown -- $(USER):$(GROUP) $(STATEDIR) || :; \
-	fi
+	install --directory --mode=u=rwx --owner=$(USER) \
+		--group=$(GROUP) $(STATEDIR)
 	install --mode=u=rwx,go=rx mandos $(PREFIX)/sbin/mandos
 	install --mode=u=rwx,go=rx --target-directory=$(PREFIX)/sbin \
 		mandos-ctl
@@ -328,9 +306,6 @@
 		$(DESTDIR)/etc/dbus-1/system.d/mandos.conf
 	install --mode=u=rwx,go=rx init.d-mandos \
 		$(DESTDIR)/etc/init.d/mandos
-	if [ "$(SYSTEMD)" != "$(DESTDIR)" -a -d "$(SYSTEMD)" ]; then \
-		install --mode=u=rw,go=r mandos.service $(SYSTEMD); \
-	fi
 	install --mode=u=rw,go=r default-mandos \
 		$(DESTDIR)/etc/default/mandos
 	if [ -z $(DESTDIR) ]; then \
@@ -350,36 +325,36 @@
 		> $(MANDIR)/man8/intro.8mandos.gz
 
 install-client-nokey: all doc
-	install --directory $(LIBDIR)/mandos $(CONFDIR)
+	install --directory $(PREFIX)/lib/mandos $(CONFDIR)
 	install --directory --mode=u=rwx $(KEYDIR) \
-		$(LIBDIR)/mandos/plugins.d
-	if [ "$(CONFDIR)" != "$(LIBDIR)/mandos" ]; then \
+		$(PREFIX)/lib/mandos/plugins.d
+	if [ "$(CONFDIR)" != "$(PREFIX)/lib/mandos" ]; then \
 		install --mode=u=rwx \
 			--directory "$(CONFDIR)/plugins.d"; \
 	fi
 	install --mode=u=rwx,go=rx --directory \
 		"$(CONFDIR)/network-hooks.d"
 	install --mode=u=rwx,go=rx \
-		--target-directory=$(LIBDIR)/mandos plugin-runner
+		--target-directory=$(PREFIX)/lib/mandos plugin-runner
 	install --mode=u=rwx,go=rx --target-directory=$(PREFIX)/sbin \
 		mandos-keygen
 	install --mode=u=rwx,go=rx \
-		--target-directory=$(LIBDIR)/mandos/plugins.d \
+		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
 		plugins.d/password-prompt
 	install --mode=u=rwxs,go=rx \
-		--target-directory=$(LIBDIR)/mandos/plugins.d \
+		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
 		plugins.d/mandos-client
 	install --mode=u=rwxs,go=rx \
-		--target-directory=$(LIBDIR)/mandos/plugins.d \
+		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
 		plugins.d/usplash
 	install --mode=u=rwxs,go=rx \
-		--target-directory=$(LIBDIR)/mandos/plugins.d \
+		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
 		plugins.d/splashy
 	install --mode=u=rwxs,go=rx \
-		--target-directory=$(LIBDIR)/mandos/plugins.d \
+		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
 		plugins.d/askpass-fifo
 	install --mode=u=rwxs,go=rx \
-		--target-directory=$(LIBDIR)/mandos/plugins.d \
+		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
 		plugins.d/plymouth
 	install initramfs-tools-hook \
 		$(INITRAMFSTOOLS)/hooks/mandos
@@ -431,13 +406,13 @@
 	! grep --regexp='^ *[^ #].*keyscript=[^,=]*/mandos/' \
 		$(DESTDIR)/etc/crypttab
 	-rm --force $(PREFIX)/sbin/mandos-keygen \
-		$(LIBDIR)/mandos/plugin-runner \
-		$(LIBDIR)/mandos/plugins.d/password-prompt \
-		$(LIBDIR)/mandos/plugins.d/mandos-client \
-		$(LIBDIR)/mandos/plugins.d/usplash \
-		$(LIBDIR)/mandos/plugins.d/splashy \
-		$(LIBDIR)/mandos/plugins.d/askpass-fifo \
-		$(LIBDIR)/mandos/plugins.d/plymouth \
+		$(PREFIX)/lib/mandos/plugin-runner \
+		$(PREFIX)/lib/mandos/plugins.d/password-prompt \
+		$(PREFIX)/lib/mandos/plugins.d/mandos-client \
+		$(PREFIX)/lib/mandos/plugins.d/usplash \
+		$(PREFIX)/lib/mandos/plugins.d/splashy \
+		$(PREFIX)/lib/mandos/plugins.d/askpass-fifo \
+		$(PREFIX)/lib/mandos/plugins.d/plymouth \
 		$(INITRAMFSTOOLS)/hooks/mandos \
 		$(INITRAMFSTOOLS)/conf-hooks.d/mandos \
 		$(INITRAMFSTOOLS)/scripts/init-premount/mandos \
@@ -449,8 +424,8 @@
 		$(MANDIR)/man8/splashy.8mandos.gz \
 		$(MANDIR)/man8/askpass-fifo.8mandos.gz \
 		$(MANDIR)/man8/plymouth.8mandos.gz \
-	-rmdir $(LIBDIR)/mandos/plugins.d $(CONFDIR)/plugins.d \
-		 $(LIBDIR)/mandos $(CONFDIR) $(KEYDIR)
+	-rmdir $(PREFIX)/lib/mandos/plugins.d $(CONFDIR)/plugins.d \
+		 $(PREFIX)/lib/mandos $(CONFDIR) $(KEYDIR)
 	update-initramfs -k all -u
 
 purge: purge-server purge-client
@@ -460,8 +435,6 @@
 		$(DESTDIR)/etc/dbus-1/system.d/mandos.conf
 		$(DESTDIR)/etc/default/mandos \
 		$(DESTDIR)/etc/init.d/mandos \
-		$(SYSTEMD)/mandos.service \
-		$(DESTDIR)/run/mandos.pid \
 		$(DESTDIR)/var/run/mandos.pid
 	-rmdir $(CONFDIR)
 

=== modified file 'NEWS'
--- NEWS	2014-07-17 03:24:57 +0000
+++ NEWS	2012-06-01 18:39:03 +0000
@@ -1,86 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.6.7 (2014-07-17)
-* Client
-** Bug fix: Now compatible with GPGME 1.5.0.
-** Bug fix: Fixed minor memory leaks.
-* Server
-** "mandos-monitor" now has verbose logging, toggleable with "v".
-
-Version 1.6.6 (2014-07-13)
-* Client
-** If client host has an SSH server, "mandos-keygen --password" now
-   outputs "checker" option which uses "ssh-keyscan"; this is more
-   secure than the default "fping" checker.
-** Bug fix: allow "." in network hook names, to match documentation.
-** Better error messages.
-* Server
-** New --no-zeroconf option.
-** Bug fix: Fix --servicename option, broken since 1.6.4.
-** Bug fix: Fix --socket option work for --socket=0.
-
-Version 1.6.5 (2014-05-11)
-* Client
-** Work around bug in GnuPG <http://bugs.g10code.com/gnupg/issue1622>
-** Give better error messages when run without sufficient privileges
-** Only warn if workaround for Debian bug #633582 was necessary and
-   failed, not if it failed and was unnecessary.
-
-Version 1.6.4 (2014-02-16)
-* Server
-** Very minor fix to self-test code.
-
-Version 1.6.3 (2014-01-21)
-* Server
-** Add systemd support.
-** For PID file, fall back to /var/run if /run does not exist.
-* Client
-** Moved files from /usr/lib/mandos to whatever the architecture
-   specifies, like /usr/lib/x86_64-linux-gnu/mandos or
-   /usr/lib64/mandos.
-
-Version 1.6.2 (2013-10-24)
-* Server
-** PID file moved from /var/run to /run.
-** Bug fix: Handle long secrets when saving client state.
-** Bug fix: Use more magic in the GnuTLS priority string to handle
-   both old DSA/ELG 2048-bit keys and new RSA/RSA 4096-bit keys.
-* Client
-** mandos-keygen: Bug fix: now generate RSA keys which GnuTLS can use.
-   		  Bug fix: Output passphrase prompts even when
-   		  redirecting standard output.
-
-Version 1.6.1 (2013-10-13)
-* Server
-** All client options for time intervals now also take an RFC 3339
-   duration.  The same for all options to mandos-ctl.
-** Bug fix: Handle fast checkers (like ":") correctly.
-** Bug fix: Don't print output from checkers when running in
-   foreground.
-** Bug fix: Do not fail when client is removed from clients.conf but
-   saved settings remain.
-** Bug fix: mandos-monitor now displays standout (reverse video) again
-   using new version of Urwid.
-** Bug fix: Make boolean options work from the config file again.
-** Bug fix: Make --no-ipv6 work again.
-** New default priority string to be slightly more compatible with
-   older versions of GnuTLS.
-* Client
-** Bug fix: Fix bashism in mandos-keygen.
-** Default key and subkey types are now RSA and RSA, respectively.
-   Also, new default key size is 4096 bits.
-
-Version 1.6.0 (2012-06-18)
-* Server
-** Takes new --foreground option
-** Init script supports new "status" action.
-* Client
-** Now uses all interfaces by default; the --interface option can
-   still be used to restrict it, and the argument to --interface (as
-   well as the $DEVICE environment variable for the network hooks) is
-   now a comma-separated list of interfaces to use.
-
 Version 1.5.5 (2012-06-01)
 * Server
 ** Server takes new --socket option

=== modified file 'TODO'
--- TODO	2014-07-14 21:41:08 +0000
+++ TODO	2012-06-17 14:55:31 +0000
@@ -1,27 +1,15 @@
 -*- org -*-
 
-* GIT
-** General: [[https://www.atlassian.com/git/workflows][Git Workflows]], [[http://gitimmersion.com/][Git Immersion]], [[https://news.ycombinator.com/item?id=7036628][Simple git workflow is simple]]
-** Intro: [[http://www.eyrie.org/~eagle/notes/debian/git.html#combine][Using Git for Debian Packaging]]
-** Use: [[https://honk.sigxcpu.org/piki/projects/git-buildpackage/][git-buildpackage]]
-** Migration
-   tailor?
-   Using bzr-fastimport: [[http://www.fusonic.net/en/blog/2013/03/26/migrating-from-bazaar-to-git/][Migrating from Bazaar to Git]]
-** Unresolved: [[http://jameswestby.net/bzr/builddeb/user_manual/split.html][bzr builddeb split mode]]
-   Maybe: [[http://honk.sigxcpu.org/projects/git-buildpackage/manual-html/gbp.import.html#GBP.IMPORT.UPSTREAM.GIT.NOTARBALL][git-buildpackage - No upstream tarballs]]
-   [[http://www.python.org/dev/peps/pep-0374/][PEP 374 - Choosing a distributed VCS for the Python project]]
-   [[http://www.emacswiki.org/emacs/GitForEmacsDevs][Git For Emacs Devs]]
-
 * [[http://www.undeadly.org/cgi?action=article&sid=20110530221728][OpenBSD]]
 
-* Testing
-** python-nemu
-
 * mandos-applet
 
 * mandos-client
 ** TODO [#B] Use capabilities instead of seteuid().
+** TODO [#B] Use struct sockaddr_storage instead of a union
 ** TODO [#B] Use getaddrinfo(hints=AI_NUMERICHOST) instead of inet_pton()
+** TODO [#B] Use getnameinfo(serv=NULL, NI_NUMERICHOST) instead of inet_ntop()
+** TODO [#B] Prefer /run/tmp over /tmp, if it exists
 ** TODO [#C] Make start_mandos_communication() take "struct server".
 
 * splashy
@@ -44,8 +32,10 @@
 * plugin-runner
 ** TODO handle printing for errors for plugins
 *** Hook up stderr of plugins, buffer them, and prepend "Mandos Plugin [plugin name]"
+** TODO [#B] use scandir(3) instead of readdir(3)
 ** TODO [#C] use same file name rules as run-parts(8)
 ** kernel command line option for debug info
+** TODO [#B] Use openat()
 
 * mandos (server)
 ** TODO [#B] Log level							  :BUGS:
@@ -57,10 +47,14 @@
 ** TODO [#C] DBusServiceObjectUsingSuper
 ** TODO [#B] Global enable/disable flag
 ** TODO [#B] By-client countdown on number of secrets given
+** TODO [#B] Support RFC 3339 time duration syntax
 ** D-Bus Client method NeedsPassword(50) - Timeout, default disapprove
     + SetPass(u"gazonk", True) -> Approval, persistent
     + Approve(False) -> Close client connection immediately
 ** TODO [#C] python-parsedatetime
+** TODO [#C] systemd/launchd
+   http://0pointer.de/blog/projects/systemd.html
+   http://wiki.debian.org/systemd
 ** TODO Separate logging logic to own object
 ** TODO [#A] Limit approval_delay to max gnutls/tls timeout value
 ** TODO [#B] break the wait on approval_delay if connection dies
@@ -68,24 +62,17 @@
 ** TODO Allow %%(checker)s as a runtime expansion
 ** TODO Use python-tlslite?
 ** TODO D-Bus AddClient() method on server object
-** TODO Use org.freedesktop.DBus.Method.NoReply annotation on async methods. :2:
-** TODO Emit [[http://dbus.freedesktop.org/doc/dbus-specification.html#standard-interfaces-properties][org.freedesktop.DBus.Properties.PropertiesChanged]] signal	  :2:
+** TODO Use org.freedesktop.DBus.Method.NoReply annotation on async methods.
+** TODO Emit [[http://dbus.freedesktop.org/doc/dbus-specification.html#standard-interfaces-properties][org.freedesktop.DBus.Properties.PropertiesChanged]] signal
    TODO Deprecate se.recompile.Mandos.Client.PropertyChanged - annotate!
    TODO Can use "invalidates" annotation to also emit on changed secret.
-** TODO Support [[http://dbus.freedesktop.org/doc/dbus-specification.html#standard-interfaces-objectmanager][org.freedesktop.DBus.ObjectManager]] interface on server object :2:
+** TODO Support [[http://dbus.freedesktop.org/doc/dbus-specification.html#standard-interfaces-objectmanager][org.freedesktop.DBus.ObjectManager]] interface on server object
    Deprecate methods GetAllClients(), GetAllClientsWithProperties()
    and signals ClientAdded and ClientRemoved.
 ** TODO Save state periodically to recover better from hard shutdowns
 ** TODO CheckerCompleted method, deprecate CheckedOK
 ** TODO Secret Service API?
    http://standards.freedesktop.org/secret-service/
-** TODO Remove D-Bus interfaces with old domain name			  :2:
-** TODO Remove old string_to_delta format				  :2:
-** TODO http://0pointer.de/blog/projects/stateless.html
-*** tmpfiles snippet to create /var/lib/mandos with right user+perms
-*** File in /usr/lib/sysusers.d to create user+group "_mandos"
-** TODO Error handling on error parsing config files
-** TODO init.d script error handling
 
 * mandos.xml
 ** Add mandos contact info in manual pages
@@ -93,7 +80,7 @@
 * mandos-ctl
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
 *** [#B] --dump option
-** TODO Remove old string_to_delta format				  :2:
+** TODO Support RFC 3339 time duration syntax
 
 * TODO mandos-dispatch
   Listens for specified D-Bus signals and spawns shell commands with
@@ -105,7 +92,7 @@
    Better view of client data in the listing
 *** Properties popup
 ** Print a nice "We are sorry" message, save stack trace to log.
-** Rename module "gobject" to "GObject".
+** Show timeout countdown for approval
 
 * mandos-keygen
 ** TODO "--secfile" option
@@ -113,6 +100,10 @@
 ** TODO [#B] "--test" option
    For testing decryption before rebooting.
 
+* Makefile
+** TODO [#C] Implement DEB_BUILD_OPTIONS
+   http://www.debian.org/doc/debian-policy/ch-source.html#s-debianrules-options
+
 * Package
 ** /usr/share/initramfs-tools/hooks/mandos
 *** TODO [#C] use same file name rules as run-parts(8)

=== modified file 'clients.conf'
--- clients.conf	2012-06-23 00:58:49 +0000
+++ clients.conf	2011-11-26 23:08:17 +0000
@@ -4,19 +4,19 @@
 
 # How long until a client is disabled and not be allowed to get the
 # data this server holds.
-;timeout = PT5M
+;timeout = 5m
 
 # How often to run the checker to confirm that a client is still up.
 # Note: a new checker will not be started if an old one is still
 # running.  The server will wait for a checker to complete until the
 # above "timeout" occurs, at which time the client will be disabled,
 # and any running checker killed.
-;interval = PT2M
+;interval = 2m
 
 # Extended timeout is an added timeout that is given once after a
 # password has been sent sucessfully to a client.  This allows for
 # additional delays caused by file system checks and quota checks.
-;extended_timeout = PT15M
+;extended_timeout = 15m
 
 # What command to run as "the checker".
 ;checker = fping -q -- %%(host)s
@@ -25,10 +25,10 @@
 ;approved_by_default = True
 
 # How long to wait for approval.
-;approval_delay = PT0S
+;approval_delay = 0s
 
 # How long one approval will last.
-;approval_duration = PT1S
+;approval_duration = 1s
 
 # Whether this client is enabled by default
 ;enabled = True
@@ -78,10 +78,10 @@
 ;host = 192.0.2.3
 ;
 ;# Parameters from the [DEFAULT] section can be overridden per client.
-;interval = PT1M
+;interval = 1m
 ;
 ;# This client requires manual approval before it receives its secret.
 ;approved_by_default = False
 ;# Require approval within 30 seconds.
-;approval_delay = PT30S
+;approval_delay = 30s
 ;####

=== modified file 'common.ent'
--- common.ent	2014-07-17 03:24:57 +0000
+++ common.ent	2012-06-01 18:39:03 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.6.7">
+<!ENTITY version "1.5.5">

=== modified file 'debian/changelog'
--- debian/changelog	2014-07-17 03:24:57 +0000
+++ debian/changelog	2012-06-01 18:39:03 +0000
@@ -1,124 +1,3 @@
-mandos (1.6.7-1) unstable; urgency=medium
-
-  * New upstream release.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Thu, 17 Jul 2014 05:22:45 +0200
-
-mandos (1.6.6-1) unstable; urgency=medium
-
-  * New upstream release.
-  * debian/mandos.postinst: Fix typo in comment.
-  * debian/control (mandos/Recommends): Changed to "ssh-client | fping".
-    (mandos-client/Recommends): New; set to "ssh".
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 13 Jul 2014 22:49:21 +0200
-
-mandos (1.6.5-3) unstable; urgency=medium
-
-  * debian/control (mandos-client/Depends): Add "dpkg-dev (>=1.16.0)";
-    initramfs-tools-hook runs "dpkg-architecture -qDEB_HOST_MULTIARCH".
-    (Closes: #750221)
-
- -- Teddy Hogeborn <teddy@recompile.se>  Fri, 06 Jun 2014 04:27:15 +0200
-
-mandos (1.6.5-2) unstable; urgency=medium
-
-  * debian/rules (override_dh_auto_test-arch): New; does nothing.  Fixes
-    FTBFS for build-indep.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Tue, 13 May 2014 08:08:31 +0200
-
-mandos (1.6.5-1) unstable; urgency=medium
-
-  * New upstream release.
-  * debian/copyright: Change year to "2014".
-  * debian/control (Build-Depends, Build-Depends-Indep): Moved build
-    dependencies of "mandos" package to "Build-Depends-Indep".
-  * debian/upstream/signing-key.asc: New; upstream source public key.
-  * debian/control (Standards-Version): Updated to "3.9.5".
-  * debian/control (mandos/Depends): Remove the dependency on
-    "avahi-daemon (>= 0.6.31-3) | systemd-sysv".  It is unnecessary
-    since we have a workaround in debian/mandos.postinst anyway.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 11 May 2014 22:16:33 +0200
-
-mandos (1.6.4-1) unstable; urgency=medium
-
-  * New upstream release.
-  * debian/control (Build-Depends): Add Python dependencies to
-                                    successfully run self-tests.
-  * debian/copyright: GPLv3 now has its own license file - use it.
-  * debian/watch: Set PGP signature URL.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 16 Feb 2014 14:09:25 +0100
-
-mandos (1.6.3-1) unstable; urgency=low
-
-  * New upstream release.
-  * debian/control (Build-Depends): Added "systemd".
-  * debian/mandos.dirs (lib/systemd/system): New.
-  * debian/mandos-client.README.Debian: Refer to architecture libdir.
-  * debian/control (mandos/Depends): Add "avahi-daemon (>= 0.6.31-3) |
-                                     systemd-sysv".
-  * debian/mandos.postinst: If avahi-daemon is version 0.6.31-2 or older,
-                            edit /etc/init.d script headers Required-Start
-                            and Required-Stop to have "avahi" instead of
-                            "avahi-daemon", before insserv(8) sees it.
-  * debian/mandos-client.lintian-overrides: Libdir changes.
-  * debian/rules (override_dh_fixperms): - '' -
-
- -- Teddy Hogeborn <teddy@recompile.se>  Tue, 21 Jan 2014 22:01:30 +0100
-
-mandos (1.6.2-1) unstable; urgency=low
-
-  * New upstream release.
-  * debian/compat: Changed to "9".
-  * debian/control (Build-Depends): Changed debhelper version to (>= 9).
-    (Standards-Version): Updated to "3.9.4".
-    (DM-Upload-Allowed): Removed.
-    (mandos/Depends): Add "initscripts (>= 2.88dsf-13.3)" to be able to
-                      use the "/run" directory (for mandos.pid).
-  * debian/copyright (Copyright): Update year.
-  * Fix "Mandos/gnutls fails to establish connection, "an algorithm that
-    is not enabled was negotiated"" fixed by upstream. (Closes: #702120)
-
- -- Teddy Hogeborn <teddy@recompile.se>  Thu, 24 Oct 2013 22:33:40 +0200
-
-mandos (1.6.1-1) unstable; urgency=low
-
-  * New upstream release.
-  * debian/control (mandos/Depends): No longer depends on
-                                     python-gnupginterface, but does
-                                     depend on gnupg (<< 2).
-    (Build-Depends): Depend on debhelper 8.9.7 for using "override-*-arch"
-                     and "override-*-indep" targets in debian/rules.
-  * debian/mandos-client.README: Update Linux documentation link.
-  * debian/rules: Completely rewritten to use debhelper v7.
-  * initramfs-tools-hook: Bug fix: Make sure the right version of GnuPG is
-    copied into the initramfs image.  Always assume that GPGME is used to
-    avoid searching for it since the path might not be /usr/lib.  Thanks
-    to Félix Sipma <felix+debian@gueux.org> for the initial bug report,
-    and also thanks to Dick Middleton <dick@lingbrae.com> for some more
-    debugging. (Closes:  #721903)
-  * Fix "bashism in /bin/sh script" fixed by upstream. (Closes: #690639)
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 13 Oct 2013 19:03:23 +0200
-
-mandos (1.6.0-1) unstable; urgency=low
-
-  * New upstream release.
-  * debian/copyright (Copyright): Join the two lines to a single line.
-  * debian/mandos-client.README.Debian: Update to refer to the new
-    location of the example network hooks, and the new feature of using
-    all network interfaces.
-  * debian/mandos-client.docs (network-hooks.d): Removed.
-  * debian/mandos-client.examples (network-hooks.d): New.
-  * debian/rules (binary-common): Added "dh_installexamples".
-    (binary-common/dh_fixperms): Exclude new location of
-    "network-hooks.d".
-
- -- Teddy Hogeborn <teddy@recompile.se>  Mon, 18 Jun 2012 00:15:23 +0200
-
 mandos (1.5.5-1) unstable; urgency=low
 
   * New upstream release.

=== modified file 'debian/compat'
--- debian/compat	2013-10-20 15:25:09 +0000
+++ debian/compat	2008-09-17 00:34:09 +0000
@@ -1,1 +1,1 @@
-9
+7

=== modified file 'debian/control'
--- debian/control	2014-07-25 22:44:20 +0000
+++ debian/control	2012-05-24 18:10:10 +0000
@@ -4,24 +4,22 @@
 Maintainer: Mandos Maintainers <mandos@recompile.se>
 Uploaders: Teddy Hogeborn <teddy@recompile.se>,
 	   Björn Påhlsson <belorn@recompile.se>
-Build-Depends: debhelper (>= 9), docbook-xml, docbook-xsl,
+Build-Depends: debhelper (>= 7), docbook-xml, docbook-xsl,
 	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc,
 	pkg-config
-Build-Depends-Indep: systemd, python2.7, python2.7-gnutls,
-	python2.7-dbus, python2.7-avahi, python2.7-gobject
-Standards-Version: 3.9.5
+Standards-Version: 3.9.3
 Vcs-Bzr: http://ftp.recompile.se/pub/mandos/trunk
 Vcs-Browser: http://bzr.recompile.se/loggerhead/mandos/trunk/files
 Homepage: http://www.recompile.se/mandos
+DM-Upload-Allowed: yes
 
 Package: mandos
 Architecture: all
-Depends: ${misc:Depends}, python (<= 2.7), python2.7, python-gnutls,
-	python2.7-gnutls, python-dbus, python2.7-dbus, python-avahi,
-	python2.7-avahi, python-gobject, python2.7-gobject,
-	avahi-daemon, adduser, python-urwid, python2.7-urwid,
-	gnupg (<< 2), initscripts (>= 2.88dsf-13.3)
-Recommends: ssh-client | fping
+Depends: ${misc:Depends}, python (>=2.6), python-gnutls, python-dbus,
+	python-avahi, python-gobject, avahi-daemon, adduser,
+	python-urwid, python (>=2.7) | python-argparse,
+	python-gnupginterface
+Recommends: fping
 Description: server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows
  computers to have encrypted root file systems and at the
@@ -40,8 +38,7 @@
 Package: mandos-client
 Architecture: linux-any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
-	gnupg (<< 2), initramfs-tools, dpkg-dev (>=1.16.0)
-Recommends: ssh
+	gnupg (<< 2), initramfs-tools
 Breaks: dropbear (<= 0.53.1-1)
 Enhances: cryptsetup
 Description: do unattended reboots with an encrypted root file system

=== modified file 'debian/copyright'
--- debian/copyright	2014-03-01 09:39:25 +0000
+++ debian/copyright	2012-06-01 21:48:12 +0000
@@ -4,8 +4,8 @@
 Source: <http://www.recompile.se/mandos>
 
 Files: *
-Copyright: Copyright © 2008-2014 Teddy Hogeborn
-	   Copyright © 2008-2014 Björn Påhlsson
+Copyright: Copyright © 2008-2012 Teddy Hogeborn
+	   Copyright © 2008-2012 Björn Påhlsson
 License: GPL-3+
     This program is free software: you can redistribute it and/or
     modify it under the terms of the GNU General Public License as
@@ -22,4 +22,4 @@
     <http://www.gnu.org/licenses/>.
     .
     On Debian systems, the complete text of the GNU General Public
-    License can be found in "/usr/share/common-licenses/GPL-3".
+    License can be found in "/usr/share/common-licenses/GPL".

=== modified file 'debian/mandos-client.README.Debian'
--- debian/mandos-client.README.Debian	2013-10-28 10:04:05 +0000
+++ debian/mandos-client.README.Debian	2012-06-16 19:30:08 +0000
@@ -16,8 +16,7 @@
   is possible to verify that the correct password will be received by
   this client by running the command, on the client:
   
-	/usr/lib/$(dpkg-architecture -qDEB_HOST_MULTIARCH \
-	)/mandos/plugins.d/mandos-client \
+	/usr/lib/mandos/plugins.d/mandos-client \
 		--pubkey=/etc/keys/mandos/pubkey.txt \
 		--seckey=/etc/keys/mandos/seckey.txt; echo
   
@@ -46,7 +45,7 @@
   The device can also be overridden at boot time on the Linux kernel
   command line using the sixth colon-separated field of the "ip="
   option; for exact syntax, read the documentation in the file
-  "/usr/share/doc/linux-doc-*/Documentation/filesystems/nfs/nfsroot.txt",
+  "/usr/share/doc/linux-doc-*/Documentation/filesystems/nfsroot.txt",
   available in the "linux-doc-*" package.
   
   Note that since the network interfaces are used in the initial RAM
@@ -91,4 +90,4 @@
   work, "--options-for=mandos-client:--connect=<ADDRESS>:<PORT>" needs
   to be manually added to the file "/etc/mandos/plugin-runner.conf".
 
- -- Teddy Hogeborn <teddy@recompile.se>, Mon, 28 Oct 2013 11:02:26 +0100
+ -- Teddy Hogeborn <teddy@recompile.se>, Sat, 16 Jun 2012 13:09:58 +0200

=== modified file 'debian/mandos-client.lintian-overrides'
--- debian/mandos-client.lintian-overrides	2014-01-20 21:50:11 +0000
+++ debian/mandos-client.lintian-overrides	2010-10-13 06:12:52 +0000
@@ -2,12 +2,12 @@
 #
 mandos-client binary: non-standard-dir-perm etc/keys/mandos/ 0700 != 0755
 
-# The directory /usr/lib/<arch>/mandos/plugins.d contains setuid
-# binaries which are not meant to be run outside an initial RAM disk
+# The directory /usr/lib/mandos/plugins.d contains setuid binaries
+# which are not meant to be run outside an initial RAM disk
 # environment (except for test purposes).  It would be insecure to
 # allow anyone to run them.
 #
-mandos-client binary: non-standard-dir-perm usr/lib/*/mandos/plugins.d/ 0700 != 0755
+mandos-client binary: non-standard-dir-perm usr/lib/mandos/plugins.d/ 0700 != 0755
 
 # These binaries must be setuid root, since they need root powers, but
 # are started by plugin-runner(8mandos), which runs all plugins as
@@ -15,14 +15,14 @@
 # system, but in an initial RAM disk environment.  Here they are
 # protected from non-root access by the directory permissions, above.
 #
-mandos-client binary: setuid-binary usr/lib/*/mandos/plugins.d/mandos-client 4755 root/root
-mandos-client binary: setuid-binary usr/lib/*/mandos/plugins.d/askpass-fifo 4755 root/root
-mandos-client binary: setuid-binary usr/lib/*/mandos/plugins.d/splashy 4755 root/root
-mandos-client binary: setuid-binary usr/lib/*/mandos/plugins.d/usplash 4755 root/root
-mandos-client binary: setuid-binary usr/lib/*/mandos/plugins.d/plymouth 4755 root/root
+mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/mandos-client 4755 root/root
+mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/askpass-fifo 4755 root/root
+mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/splashy 4755 root/root
+mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/usplash 4755 root/root
+mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/plymouth 4755 root/root
 
 # The directory /etc/mandos/plugins.d can be used by local system
 # administrators to place plugins in, overriding and complementing
-# /usr/lib/<arch>/mandos/plugins.d, and must be likewise protected.
+# /usr/lib/mandos/plugins.d, and must be likewise protected.
 #
 mandos-client binary: non-standard-dir-perm etc/mandos/plugins.d/ 0700 != 0755

=== modified file 'debian/mandos.dirs'
--- debian/mandos.dirs	2013-10-27 17:42:23 +0000
+++ debian/mandos.dirs	2011-11-26 22:22:20 +0000
@@ -5,4 +5,3 @@
 etc/dbus-1/system.d
 usr/sbin
 var/lib/mandos
-lib/systemd/system

=== modified file 'debian/mandos.postinst'
--- debian/mandos.postinst	2014-06-07 20:29:36 +0000
+++ debian/mandos.postinst	2011-11-26 22:22:20 +0000
@@ -47,16 +47,6 @@
 	;;
 esac
 
-# Avahi version 0.6.31-2 and older provides "avahi" (instead of
-# "avahi-daemon") in its /etc/init.d script header.  To make
-# insserv(8) happy, we edit our /etc/init.d script header to contain
-# the correct string before the code added by dh_installinit calls
-# update.rc-d, which calls insserv.
-avahi_version="`dpkg-query --showformat='${Version}' --show avahi-daemon`"
-if dpkg --compare-versions "$avahi_version" le 0.6.31-2; then
-    sed --in-place --expression='/^### BEGIN INIT INFO$/,/^### END INIT INFO$/s/^\(# Required-\(Stop\|Start\):.*avahi\)-daemon\>/\1/g' /etc/init.d/mandos
-fi
-
 #DEBHELPER#
 
 exit 0

=== modified file 'debian/rules'
--- debian/rules	2014-05-12 21:02:38 +0000
+++ debian/rules	2012-06-01 21:48:12 +0000
@@ -1,31 +1,108 @@
 #!/usr/bin/make -f
-%:
-	dh $@
-
-override_dh_auto_build-arch:
+# Sample debian/rules that uses debhelper.
+#
+# This file was originally written by Joey Hess and Craig Small.
+# As a special exception, when this file is copied by dh-make into a
+# dh-make output file, you may use that output file without restriction.
+# This special exception was added by Craig Small in version 0.37 of dh-make.
+#
+# Modified to make a template file for a multi-binary package with separated
+# build-arch and build-indep targets  by Bill Allombert 2001
+
+# Uncomment this to turn on verbose mode.
+#export DH_VERBOSE=1
+
+# This has to be exported to make some magic below work.
+export DH_OPTIONS
+
+# -pie was broken briefly on the mips and mipsel architectures, see
+# <http://bugs.debian.org/526961>
+BINUTILS_V := $(shell dpkg-query --showformat='$${Version}' \
+			--show binutils)
+ifeq (yes,$(shell dpkg --compare-versions $(BINUTILS_V) lt 2.20-3 \
+		&& dpkg --compare-versions $(BINUTILS_V) ge 2.19.1-1 \
+		&& echo yes))
+  ifneq (,$(strip $(findstring :$(DEB_HOST_ARCH):,:mips:mipsel:) \
+		$(findstring :$(DEB_BUILD_ARCH):,:mips:mipsel:)))
+    BROKEN_PIE := yes
+    export BROKEN_PIE
+  endif
+endif
+
+configure: configure-stamp
+configure-stamp:
+	dh_testdir
+	touch configure-stamp
+
+build: build-arch build-indep
+
+build-arch: build-arch-stamp
+build-arch-stamp: configure-stamp
 	LC_ALL=en_US.utf8 dh_auto_build -- all doc
-
-override_dh_auto_build-indep:
-	LC_ALL=en_US.utf8 dh_auto_build -- doc
-
-override_dh_installinit-indep:
+	touch $@
+
+build-indep: build-indep-stamp
+build-indep-stamp: configure-stamp
+	LC_ALL=en_US.UTF-8 dh_auto_build -- doc
+	touch $@
+
+clean:
+	dh_testdir
+	dh_testroot
+	rm -f build-arch-stamp build-indep-stamp configure-stamp
+	dh_auto_clean
+	dh_clean
+
+install: install-indep install-arch
+install-indep:
+	dh_testdir
+	dh_testroot
+	dh_prep
+	dh_installdirs --indep
+	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos install-server
+	dh_lintian
 	dh_installinit --onlyscripts \
 		--update-rcd-params="defaults 25 15"
-
-override_dh_auto_install-indep:
-	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos install-server
-
-override_dh_auto_install-arch:
-	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos-client \
-		install-client-nokey
-
-override_dh_fixperms:
+	dh_install --indep
+
+install-arch:
+	dh_testdir
+	dh_testroot
+	dh_prep
+	dh_installdirs --same-arch
+	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos-client install-client-nokey
+	dh_lintian
+	dh_install --same-arch
+
+binary-common:
+	dh_testdir
+	dh_testroot
+	dh_installchangelogs
+	dh_installdocs
+	dh_installexamples
+	dh_link
+	dh_strip
+	dh_compress
 	dh_fixperms --exclude etc/keys/mandos \
 		--exclude etc/mandos/clients.conf \
 		--exclude etc/mandos/plugins.d \
-		--exclude usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null)/mandos/plugins.d \
+		--exclude usr/lib/mandos/plugins.d \
 		--exclude usr/share/doc/mandos-client/examples/network-hooks.d
-	chmod --recursive g-w -- \
-	"$(CURDIR)/debian/mandos-client/usr/share/doc/mandos-client/examples/network-hooks.d"
-
-override_dh_auto_test-arch: ;
+	dh_installdeb
+	dh_shlibdeps
+	dh_gencontrol
+	dh_md5sums
+	dh_builddeb
+
+# Build architecture independant packages using the common target.
+binary-indep: build-indep install-indep
+	$(MAKE) -f debian/rules DH_OPTIONS=--indep binary-common
+
+# Build architecture dependant packages using the common target.
+binary-arch: build-arch install-arch
+	$(MAKE) -f debian/rules DH_OPTIONS=--same-arch binary-common
+
+binary: binary-arch binary-indep
+
+.PHONY: build clean binary-indep binary-arch binary install \
+		install-indep install-arch configure

=== removed directory 'debian/upstream'
=== removed file 'debian/upstream/signing-key.asc'
--- debian/upstream/signing-key.asc	2014-03-28 22:32:21 +0000
+++ debian/upstream/signing-key.asc	1970-01-01 00:00:00 +0000
@@ -1,52 +0,0 @@
------BEGIN PGP PUBLIC KEY BLOCK-----
-Version: GnuPG v1.4.12 (GNU/Linux)
-
-mQINBFJQOFYBEACoWsEGlOxVWFUAxOxdd3GDLaqEKkKihJwLp102Ks7JKMd9friR
-7+OZuo3U0gdqLU9q1jPJn36J1QbaUTOvcaKtZp+QpUoYJ2OaGtlOY5ML8LSoC0rZ
-MIzGYTtvriwpU/YplLNGPl/90KsB2VqjrY1l1he5M8zziWDlPdJxwg8GFvmPWoif
-6oo+1iCswL5IdQ6c5MVO53zYu0cgyUSazLsVD5Xzy59lefgtaDydahJpPycf5aEQ
-DAoC9fZt2mgG3FLIUCZdXIhZdOJGCMdjLThBnJXYgGbG4rbGLNlI4W/uA5aqa4ME
-WYSAcCyX3ucKY/LkXRtC+z5s05e7tZ3Z+uAJy1eDsbhDXgZERye7a/zPWx1tAlzQ
-E80Oltjh1uXWjQORyx99a0jK87zjm49YjhYw1ZN6Z0HfSaws4Yj2QOzp9t4B3l7f
-DIUYoWBfHW7mseQeQ+t3TwQU5gjFCNu7oDeATqi5A5MksXN0+BcksterbGRBhEyp
-CybIEyrZE033jIs407Ool4Kv10cnjc8oy609BXex/dxwcvVr2vQHle4NPUZd+Xhg
-zC+9Z4jFwE0M/EPvtyieA/DWQse+TZ5itDGMYDub/GJfv1U61ANOgPIbTEF7iSa9
-5nWmq7zyUy/txmABka842Kt0Vp6ayoKcF8EIXCaDrVfPnXj+JlKf3c2u6wARAQAB
-tCxNYW5kb3MgTWFpbnRhaW5lciBUZWFtIDxtYW5kb3NAcmVjb21waWxlLnNlPokC
-PQQTAQgAJwUCUlA4VgIbAwUJCWYBgAULCQgHAwUVCgkICwUWAgMBAAIeAQIXgAAK
-CRByIylzyjTCxETXEACi56jCV9lJNSBbTp0Iet4X/i7Mx0Z8UkFFa3l7o0i4jFQj
-CIBrWECDlcxqZziii2dgh7L0ma93vB3rfjfCWeYLcEQw43MFBsd4dHuobrLXTcqU
-7n0Zmc8BsXwk5B25CnEYgvlbWX9BCYtxHGRcZzQrqOFjCMKatq0EIIVuWaz5yuCU
-V2rEgnr+veTd/rBOE9ez6Ju6xH11Teob5G7pMM0YPKHtZG/J3rvWPw4BDM6Tc60B
-G0sTDZNgkrGWxuB8YaLIwVWzliQK/17Jv/0alajyA3cWLWMkcK9Yhi/einzdMRoD
-IjnbtoHcSC9g6i0VGelwnMpHlFTwXriXEBSttULarK3iKE4tOv9nxMAEwicqlw14
-X96PPgz6ogtJG7FiwZfy1CQ81Uby+YuIhHZx3ZEyR1TFq70e98EgCuvjMZWMIhSy
-gB5Vssfq7c2lXQjltV3ujhK1PD+7/iHlL7t4QRxPDN8fbMS2VPfAdtnWS1K48d5J
-D/jP1LrGWS81HIaX8GFVLVw+jSQEu9cn3TFiZxK/4MMsITmlouJdtZWmQ/otMSMl
-wiCCZp3dGpRXMmaqR1N8V0nMKshM8mci7bD92ubd/t6cR/G6l+VIp45WyFONvtde
-F3ccfmfrKJuroMDfHxPxMf58EroAuWwzJKCPRH4JmwDvSSQoIIAGNL1lOKp6wrkC
-DQRSUDhWARAAzN7pbpAu7XLNPODotV/N+JaCFvNAIqTcr9PrbhxiKFCDs9/IExwP
-sGENL9GZd1DfoGEgxQ8j3l8VGw9VSeUoN7uMY2NwwbXTilAFkn/S8xnr2zQDRZ+n
-EeFSq9MMFxj4Kt1TqVYDbO8vmFfOT3gRCRHeJ+pn4yJeSPau/ndNrmbQ1/Z6vaUG
-yfo931ottx7SXZwkHA6jJVFT9rbHTyx9tzOqMKDJiMrx8qKaHpE9B45oHNR0WJJJ
-75zoDVuOZ6wAxXZuqBFu2lKPqDTZeawfzcu5qplrm1RPgSOjz6w1A41HBLqGe+v9
-7Twx5wfNMgnKC0V2wUe0xR6hQHQlyZoCwcGyrasiu+v/joZ1p66SSWKjs+LGjoe4
-Lwh6VjZU2x+irVBjcgIoRWf3k4JAef0nGYsm0cFjAnwXac+/CYxVt+7Y4+HG8wPB
-oUNZkW+bvdHQouxEClxnccIEgX/AkriJTYDQ4q3tkl2HVE/51R4pdQVLer2a5ov+
-Jwk44DdqzYstMsvqu+iD48hXzADg6HFvofkpct15h463pMaJf99uVVM9ZDNQ6B34
-l3tPX9ZDkIDl6n9dE2Jkaxx1yNVhPXpeMf4EzL+CEdUErVStB66lUkw+tNkuZyVT
-ZTQel9h0196+CNSiqAaL8+ZZdbjKKfzlcB4Qnd897XzMfsFQ7mzJ9QsAEQEAAYkC
-JQQYAQgADwUCUlA4VgIbDAUJCWYBgAAKCRByIylzyjTCxFmlEACBTOg5NqX63d8D
-mwk4smlFPppQBIduxZaMG9HsLcPi3VKTG9Zg6WI6rEdr/4MnoINsudLsEbrQLgRH
-2q1Zs+HqIIP5H2/sYHmswyokYB10zKB6gNUUg/GSlcAcrelsHVKx5B8kccWGT5gk
-Wo/X0BGMUTOvQ6lJ6YNo1idcQ2ZjsyfZoz3G8JS7/EXN//jAZf+017yj8WsAS7hw
-JRFMy7VET4g00JcBoNOAMP7PkozimZ2OwwsggJSYWkR1RaU2tKR1VmDF8R6UxuEd
-BJzwFmz+wNC1Kq+FoSaRNsrKEmzLnfV9unDnF2z7Lc4LqOysXdzOk9zTBPur0gd2
-Lh5H/g5rTAMQBARqXfvIwiTtrBGgil8JW8e4Bc0LQUuHAE7x9gMRil+OtkQrCRk9
-0LWXVS+K0tvvruE4EDtCGiS5046+BEI3aYsp4hNzjHADq0TJeCYjNg9kY0CjxcEq
-cfuMoUbQ0MkARGuBbykCdlylfTrkxrj/dPhr49lctY3H+Pj6F4fMDM4TP6UTGA8k
-993RRNYhkDWSxIp6G7RJpBZobHN+eHQ3r8A4tWdYb4Fvd2lvwEDjUFT9uD6WAff4
-8A1hM2uSy91UYBOPrIjqYdRFKJc9rThYdXH2T6SiRMYtZMrEKhqPffB/i9mqVBlD
-6vKRsaQikZujRdP9Dkf0mLmJ7LANWw==
-=9Noe
------END PGP PUBLIC KEY BLOCK-----

=== modified file 'debian/watch'
--- debian/watch	2014-02-16 02:42:42 +0000
+++ debian/watch	2011-10-05 16:00:56 +0000
@@ -1,3 +1,2 @@
 version=3
-opts=pgpsigurlmangle=s/$/.asc/ \
- ftp://ftp.recompile.se/pub/mandos/mandos[-_]([^\s]+?)(?:\.orig)?\.tar\.(?:gz|bz2|7z|xz)
+ftp://ftp.recompile.se/pub/mandos/mandos[-_]([^\s]+?)(?:\.orig)?\.tar\.(?:gz|bz2|7z|xz)

=== modified file 'init.d-mandos'
--- init.d-mandos	2014-01-06 15:56:54 +0000
+++ init.d-mandos	2012-06-01 21:48:12 +0000
@@ -1,12 +1,12 @@
 #! /bin/sh
 ### BEGIN INIT INFO
 # Provides:          mandos
-# Required-Start:    $remote_fs $syslog avahi-daemon
-# Required-Stop:     $remote_fs $syslog avahi-daemon
+# Required-Start:    $remote_fs $syslog avahi
+# Required-Stop:     $remote_fs $syslog avahi
 # Default-Start:     2 3 4 5
 # Default-Stop:      0 1 6
 # Short-Description: Mandos server
-# Description:       Server of encrypted passwords to Mandos clients
+# Description:       Gives encrypted passwords to Mandos clients
 ### END INIT INFO
 
 # Author: Teddy Hogeborn <teddy@recompile.se>
@@ -23,11 +23,7 @@
 NAME=mandos
 DAEMON=/usr/sbin/$NAME
 DAEMON_ARGS=""
-if [ -d /run/. ]; then
-    PIDFILE=/run/$NAME.pid
-else
-    PIDFILE=/var/run/$NAME.pid
-fi
+PIDFILE=/var/run/$NAME.pid
 SCRIPTNAME=/etc/init.d/$NAME
 
 # Exit if the package is not installed
@@ -44,8 +40,7 @@
 . /lib/init/vars.sh
 
 # Define LSB log_* functions.
-# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
-# and status_of_proc is working.
+# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
 . /lib/lsb/init-functions
 
 #
@@ -123,9 +118,6 @@
 		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
 	esac
 	;;
-  status)
-	status_of_proc "$DAEMON" "$NAME" -p "$PIDFILE" && exit 0 || exit $?
-	;;
   #reload|force-reload)
 	#
 	# If do_reload() is not implemented then leave this commented out
@@ -152,14 +144,17 @@
 		esac
 		;;
 	  *)
-		# Failed to stop
+	  	# Failed to stop
 		log_end_msg 1
 		;;
 	esac
 	;;
+  status)
+	status_of_proc "$DAEMON" "$NAME" -p "$PIDFILE"
+	;;
   *)
 	#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
-	echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
+	echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
 	exit 3
 	;;
 esac

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2014-07-16 23:44:54 +0000
+++ initramfs-tools-hook	2011-11-29 18:19:31 +0000
@@ -3,7 +3,7 @@
 # This script will be run by 'mkinitramfs' when it creates the image.
 # Its job is to decide which files to install, then install them into
 # the staging area, where the initramfs is being created.  This
-# happens when a new 'linux-image' package is installed, or when an
+# happens when a new 'linux-image' package is installed, or when the
 # administrator runs 'update-initramfs' by hand to update an initramfs
 # image.
 
@@ -29,15 +29,13 @@
 
 . /usr/share/initramfs-tools/hook-functions
 
-for d in /usr/lib \
-    "/usr/lib/`dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null`" \
-    "`rpm --eval='%{_libdir}' 2>/dev/null`" /usr/local/lib; do
-    if [ -d "$d"/mandos ]; then
-	libdir="$d"
+for d in /usr /usr/local; do
+    if [ -d "$d"/lib/mandos ]; then
+	prefix="$d"
 	break
     fi
 done
-if [ -z "$libdir" ]; then
+if [ -z "$prefix" ]; then
     # Mandos not found
     exit 1
 fi
@@ -79,12 +77,12 @@
     --mode=u=rwx "${DESTDIR}${PLUGINDIR}"
 
 # Copy the Mandos plugin runner
-copy_exec "$libdir"/mandos/plugin-runner "${MANDOSDIR}"
+copy_exec "$prefix"/lib/mandos/plugin-runner "${MANDOSDIR}"
 
 # Copy the plugins
 
 # Copy the packaged plugins
-for file in "$libdir"/mandos/plugins.d/*; do
+for file in "$prefix"/lib/mandos/plugins.d/*; do
     base="`basename \"$file\"`"
     # Is this plugin overridden?
     if [ -e "/etc/mandos/plugins.d/$base" ]; then
@@ -149,24 +147,12 @@
     fi
 done
 
-# GPGME needs GnuPG
-gpg=/usr/bin/gpg
-libgpgme11_version="`dpkg-query --showformat='${Version}' --show libgpgme11`"
-if dpkg --compare-versions "$libgpgme11_version" ge 1.5.0-0.1; then
-    if [ -e /usr/bin/gpgconf ]; then
-	if [ ! -e "${DESTDIR}/usr/bin/gpgconf" ]; then
-	    copy_exec /usr/bin/gpgconf
-	fi
-	gpg="`/usr/bin/gpgconf|sed --quiet --expression='s/^gpg:[^:]*://p'`"
-    fi
-elif dpkg --compare-versions "$libgpgme11_version" ge 1.4.1-0.1; then
-    gpg=/usr/bin/gpg2
-fi
-if [ ! -e "${DESTDIR}$gpg" ]; then
-    copy_exec "$gpg"
-fi
-unset gpg
-unset libgpgme11_version
+# GPGME needs /usr/bin/gpg
+if [ ! -e "${DESTDIR}/usr/bin/gpg" \
+    -a -n "`ls \"${DESTDIR}\"/usr/lib/libgpgme.so* \
+		2>/dev/null`" ]; then
+    copy_exec /usr/bin/gpg
+fi
 
 # Config files
 for file in /etc/mandos/plugin-runner.conf; do

=== removed file 'initramfs-unpack'
--- initramfs-unpack	2013-10-13 15:43:42 +0000
+++ initramfs-unpack	1970-01-01 00:00:00 +0000
@@ -1,67 +0,0 @@
-#!/bin/bash
-# 
-# Initramfs unpacker - unpacks initramfs images into /tmp
-# 
-# Copyright © 2013 Teddy Hogeborn
-# Copyright © 2013 Björn Påhlsson
-# 
-# This program is free software: you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.
-#
-#     This program is distributed in the hope that it will be useful,
-#     but WITHOUT ANY WARRANTY; without even the implied warranty of
-#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#     GNU General Public License for more details.
-# 
-# You should have received a copy of the GNU General Public License
-# along with this program.  If not, see
-# <http://www.gnu.org/licenses/>.
-# 
-# Contact the authors at <mandos@recompile.se>.
-
-cpio="cpio --extract --make-directories --unconditional --preserve-modification-time"
-
-if [ -z "$*" ]; then
-    set -- /boot/initrd.img-*
-fi
-
-for imgfile in "$@"; do
-    if ! [ -f "$imgfile" ]; then
-	echo "Error: Not an existing file: $imgfile" >&2
-	continue
-    fi
-    imgdir="${TMPDIR:-/tmp}/${imgfile##*/}"
-    if [ -d "$imgdir" ]; then
-	rm --recursive -- "$imgdir"
-    fi
-    mkdir --parents "$imgdir"
-    # Does this image contain microcode?
-    if $cpio --quiet --list --file="$imgfile" >/dev/null 2>&1; then
-	# Number of bytes to skip to get to the compressed archive
-	skip=$(($(LANG=C $cpio --io-size=1 --list --file="$imgfile" 2>&1 \
-	    | sed --quiet --expression='s/^\([0-9]\+\) blocks$/\1/p')+8))
-	catimg="dd if=$imgfile bs=$skip skip=1 status=noxfer"
-    else
-	catimg="cat -- $imgfile"
-    fi
-    # Determine the compression method
-    if { $catimg 2>/dev/null | zcat --test >/dev/null 2>&1;
-	    [ ${PIPESTATUS[-1]} -eq 0 ]; }; then
-	decomp="zcat"
-    elif { $catimg 2>/dev/null | bzip2 --test >/dev/null 2>&1;
-	    [ ${PIPESTATUS[-1]} -eq 0 ]; }; then
-	decomp="bzip2 --stdout --decompress"
-    elif { $catimg 2>/dev/null | lzop --test >/dev/null 2>&1;
-	    [ ${PIPESTATUS[-1]} -eq 0 ]; }; then
-	decomp="lzop --stdout --decompress"
-    else
-	echo "Error: Could not determine type of $imgfile" >&2
-	continue
-    fi
-    $catimg 2>/dev/null | $decomp | ( cd -- "$imgdir" && $cpio --quiet )
-    if [ ${PIPESTATUS[-1]} -eq 0 ]; then
-	echo "$imgfile unpacked into $imgdir"
-    fi
-done

=== modified file 'intro.xml'
--- intro.xml	2014-06-22 02:19:30 +0000
+++ intro.xml	2011-12-31 23:05:34 +0000
@@ -1,7 +1,7 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
-<!ENTITY TIMESTAMP "2014-06-22">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -215,22 +215,17 @@
       </para>
     </refsect2>
     
-    <refsect2 id="fakecheck">
-      <title>Faking checker results?</title>
+    <refsect2 id="fakeping">
+      <title>Faking ping replies?</title>
       <para>
-	If the Mandos client does not have an SSH server, the default
-	is for the Mandos server to use
+	The default for the server is to use
 	<quote><literal>fping</literal></quote>, the replies to which
 	could be faked to eliminate the timeout.  But this could
 	easily be changed to any shell command, with any security
-	measures you like.  If the Mandos client
-	<emphasis>has</emphasis> an SSH server, the default
-	configuration (as generated by
-	<command>mandos-keygen</command> with the
-	<option>--password</option> option) is for the Mandos server
-	to use an <command>ssh-keyscan</command> command with strict
-	keychecking, which can not be faked.  Alternatively, IPsec
-	could be used for the ping packets, making them secure.
+	measures you like.  It could, for instance, be changed to an
+	SSH command with strict keychecking, which could not be faked.
+	Or IPsec could be used for the ping packets, making them
+	secure.
       </para>
     </refsect2>
   </refsect1>

=== modified file 'mandos'
--- mandos	2014-07-25 22:44:20 +0000
+++ mandos	2012-06-17 14:55:31 +0000
@@ -1,4 +1,4 @@
-#!/usr/bin/python2.7
+#!/usr/bin/python
 # -*- mode: python; coding: utf-8 -*-
 # 
 # Mandos server - give out binary blobs to connecting clients.
@@ -11,8 +11,8 @@
 # "AvahiService" class, and some lines in "main".
 # 
 # Everything else is
-# Copyright © 2008-2014 Teddy Hogeborn
-# Copyright © 2008-2014 Björn Påhlsson
+# Copyright © 2008-2012 Teddy Hogeborn
+# Copyright © 2008-2012 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -68,7 +68,6 @@
 import binascii
 import tempfile
 import itertools
-import collections
 
 import dbus
 import dbus.service
@@ -79,6 +78,7 @@
 import ctypes.util
 import xml.dom.minidom
 import inspect
+import GnuPGInterface
 
 try:
     SO_BINDTODEVICE = socket.SO_BINDTODEVICE
@@ -88,11 +88,13 @@
     except ImportError:
         SO_BINDTODEVICE = None
 
-version = "1.6.7"
+version = "1.5.5"
 stored_state_file = "clients.pickle"
 
 logger = logging.getLogger()
-syslogger = None
+syslogger = (logging.handlers.SysLogHandler
+             (facility = logging.handlers.SysLogHandler.LOG_DAEMON,
+              address = str("/dev/log")))
 
 try:
     if_nametoindex = (ctypes.cdll.LoadLibrary
@@ -114,11 +116,6 @@
 def initlogger(debug, level=logging.WARNING):
     """init logger and add loglevel"""
     
-    global syslogger
-    syslogger = (logging.handlers.SysLogHandler
-                 (facility =
-                  logging.handlers.SysLogHandler.LOG_DAEMON,
-                  address = str("/dev/log")))
     syslogger.setFormatter(logging.Formatter
                            ('Mandos [%(process)d]: %(levelname)s:'
                             ' %(message)s'))
@@ -142,12 +139,14 @@
 class PGPEngine(object):
     """A simple class for OpenPGP symmetric encryption & decryption"""
     def __init__(self):
+        self.gnupg = GnuPGInterface.GnuPG()
         self.tempdir = tempfile.mkdtemp(prefix="mandos-")
-        self.gnupgargs = ['--batch',
-                          '--home', self.tempdir,
-                          '--force-mdc',
-                          '--quiet',
-                          '--no-use-agent']
+        self.gnupg = GnuPGInterface.GnuPG()
+        self.gnupg.options.meta_interactive = False
+        self.gnupg.options.homedir = self.tempdir
+        self.gnupg.options.extra_args.extend(['--force-mdc',
+                                              '--quiet',
+                                              '--no-use-agent'])
     
     def __enter__(self):
         return self
@@ -175,49 +174,40 @@
     def password_encode(self, password):
         # Passphrase can not be empty and can not contain newlines or
         # NUL bytes.  So we prefix it and hex encode it.
-        encoded = b"mandos" + binascii.hexlify(password)
-        if len(encoded) > 2048:
-            # GnuPG can't handle long passwords, so encode differently
-            encoded = (b"mandos" + password.replace(b"\\", b"\\\\")
-                       .replace(b"\n", b"\\n")
-                       .replace(b"\0", b"\\x00"))
-        return encoded
+        return b"mandos" + binascii.hexlify(password)
     
     def encrypt(self, data, password):
-        passphrase = self.password_encode(password)
-        with tempfile.NamedTemporaryFile(dir=self.tempdir
-                                         ) as passfile:
-            passfile.write(passphrase)
-            passfile.flush()
-            proc = subprocess.Popen(['gpg', '--symmetric',
-                                     '--passphrase-file',
-                                     passfile.name]
-                                    + self.gnupgargs,
-                                    stdin = subprocess.PIPE,
-                                    stdout = subprocess.PIPE,
-                                    stderr = subprocess.PIPE)
-            ciphertext, err = proc.communicate(input = data)
-        if proc.returncode != 0:
-            raise PGPError(err)
+        self.gnupg.passphrase = self.password_encode(password)
+        with open(os.devnull, "w") as devnull:
+            try:
+                proc = self.gnupg.run(['--symmetric'],
+                                      create_fhs=['stdin', 'stdout'],
+                                      attach_fhs={'stderr': devnull})
+                with contextlib.closing(proc.handles['stdin']) as f:
+                    f.write(data)
+                with contextlib.closing(proc.handles['stdout']) as f:
+                    ciphertext = f.read()
+                proc.wait()
+            except IOError as e:
+                raise PGPError(e)
+        self.gnupg.passphrase = None
         return ciphertext
     
     def decrypt(self, data, password):
-        passphrase = self.password_encode(password)
-        with tempfile.NamedTemporaryFile(dir = self.tempdir
-                                         ) as passfile:
-            passfile.write(passphrase)
-            passfile.flush()
-            proc = subprocess.Popen(['gpg', '--decrypt',
-                                     '--passphrase-file',
-                                     passfile.name]
-                                    + self.gnupgargs,
-                                    stdin = subprocess.PIPE,
-                                    stdout = subprocess.PIPE,
-                                    stderr = subprocess.PIPE)
-            decrypted_plaintext, err = proc.communicate(input
-                                                        = data)
-        if proc.returncode != 0:
-            raise PGPError(err)
+        self.gnupg.passphrase = self.password_encode(password)
+        with open(os.devnull, "w") as devnull:
+            try:
+                proc = self.gnupg.run(['--decrypt'],
+                                      create_fhs=['stdin', 'stdout'],
+                                      attach_fhs={'stderr': devnull})
+                with contextlib.closing(proc.handles['stdin']) as f:
+                    f.write(data)
+                with contextlib.closing(proc.handles['stdout']) as f:
+                    decrypted_plaintext = f.read()
+                proc.wait()
+            except IOError as e:
+                raise PGPError(e)
+        self.gnupg.passphrase = None
         return decrypted_plaintext
 
 
@@ -243,7 +233,7 @@
                Used to optionally bind to the specified interface.
     name: string; Example: 'Mandos'
     type: string; Example: '_mandos._tcp'.
-     See <https://www.iana.org/assignments/service-names-port-numbers>
+                  See <http://www.dns-sd.org/ServiceTypes.html>
     port: integer; what port to announce
     TXT: list of strings; TXT record for the service
     domain: string; Domain to publish on, default to .local if empty.
@@ -449,7 +439,6 @@
     runtime_expansions: Allowed attributes for runtime expansion.
     expires:    datetime.datetime(); time (UTC) when a client will be
                 disabled, or None
-    server_settings: The server_settings dict from main()
     """
     
     runtime_expansions = ("approval_delay", "approval_duration",
@@ -457,13 +446,13 @@
                           "fingerprint", "host", "interval",
                           "last_approval_request", "last_checked_ok",
                           "last_enabled", "name", "timeout")
-    client_defaults = { "timeout": "PT5M",
-                        "extended_timeout": "PT15M",
-                        "interval": "PT2M",
+    client_defaults = { "timeout": "5m",
+                        "extended_timeout": "15m",
+                        "interval": "2m",
                         "checker": "fping -q -- %%(host)s",
                         "host": "",
-                        "approval_delay": "PT0S",
-                        "approval_duration": "PT1S",
+                        "approval_delay": "0s",
+                        "approval_duration": "1s",
                         "approved_by_default": "True",
                         "enabled": "True",
                         }
@@ -530,11 +519,8 @@
         
         return settings
     
-    def __init__(self, settings, name = None, server_settings=None):
+    def __init__(self, settings, name = None):
         self.name = name
-        if server_settings is None:
-            server_settings = {}
-        self.server_settings = server_settings
         # adding all client settings
         for setting, value in settings.iteritems():
             setattr(self, setting, value)
@@ -693,11 +679,10 @@
         # If a checker exists, make sure it is not a zombie
         try:
             pid, status = os.waitpid(self.checker.pid, os.WNOHANG)
-        except AttributeError:
-            pass
-        except OSError as error:
-            if error.errno != errno.ECHILD:
-                raise
+        except (AttributeError, OSError) as error:
+            if (isinstance(error, OSError)
+                and error.errno != errno.ECHILD):
+                raise error
         else:
             if pid:
                 logger.warning("Checker was a zombie")
@@ -725,37 +710,19 @@
                 # in normal mode, that is already done by daemon(),
                 # and in debug mode we don't want to.  (Stdin is
                 # always replaced by /dev/null.)
-                # The exception is when not debugging but nevertheless
-                # running in the foreground; use the previously
-                # created wnull.
-                popen_args = {}
-                if (not self.server_settings["debug"]
-                    and self.server_settings["foreground"]):
-                    popen_args.update({"stdout": wnull,
-                                       "stderr": wnull })
                 self.checker = subprocess.Popen(command,
                                                 close_fds=True,
-                                                shell=True, cwd="/",
-                                                **popen_args)
+                                                shell=True, cwd="/")
             except OSError as error:
                 logger.error("Failed to start subprocess",
                              exc_info=error)
-                return True
             self.checker_callback_tag = (gobject.child_watch_add
                                          (self.checker.pid,
                                           self.checker_callback,
                                           data=command))
             # The checker may have completed before the gobject
             # watch was added.  Check for this.
-            try:
-                pid, status = os.waitpid(self.checker.pid, os.WNOHANG)
-            except OSError as error:
-                if error.errno == errno.ECHILD:
-                    # This should never happen
-                    logger.error("Child process vanished",
-                                 exc_info=error)
-                    return True
-                raise
+            pid, status = os.waitpid(self.checker.pid, os.WNOHANG)
             if pid:
                 gobject.source_remove(self.checker_callback_tag)
                 self.checker_callback(pid, status, command)
@@ -937,9 +904,7 @@
             # The byte_arrays option is not supported yet on
             # signatures other than "ay".
             if prop._dbus_signature != "ay":
-                raise ValueError("Byte arrays not supported for non-"
-                                 "'ay' signature {0!r}"
-                                 .format(prop._dbus_signature))
+                raise ValueError
             value = dbus.ByteArray(b''.join(chr(byte)
                                             for byte in value))
         prop(value)
@@ -1103,8 +1068,8 @@
                 interface_names.add(alt_interface)
                 # Is this a D-Bus signal?
                 if getattr(attribute, "_dbus_is_signal", False):
-                    # Extract the original non-method undecorated
-                    # function by black magic
+                    # Extract the original non-method function by
+                    # black magic
                     nonmethod_func = (dict(
                             zip(attribute.func_code.co_freevars,
                                 attribute.__closure__))["func"]
@@ -1353,7 +1318,11 @@
                                        *args, **kwargs)
     
     def start_checker(self, *args, **kwargs):
-        old_checker_pid = getattr(self.checker, "pid", None)
+        old_checker = self.checker
+        if self.checker is not None:
+            old_checker_pid = self.checker.pid
+        else:
+            old_checker_pid = None
         r = Client.start_checker(self, *args, **kwargs)
         # Only if new checker process was started
         if (self.checker is not None
@@ -1704,7 +1673,7 @@
             logger.debug("Protocol version: %r", line)
             try:
                 if int(line.strip().split()[0]) > 1:
-                    raise RuntimeError(line)
+                    raise RuntimeError
             except (ValueError, IndexError, RuntimeError) as error:
                 logger.error("Unknown protocol version: %s", error)
                 return
@@ -1917,7 +1886,7 @@
     
     def add_pipe(self, parent_pipe, proc):
         """Dummy function; override as necessary"""
-        raise NotImplementedError()
+        raise NotImplementedError
 
 
 class IPv6_TCPServer(MultiprocessingMixInWithPipe,
@@ -1999,7 +1968,7 @@
                 if self.address_family == socket.AF_INET6:
                     any_address = "::" # in6addr_any
                 else:
-                    any_address = "0.0.0.0" # INADDR_ANY
+                    any_address = socket.INADDR_ANY
                 self.server_address = (any_address,
                                        self.server_address[1])
             elif not self.server_address[1]:
@@ -2121,105 +2090,6 @@
         return True
 
 
-def rfc3339_duration_to_delta(duration):
-    """Parse an RFC 3339 "duration" and return a datetime.timedelta
-    
-    >>> rfc3339_duration_to_delta("P7D")
-    datetime.timedelta(7)
-    >>> rfc3339_duration_to_delta("PT60S")
-    datetime.timedelta(0, 60)
-    >>> rfc3339_duration_to_delta("PT60M")
-    datetime.timedelta(0, 3600)
-    >>> rfc3339_duration_to_delta("PT24H")
-    datetime.timedelta(1)
-    >>> rfc3339_duration_to_delta("P1W")
-    datetime.timedelta(7)
-    >>> rfc3339_duration_to_delta("PT5M30S")
-    datetime.timedelta(0, 330)
-    >>> rfc3339_duration_to_delta("P1DT3M20S")
-    datetime.timedelta(1, 200)
-    """
-    
-    # Parsing an RFC 3339 duration with regular expressions is not
-    # possible - there would have to be multiple places for the same
-    # values, like seconds.  The current code, while more esoteric, is
-    # cleaner without depending on a parsing library.  If Python had a
-    # built-in library for parsing we would use it, but we'd like to
-    # avoid excessive use of external libraries.
-    
-    # New type for defining tokens, syntax, and semantics all-in-one
-    Token = collections.namedtuple("Token",
-                                   ("regexp", # To match token; if
-                                              # "value" is not None,
-                                              # must have a "group"
-                                              # containing digits
-                                    "value",  # datetime.timedelta or
-                                              # None
-                                    "followers")) # Tokens valid after
-                                                  # this token
-    # RFC 3339 "duration" tokens, syntax, and semantics; taken from
-    # the "duration" ABNF definition in RFC 3339, Appendix A.
-    token_end = Token(re.compile(r"$"), None, frozenset())
-    token_second = Token(re.compile(r"(\d+)S"),
-                         datetime.timedelta(seconds=1),
-                         frozenset((token_end,)))
-    token_minute = Token(re.compile(r"(\d+)M"),
-                         datetime.timedelta(minutes=1),
-                         frozenset((token_second, token_end)))
-    token_hour = Token(re.compile(r"(\d+)H"),
-                       datetime.timedelta(hours=1),
-                       frozenset((token_minute, token_end)))
-    token_time = Token(re.compile(r"T"),
-                       None,
-                       frozenset((token_hour, token_minute,
-                                  token_second)))
-    token_day = Token(re.compile(r"(\d+)D"),
-                      datetime.timedelta(days=1),
-                      frozenset((token_time, token_end)))
-    token_month = Token(re.compile(r"(\d+)M"),
-                        datetime.timedelta(weeks=4),
-                        frozenset((token_day, token_end)))
-    token_year = Token(re.compile(r"(\d+)Y"),
-                       datetime.timedelta(weeks=52),
-                       frozenset((token_month, token_end)))
-    token_week = Token(re.compile(r"(\d+)W"),
-                       datetime.timedelta(weeks=1),
-                       frozenset((token_end,)))
-    token_duration = Token(re.compile(r"P"), None,
-                           frozenset((token_year, token_month,
-                                      token_day, token_time,
-                                      token_week)))
-    # Define starting values
-    value = datetime.timedelta() # Value so far
-    found_token = None
-    followers = frozenset((token_duration,)) # Following valid tokens
-    s = duration                # String left to parse
-    # Loop until end token is found
-    while found_token is not token_end:
-        # Search for any currently valid tokens
-        for token in followers:
-            match = token.regexp.match(s)
-            if match is not None:
-                # Token found
-                if token.value is not None:
-                    # Value found, parse digits
-                    factor = int(match.group(1), 10)
-                    # Add to value so far
-                    value += factor * token.value
-                # Strip token from string
-                s = token.regexp.sub("", s, 1)
-                # Go to found token
-                found_token = token
-                # Set valid next tokens
-                followers = found_token.followers
-                break
-        else:
-            # No currently valid tokens were found
-            raise ValueError("Invalid RFC 3339 duration")
-    # End token found
-    return value
-
-
 def string_to_delta(interval):
     """Parse a string and return a datetime.timedelta
     
@@ -2236,12 +2106,6 @@
     >>> string_to_delta('5m 30s')
     datetime.timedelta(0, 330)
     """
-    
-    try:
-        return rfc3339_duration_to_delta(interval)
-    except ValueError:
-        pass
-    
     timevalue = datetime.timedelta(0)
     for s in interval.split():
         try:
@@ -2260,7 +2124,7 @@
             else:
                 raise ValueError("Unknown suffix {0!r}"
                                  .format(suffix))
-        except IndexError as e:
+        except (ValueError, IndexError) as e:
             raise ValueError(*(e.args))
         timevalue += delta
     return timevalue
@@ -2310,7 +2174,7 @@
                         help="Run self-test")
     parser.add_argument("--debug", action="store_true",
                         help="Debug mode; run in foreground and log"
-                        " to terminal", default=None)
+                        " to terminal")
     parser.add_argument("--debuglevel", metavar="LEVEL",
                         help="Debug level for stdout output")
     parser.add_argument("--priority", help="GnuTLS"
@@ -2323,30 +2187,26 @@
                         " files")
     parser.add_argument("--no-dbus", action="store_false",
                         dest="use_dbus", help="Do not provide D-Bus"
-                        " system bus interface", default=None)
+                        " system bus interface")
     parser.add_argument("--no-ipv6", action="store_false",
-                        dest="use_ipv6", help="Do not use IPv6",
-                        default=None)
+                        dest="use_ipv6", help="Do not use IPv6")
     parser.add_argument("--no-restore", action="store_false",
                         dest="restore", help="Do not restore stored"
-                        " state", default=None)
+                        " state")
     parser.add_argument("--socket", type=int,
                         help="Specify a file descriptor to a network"
                         " socket to use instead of creating one")
     parser.add_argument("--statedir", metavar="DIR",
                         help="Directory to save/restore state in")
     parser.add_argument("--foreground", action="store_true",
-                        help="Run in foreground", default=None)
-    parser.add_argument("--no-zeroconf", action="store_false",
-                        dest="zeroconf", help="Do not use Zeroconf",
-                        default=None)
+                        help="Run in foreground")
     
     options = parser.parse_args()
     
     if options.check:
         import doctest
-        fail_count, test_count = doctest.testmod()
-        sys.exit(os.EX_OK if fail_count == 0 else 1)
+        doctest.testmod()
+        sys.exit()
     
     # Default values for config file for server-global settings
     server_defaults = { "interface": "",
@@ -2354,7 +2214,7 @@
                         "port": "",
                         "debug": "False",
                         "priority":
-                        "SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:+SIGN-RSA-SHA224:+SIGN-RSA-RMD160",
+                        "SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP",
                         "servicename": "Mandos",
                         "use_dbus": "True",
                         "use_ipv6": "True",
@@ -2363,7 +2223,6 @@
                         "socket": "",
                         "statedir": "/var/lib/mandos",
                         "foreground": "False",
-                        "zeroconf": "True",
                         }
     
     # Parse config file for server-global settings
@@ -2396,7 +2255,7 @@
     for option in ("interface", "address", "port", "debug",
                    "priority", "servicename", "configdir",
                    "use_dbus", "use_ipv6", "debuglevel", "restore",
-                   "statedir", "socket", "foreground", "zeroconf"):
+                   "statedir", "socket", "foreground"):
         value = getattr(options, option)
         if value is not None:
             server_settings[option] = value
@@ -2405,10 +2264,6 @@
     for option in server_settings.keys():
         if type(server_settings[option]) is str:
             server_settings[option] = unicode(server_settings[option])
-    # Force all boolean options to be boolean
-    for option in ("debug", "use_dbus", "use_ipv6", "restore",
-                   "foreground", "zeroconf"):
-        server_settings[option] = bool(server_settings[option])
     # Debug implies foreground
     if server_settings["debug"]:
         server_settings["foreground"] = True
@@ -2416,12 +2271,6 @@
     
     ##################################################################
     
-    if (not server_settings["zeroconf"] and
-        not (server_settings["port"]
-             or server_settings["socket"] != "")):
-            parser.error("Needs port or socket to work without"
-                         " Zeroconf")
-    
     # For convenience
     debug = server_settings["debug"]
     debuglevel = server_settings["debuglevel"]
@@ -2430,7 +2279,6 @@
     stored_state_path = os.path.join(server_settings["statedir"],
                                      stored_state_file)
     foreground = server_settings["foreground"]
-    zeroconf = server_settings["zeroconf"]
     
     if debug:
         initlogger(debug, logging.DEBUG)
@@ -2457,9 +2305,6 @@
     global mandos_dbus_service
     mandos_dbus_service = None
     
-    socketfd = None
-    if server_settings["socket"] != "":
-        socketfd = server_settings["socket"]
     tcp_server = MandosServer((server_settings["address"],
                                server_settings["port"]),
                               ClientHandler,
@@ -2469,11 +2314,10 @@
                               gnutls_priority=
                               server_settings["priority"],
                               use_dbus=use_dbus,
-                              socketfd=socketfd)
+                              socketfd=(server_settings["socket"]
+                                        or None))
     if not foreground:
-        pidfilename = "/run/mandos.pid"
-        if not os.path.isdir("/run/."):
-            pidfilename = "/var/run/mandos.pid"
+        pidfilename = "/var/run/mandos.pid"
         pidfile = None
         try:
             pidfile = open(pidfilename, "w")
@@ -2496,7 +2340,7 @@
         os.setuid(uid)
     except OSError as error:
         if error.errno != errno.EPERM:
-            raise
+            raise error
     
     if debug:
         # Enable all possible GnuTLS debugging
@@ -2545,15 +2389,14 @@
             use_dbus = False
             server_settings["use_dbus"] = False
             tcp_server.use_dbus = False
-    if zeroconf:
-        protocol = avahi.PROTO_INET6 if use_ipv6 else avahi.PROTO_INET
-        service = AvahiServiceToSyslog(name =
-                                       server_settings["servicename"],
-                                       servicetype = "_mandos._tcp",
-                                       protocol = protocol, bus = bus)
-        if server_settings["interface"]:
-            service.interface = (if_nametoindex
-                                 (str(server_settings["interface"])))
+    protocol = avahi.PROTO_INET6 if use_ipv6 else avahi.PROTO_INET
+    service = AvahiServiceToSyslog(name =
+                                   server_settings["servicename"],
+                                   servicetype = "_mandos._tcp",
+                                   protocol = protocol, bus = bus)
+    if server_settings["interface"]:
+        service.interface = (if_nametoindex
+                             (str(server_settings["interface"])))
     
     global multiprocessing_manager
     multiprocessing_manager = multiprocessing.Manager()
@@ -2566,14 +2409,6 @@
     old_client_settings = {}
     clients_data = {}
     
-    # This is used to redirect stdout and stderr for checker processes
-    global wnull
-    wnull = open(os.devnull, "w") # A writable /dev/null
-    # Only used if server is running in foreground but not in debug
-    # mode
-    if debug or not foreground:
-        wnull.close()
-    
     # Get client data and settings from last running state.
     if server_settings["restore"]:
         try:
@@ -2595,10 +2430,6 @@
     
     with PGPEngine() as pgp:
         for client_name, client in clients_data.iteritems():
-            # Skip removed clients
-            if client_name not in client_settings:
-                continue
-            
             # Decide which value to use after restoring saved state.
             # We have three different values: Old config file,
             # new config file, and saved state.
@@ -2666,8 +2497,7 @@
     # Create all client objects
     for client_name, client in clients_data.iteritems():
         tcp_server.clients[client_name] = client_class(
-            name = client_name, settings = client,
-            server_settings = server_settings)
+            name = client_name, settings = client)
     
     if not tcp_server.clients:
         logger.warning("No clients defined")
@@ -2753,11 +2583,9 @@
     
     def cleanup():
         "Cleanup function; run on exit"
-        if zeroconf:
-            service.cleanup()
+        service.cleanup()
         
         multiprocessing.active_children()
-        wnull.close()
         if not (tcp_server.clients or client_settings):
             return
         
@@ -2775,7 +2603,7 @@
                 # A list of attributes that can not be pickled
                 # + secret.
                 exclude = set(("bus", "changedstate", "secret",
-                               "checker", "server_settings"))
+                               "checker"))
                 for name, typ in (inspect.getmembers
                                   (dbus.service.Object)):
                     exclude.add(name)
@@ -2809,7 +2637,7 @@
             else:
                 logger.warning("Could not save persistent state:",
                                exc_info=e)
-                raise
+                raise e
         
         # Delete all clients, and settings from config
         while tcp_server.clients:
@@ -2839,8 +2667,7 @@
     tcp_server.server_activate()
     
     # Find out what port we got
-    if zeroconf:
-        service.port = tcp_server.socket.getsockname()[1]
+    service.port = tcp_server.socket.getsockname()[1]
     if use_ipv6:
         logger.info("Now listening on address %r, port %d,"
                     " flowinfo %d, scope_id %d",
@@ -2852,15 +2679,14 @@
     #service.interface = tcp_server.socket.getsockname()[3]
     
     try:
-        if zeroconf:
-            # From the Avahi example code
-            try:
-                service.activate()
-            except dbus.exceptions.DBusException as error:
-                logger.critical("D-Bus Exception", exc_info=error)
-                cleanup()
-                sys.exit(1)
-            # End of Avahi example code
+        # From the Avahi example code
+        try:
+            service.activate()
+        except dbus.exceptions.DBusException as error:
+            logger.critical("D-Bus Exception", exc_info=error)
+            cleanup()
+            sys.exit(1)
+        # End of Avahi example code
         
         gobject.io_add_watch(tcp_server.fileno(), gobject.IO_IN,
                              lambda *args, **kwargs:

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2014-06-22 02:19:30 +0000
+++ mandos-clients.conf.xml	2012-05-26 22:48:45 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2014-06-22">
+<!ENTITY TIMESTAMP "2012-05-27">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -117,7 +117,7 @@
 	  <para>
 	    How long to wait for external approval before resorting to
 	    use the <option>approved_by_default</option> value.  The
-	    default is <quote>PT0S</quote>, i.e. not to wait.
+	    default is <quote>0s</quote>, i.e. not to wait.
 	  </para>
 	  <para>
 	    The format of <replaceable>TIME</replaceable> is the same
@@ -177,13 +177,7 @@
 	    <varname>PATH</varname> will be searched.  The default
 	    value for the checker command is <quote><literal
 	    ><command>fping</command> <option>-q</option> <option
-	    >--</option> %%(host)s</literal></quote>.  Note that
-	    <command>mandos-keygen</command>, when generating output
-	    to be inserted into this file, normally looks for an SSH
-	    server on the Mandos client, and, if it find one, outputs
-	    a <option>checker</option> option to check for the
-	    client’s key fingerprint – this is more secure against
-	    spoofing.
+	    >--</option> %%(host)s</literal></quote>.
 	  </para>
 	  <para>
 	    In addition to normal start time expansion, this option
@@ -341,12 +335,17 @@
 	    <option>extended_timeout</option> option.
 	  </para>
 	  <para>
-	    The <replaceable>TIME</replaceable> is specified as an RFC
-	    3339 duration; for example
-	    <quote><literal>P1Y2M3DT4H5M6S</literal></quote> meaning
-	    one year, two months, three days, four hours, five
-	    minutes, and six seconds.  Some values can be omitted, see
-	    RFC 3339 Appendix A for details.
+	    The <replaceable>TIME</replaceable> is specified as a
+	    space-separated number of values, each of which is a
+	    number and a one-character suffix.  The suffix must be one
+	    of <quote>d</quote>, <quote>s</quote>, <quote>m</quote>,
+	    <quote>h</quote>, and <quote>w</quote> for days, seconds,
+	    minutes, hours, and weeks, respectively.  The values are
+	    added together to give the total time value, so all of
+	    <quote><literal>330s</literal></quote>,
+	    <quote><literal>110s 110s 110s</literal></quote>, and
+	    <quote><literal>5m 30s</literal></quote> will give a value
+	    of five minutes and thirty seconds.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -466,8 +465,8 @@
     <informalexample>
       <programlisting>
 [DEFAULT]
-timeout = PT5M
-interval = PT2M
+timeout = 5m
+interval = 2m
 checker = fping -q -- %%(host)s
 
 # Client "foo"
@@ -490,15 +489,15 @@
         4T2zw4dxS5NswXWU0sVEXxjs6PYxuIiCTL7vdpx8QjBkrPWDrAbcMyBr2O
         QlnHIvPzEArRQLo=
 host = foo.example.org
-interval = PT1M
+interval = 1m
 
 # Client "bar"
 [bar]
 fingerprint = 3e393aeaefb84c7e89e2f547b3a107558fca3a27
 secfile = /etc/mandos/bar-secret
-timeout = PT15M
+timeout = 15m
 approved_by_default = False
-approval_delay = PT30S
+approval_delay = 30s
       </programlisting>
     </informalexample>
   </refsect1>
@@ -517,20 +516,6 @@
       <citerefentry><refentrytitle>fping</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>
     </para>
-    <variablelist>
-      <varlistentry>
-	<term>
-	  RFC 3339: <citetitle>Date and Time on the Internet:
-	  Timestamps</citetitle>
-	</term>
-      <listitem>
-	<para>
-	  The time intervals are in the "duration" format, as
-	  specified in ABNF in Appendix A of RFC 3339.
-	</para>
-      </listitem>
-      </varlistentry>
-    </variablelist>
   </refsect1>
 </refentry>
 <!-- Local Variables: -->

=== modified file 'mandos-ctl'
--- mandos-ctl	2014-07-24 01:35:55 +0000
+++ mandos-ctl	2012-06-01 18:39:03 +0000
@@ -3,8 +3,8 @@
 # 
 # Mandos Monitor - Control and monitor the Mandos server
 # 
-# Copyright © 2008-2014 Teddy Hogeborn
-# Copyright © 2008-2014 Björn Påhlsson
+# Copyright © 2008-2012 Teddy Hogeborn
+# Copyright © 2008-2012 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -26,24 +26,15 @@
 from __future__ import (division, absolute_import, print_function,
                         unicode_literals)
 
-try:
-    from future_builtins import *
-except ImportError:
-    pass
+from future_builtins import *
 
 import sys
+import dbus
 import argparse
 import locale
 import datetime
 import re
 import os
-import collections
-import doctest
-
-import dbus
-
-if sys.version_info[0] == 2:
-    str = unicode
 
 locale.setlocale(locale.LC_ALL, "")
 
@@ -72,7 +63,7 @@
 server_path = "/"
 server_interface = domain + ".Mandos"
 client_interface = domain + ".Mandos.Client"
-version = "1.6.7"
+version = "1.5.5"
 
 def timedelta_to_milliseconds(td):
     """Convert a datetime.timedelta object to milliseconds"""
@@ -89,106 +80,6 @@
                     seconds = td.seconds % 60,
                     ))
 
-
-def rfc3339_duration_to_delta(duration):
-    """Parse an RFC 3339 "duration" and return a datetime.timedelta
-    
-    >>> rfc3339_duration_to_delta("P7D")
-    datetime.timedelta(7)
-    >>> rfc3339_duration_to_delta("PT60S")
-    datetime.timedelta(0, 60)
-    >>> rfc3339_duration_to_delta("PT60M")
-    datetime.timedelta(0, 3600)
-    >>> rfc3339_duration_to_delta("PT24H")
-    datetime.timedelta(1)
-    >>> rfc3339_duration_to_delta("P1W")
-    datetime.timedelta(7)
-    >>> rfc3339_duration_to_delta("PT5M30S")
-    datetime.timedelta(0, 330)
-    >>> rfc3339_duration_to_delta("P1DT3M20S")
-    datetime.timedelta(1, 200)
-    """
-    
-    # Parsing an RFC 3339 duration with regular expressions is not
-    # possible - there would have to be multiple places for the same
-    # values, like seconds.  The current code, while more esoteric, is
-    # cleaner without depending on a parsing library.  If Python had a
-    # built-in library for parsing we would use it, but we'd like to
-    # avoid excessive use of external libraries.
-    
-    # New type for defining tokens, syntax, and semantics all-in-one
-    Token = collections.namedtuple("Token",
-                                   ("regexp", # To match token; if
-                                              # "value" is not None,
-                                              # must have a "group"
-                                              # containing digits
-                                    "value",  # datetime.timedelta or
-                                              # None
-                                    "followers")) # Tokens valid after
-                                                  # this token
-    # RFC 3339 "duration" tokens, syntax, and semantics; taken from
-    # the "duration" ABNF definition in RFC 3339, Appendix A.
-    token_end = Token(re.compile(r"$"), None, frozenset())
-    token_second = Token(re.compile(r"(\d+)S"),
-                         datetime.timedelta(seconds=1),
-                         frozenset((token_end,)))
-    token_minute = Token(re.compile(r"(\d+)M"),
-                         datetime.timedelta(minutes=1),
-                         frozenset((token_second, token_end)))
-    token_hour = Token(re.compile(r"(\d+)H"),
-                       datetime.timedelta(hours=1),
-                       frozenset((token_minute, token_end)))
-    token_time = Token(re.compile(r"T"),
-                       None,
-                       frozenset((token_hour, token_minute,
-                                  token_second)))
-    token_day = Token(re.compile(r"(\d+)D"),
-                      datetime.timedelta(days=1),
-                      frozenset((token_time, token_end)))
-    token_month = Token(re.compile(r"(\d+)M"),
-                        datetime.timedelta(weeks=4),
-                        frozenset((token_day, token_end)))
-    token_year = Token(re.compile(r"(\d+)Y"),
-                       datetime.timedelta(weeks=52),
-                       frozenset((token_month, token_end)))
-    token_week = Token(re.compile(r"(\d+)W"),
-                       datetime.timedelta(weeks=1),
-                       frozenset((token_end,)))
-    token_duration = Token(re.compile(r"P"), None,
-                           frozenset((token_year, token_month,
-                                      token_day, token_time,
-                                      token_week)))
-    # Define starting values
-    value = datetime.timedelta() # Value so far
-    found_token = None
-    followers = frozenset((token_duration,)) # Following valid tokens
-    s = duration                # String left to parse
-    # Loop until end token is found
-    while found_token is not token_end:
-        # Search for any currently valid tokens
-        for token in followers:
-            match = token.regexp.match(s)
-            if match is not None:
-                # Token found
-                if token.value is not None:
-                    # Value found, parse digits
-                    factor = int(match.group(1), 10)
-                    # Add to value so far
-                    value += factor * token.value
-                # Strip token from string
-                s = token.regexp.sub("", s, 1)
-                # Go to found token
-                found_token = token
-                # Set valid next tokens
-                followers = found_token.followers
-                break
-        else:
-            # No currently valid tokens were found
-            raise ValueError("Invalid RFC 3339 duration")
-    # End token found
-    return value
-
-
 def string_to_delta(interval):
     """Parse a string and return a datetime.timedelta
     
@@ -205,14 +96,8 @@
     >>> string_to_delta("5m 30s")
     datetime.timedelta(0, 330)
     """
-    
-    try:
-        return rfc3339_duration_to_delta(interval)
-    except ValueError:
-        pass
-    
     value = datetime.timedelta(0)
-    regexp = re.compile(r"(\d+)([dsmhw]?)")
+    regexp = re.compile("(\d+)([dsmhw]?)")
     
     for num, suffix in regexp.findall(interval):
         if suffix == "d":
@@ -236,7 +121,7 @@
         if keyword in ("Timeout", "Interval", "ApprovalDelay",
                        "ApprovalDuration", "ExtendedTimeout"):
             return milliseconds_to_string(value)
-        return str(value)
+        return unicode(value)
     
     # Create format string to print table rows
     format_string = " ".join("{{{key}:{width}}}".format(
@@ -316,15 +201,12 @@
     parser.add_argument("--approval-duration",
                         help="Set duration of one client approval")
     parser.add_argument("-H", "--host", help="Set host for client")
-    parser.add_argument("-s", "--secret",
-                        type=argparse.FileType(mode="rb"),
+    parser.add_argument("-s", "--secret", type=file,
                         help="Set password blob (file) for client")
     parser.add_argument("-A", "--approve", action="store_true",
                         help="Approve any current client request")
     parser.add_argument("-D", "--deny", action="store_true",
                         help="Deny any current client request")
-    parser.add_argument("--check", action="store_true",
-                        help="Run self-test")
     parser.add_argument("client", nargs="*", help="Client name")
     options = parser.parse_args()
     
@@ -335,10 +217,6 @@
                      " --all.")
     if options.all and not has_actions(options):
         parser.error("--all requires an action.")
-
-    if options.check:
-        fail_count, test_count = doctest.testmod()
-        sys.exit(os.EX_OK if fail_count == 0 else 1)
     
     try:
         bus = dbus.SystemBus()
@@ -374,7 +252,7 @@
     if options.all or not options.client:
         clients = dict((bus.get_object(busname, path), properties)
                        for path, properties in
-                       mandos_clients.items())
+                       mandos_clients.iteritems())
     else:
         for name in options.client:
             for path, client in mandos_clients.iteritems():

=== modified file 'mandos-ctl.xml'
--- mandos-ctl.xml	2012-06-22 23:33:56 +0000
+++ mandos-ctl.xml	2011-12-31 23:05:34 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-ctl">
-<!ENTITY TIMESTAMP "2012-06-22">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -195,10 +195,6 @@
 	<arg choice="plain"><option>-v</option></arg>
       </group>
     </cmdsynopsis>
-    <cmdsynopsis>
-      <command>&COMMANDNAME;</command>
-      <arg choice="plain"><option>--check</option></arg>
-    </cmdsynopsis>
   </refsynopsisdiv>
   
   <refsect1 id="description">
@@ -480,15 +476,6 @@
 	</listitem>
       </varlistentry>
       
-      <varlistentry>
-	<term><option>--check</option></term>
-	<listitem>
-	  <para>
-	    Run self-tests.  This includes any unit tests, etc.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
     </variablelist>
   </refsect1>
   

=== modified file 'mandos-keygen'
--- mandos-keygen	2014-07-17 03:24:57 +0000
+++ mandos-keygen	2012-06-01 18:39:03 +0000
@@ -2,8 +2,8 @@
 # 
 # Mandos key generator - create a new OpenPGP key for a Mandos client
 # 
-# Copyright © 2008-2014 Teddy Hogeborn
-# Copyright © 2008-2014 Björn Påhlsson
+# Copyright © 2008-2012 Teddy Hogeborn
+# Copyright © 2008-2012 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,19 +21,18 @@
 # Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.6.7"
+VERSION="1.5.5"
 
 KEYDIR="/etc/keys/mandos"
-KEYTYPE=RSA
-KEYLENGTH=4096
-SUBKEYTYPE=RSA
-SUBKEYLENGTH=4096
+KEYTYPE=DSA
+KEYLENGTH=2048
+SUBKEYTYPE=ELG-E
+SUBKEYLENGTH=2048
 KEYNAME="`hostname --fqdn 2>/dev/null || hostname`"
 KEYEMAIL=""
-KEYCOMMENT=""
+KEYCOMMENT="Mandos client key"
 KEYEXPIRE=0
 FORCE=no
-SSH=yes
 KEYCOMMENT_ORIG="$KEYCOMMENT"
 mode=keygen
 
@@ -42,8 +41,8 @@
 fi
 
 # Parse options
-TEMP=`getopt --options vhpF:d:t:l:s:L:n:e:c:x:fS \
-    --longoptions version,help,password,passfile:,dir:,type:,length:,subtype:,sublength:,name:,email:,comment:,expire:,force,no-ssh \
+TEMP=`getopt --options vhpF:d:t:l:s:L:n:e:c:x:f \
+    --longoptions version,help,password,passfile:,dir:,type:,length:,subtype:,sublength:,name:,email:,comment:,expire:,force \
     --name "$0" -- "$@"`
 
 help(){
@@ -61,18 +60,19 @@
   -v, --version         Show program's version number and exit
   -h, --help            Show this help message and exit
   -d DIR, --dir DIR     Target directory for key files
-  -t TYPE, --type TYPE  Key type.  Default is RSA.
+  -t TYPE, --type TYPE  Key type.  Default is DSA.
   -l BITS, --length BITS
-                        Key length in bits.  Default is 4096.
+                        Key length in bits.  Default is 2048.
   -s TYPE, --subtype TYPE
-                        Subkey type.  Default is RSA.
+                        Subkey type.  Default is ELG-E.
   -L BITS, --sublength BITS
-                        Subkey length in bits.  Default is 4096.
+                        Subkey length in bits.  Default is 2048.
   -n NAME, --name NAME  Name of key.  Default is the FQDN.
   -e ADDRESS, --email ADDRESS
                         Email address of key.  Default is empty.
   -c TEXT, --comment TEXT
-                        Comment field for key.  The default is empty.
+                        Comment field for key.  The default value is
+                        "Mandos client key".
   -x TIME, --expire TIME
                         Key expire time.  Default is no expiration.
                         See gpg(1) for syntax.
@@ -86,7 +86,6 @@
                         Encrypt a password from FILE using the key in
                         the key directory.  All options other than
                         --dir and --name are ignored.
-  -S, --no-ssh          Don't get SSH key or set "checker" option.
 EOF
 }
 
@@ -105,7 +104,6 @@
 	-c|--comment) KEYCOMMENT="$2"; shift 2;;
 	-x|--expire) KEYEXPIRE="$2"; shift 2;;
 	-f|--force) FORCE=yes; shift;;
-	-S|--no-ssh) SSH=no; shift;;
 	-v|--version) echo "$0 $VERSION"; exit;;
 	-h|--help) help; exit;;
 	--) shift; break;;
@@ -191,7 +189,7 @@
 trap "
 set +e; \
 test -n \"$SECFILE\" && shred --remove \"$SECFILE\"; \
-shred --remove \"$RINGDIR\"/sec* 2>/dev/null;
+shred --remove \"$RINGDIR\"/sec*;
 test -n \"$BATCHFILE\" && rm --force \"$BATCHFILE\"; \
 rm --recursive --force \"$RINGDIR\";
 tty --quiet && stty echo; \
@@ -206,10 +204,10 @@
     cat >"$BATCHFILE" <<-EOF
 	Key-Type: $KEYTYPE
 	Key-Length: $KEYLENGTH
-	Key-Usage: sign,auth
+	#Key-Usage: encrypt,sign,auth
 	Subkey-Type: $SUBKEYTYPE
 	Subkey-Length: $SUBKEYLENGTH
-	Subkey-Usage: encrypt
+	#Subkey-Usage: encrypt,sign,auth
 	Name-Real: $KEYNAME
 	$KEYCOMMENTLINE
 	$KEYEMAILLINE
@@ -231,11 +229,6 @@
 	date
     fi
     
-    # Make sure trustdb.gpg exists;
-    # this is a workaround for Debian bug #737128
-    gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
-	--homedir "$RINGDIR" \
-	--import-ownertrust < /dev/null
     # Generate a new key in the key rings
     gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
 	--homedir "$RINGDIR" --trust-model always \
@@ -277,23 +270,6 @@
 fi
 
 if [ "$mode" = password ]; then
-    
-    # Make SSH be 0 or 1
-    case "$SSH" in
-	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]) SSH=1;;
-	[Nn][Oo]|[Ff][Aa][Ll][Ss][Ee]|*) SSH=0;;
-    esac
-    
-    if [ $SSH -eq 1 ]; then
-	set +e
-	ssh_fingerprint="`ssh-keyscan localhost 2>/dev/null`"
-	if [ $? -ne 0 ]; then
-	    ssh_fingerprint=""
-	fi
-	set -e
-	ssh_fingerprint="${ssh_fingerprint#localhost }"
-    fi
-    
     # Import key into temporary key rings
     gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
 	--homedir "$RINGDIR" --trust-model always --armor \
@@ -318,11 +294,9 @@
 	    cat "$PASSFILE"
 	else
 	    tty --quiet && stty -echo
-	    echo -n "Enter passphrase: " >&2
-	    read first
+	    read -p "Enter passphrase: " first
 	    tty --quiet && echo >&2
-	    echo -n "Repeat passphrase: " >&2
-	    read second
+	    read -p "Repeat passphrase: " second
 	    if tty --quiet; then
 		echo >&2
 		stty echo
@@ -362,10 +336,6 @@
 		/^[^-]/s/^/    /p
 	    }
 	}' < "$SECFILE"
-    if [ -n "$ssh_fingerprint" ]; then
-	echo 'checker = ssh-keyscan %%(host)s 2>/dev/null | grep --fixed-strings --line-regexp --quiet --regexp="%%(host)s %(ssh_fingerprint)s"'
-	echo "ssh_fingerprint = ${ssh_fingerprint}"
-    fi
 fi
 
 trap - EXIT
@@ -376,5 +346,5 @@
     shred --remove "$SECFILE"
 fi
 # Remove the key rings
-shred --remove "$RINGDIR"/sec* 2>/dev/null
+shred --remove "$RINGDIR"/sec*
 rm --recursive --force "$RINGDIR"

=== modified file 'mandos-keygen.xml'
--- mandos-keygen.xml	2014-06-22 02:19:30 +0000
+++ mandos-keygen.xml	2011-12-31 23:05:34 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-keygen">
-<!ENTITY TIMESTAMP "2014-06-22">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -119,10 +119,7 @@
 	<replaceable>TIME</replaceable></option></arg>
       </group>
       <sbr/>
-      <group>
-	<arg choice="plain"><option>--force</option></arg>
-	<arg choice="plain"><option>-f</option></arg>
-      </group>
+      <arg><option>--force</option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -148,10 +145,6 @@
 	<arg choice="plain"><option>-n
 	<replaceable>NAME</replaceable></option></arg>
       </group>
-      <group>
-	<arg choice="plain"><option>--no-ssh</option></arg>
-	<arg choice="plain"><option>-S</option></arg>
-      </group>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -234,7 +227,7 @@
 	<replaceable>TYPE</replaceable></option></term>
 	<listitem>
 	  <para>
-	    Key type.  Default is <quote>RSA</quote>.
+	    Key type.  Default is <quote>DSA</quote>.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -246,7 +239,7 @@
 	<replaceable>BITS</replaceable></option></term>
 	<listitem>
 	  <para>
-	    Key length in bits.  Default is 4096.
+	    Key length in bits.  Default is 2048.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -258,7 +251,7 @@
 	<replaceable>KEYTYPE</replaceable></option></term>
 	<listitem>
 	  <para>
-	    Subkey type.  Default is <quote>RSA</quote> (Elgamal
+	    Subkey type.  Default is <quote>ELG-E</quote> (Elgamal
 	    encryption-only).
 	  </para>
 	</listitem>
@@ -271,7 +264,7 @@
 	<replaceable>BITS</replaceable></option></term>
 	<listitem>
 	  <para>
-	    Subkey length in bits.  Default is 4096.
+	    Subkey length in bits.  Default is 2048.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -295,7 +288,8 @@
 	<replaceable>TEXT</replaceable></option></term>
 	<listitem>
 	  <para>
-	    Comment field for key.  Default is empty.
+	    Comment field for key.  The default value is
+	    <quote><literal>Mandos client key</literal></quote>.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -353,22 +347,6 @@
 	  </para>
 	</listitem>
       </varlistentry>
-      <varlistentry>
-	<term><option>--no-ssh</option></term>
-	<term><option>-S</option></term>
-	<listitem>
-	  <para>
-	    When <option>--password</option> or
-	    <option>--passfile</option> is given, this option will
-	    prevent <command>&COMMANDNAME;</command> from calling
-	    <command>ssh-keyscan</command> to get an SSH fingerprint
-	    for this host and, if successful, output suitable config
-	    options to use this fingerprint as a
-	    <option>checker</option> option in the output.  This is
-	    otherwise the default behavior.
-	  </para>
-	</listitem>
-      </varlistentry>
     </variablelist>
   </refsect1>
   
@@ -525,9 +503,7 @@
       <citerefentry><refentrytitle>mandos</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos-client</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>ssh-keyscan</refentrytitle>
-      <manvolnum>1</manvolnum></citerefentry>
+      <manvolnum>8mandos</manvolnum></citerefentry>
     </para>
   </refsect1>
   

=== modified file 'mandos-monitor'
--- mandos-monitor	2014-07-24 02:58:45 +0000
+++ mandos-monitor	2012-06-01 18:39:03 +0000
@@ -3,8 +3,8 @@
 # 
 # Mandos Monitor - Control and monitor the Mandos server
 # 
-# Copyright © 2009-2014 Teddy Hogeborn
-# Copyright © 2009-2014 Björn Påhlsson
+# Copyright © 2009-2012 Teddy Hogeborn
+# Copyright © 2009-2012 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -25,13 +25,12 @@
 
 from __future__ import (division, absolute_import, print_function,
                         unicode_literals)
-try:
-    from future_builtins import *
-except ImportError:
-    pass
+
+from future_builtins import *
 
 import sys
 import os
+import signal
 
 import datetime
 
@@ -39,18 +38,14 @@
 import urwid
 
 from dbus.mainloop.glib import DBusGMainLoop
-try:
-    import gobject
-except ImportError:
-    from gi.repository import GObject as gobject
+import gobject
 
 import dbus
 
+import UserList
+
 import locale
 
-if sys.version_info[0] == 2:
-    str = unicode
-
 locale.setlocale(locale.LC_ALL, '')
 
 import logging
@@ -60,7 +55,15 @@
 domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.6.7"
+version = "1.5.5"
+
+# Always run in monochrome mode
+urwid.curses_display.curses.has_colors = lambda : False
+
+# Urwid doesn't support blinking, but we want it.  Since we have no
+# use for underline on its own, we make underline also always blink.
+urwid.curses_display.curses.A_UNDERLINE |= (
+    urwid.curses_display.curses.A_BLINK)
 
 def isoformat_to_datetime(iso):
     "Parse an ISO 8601 date string to a datetime.datetime()"
@@ -161,8 +164,8 @@
                                          self.rejected,
                                          client_interface,
                                          byte_arrays=True))
-        self.logger('Created client {0}'
-                    .format(self.properties["Name"]), level=0)
+        #self.logger('Created client {0}'
+        #            .format(self.properties["Name"]))
     
     def using_timer(self, flag):
         """Call this method with True or False when timer should be
@@ -179,9 +182,6 @@
     
     def checker_completed(self, exitstatus, condition, command):
         if exitstatus == 0:
-            self.logger('Checker for client {0} (command "{1}")'
-                        ' succeeded'.format(self.properties["Name"],
-                                            command), level=0)
             self.update()
             return
         # Checker failed
@@ -206,10 +206,12 @@
         self.update()
     
     def checker_started(self, command):
-        """Server signals that a checker started."""
-        self.logger('Client {0} started checker "{1}"'
-                    .format(self.properties["Name"],
-                            command), level=0)
+        """Server signals that a checker started. This could be useful
+           to log in the future. """
+        #self.logger('Client {0} started checker "{1}"'
+        #            .format(self.properties["Name"],
+        #                    unicode(command)))
+        pass
     
     def got_secret(self):
         self.logger('Client {0} received its secret'
@@ -277,7 +279,7 @@
                 message = "Approval in {0}. (d)eny?"
             else:
                 message = "Denial in {0}. (a)pprove?"
-            message = message.format(str(timer).rsplit(".", 1)[0])
+            message = message.format(unicode(timer).rsplit(".", 1)[0])
             self.using_timer(True)
         elif self.properties["LastCheckerStatus"] != 0:
             # When checker has failed, show timer until client expires
@@ -291,7 +293,7 @@
                             datetime.timedelta())
             message = ('A checker has failed! Time until client'
                        ' gets disabled: {0}'
-                       .format(str(timer).rsplit(".", 1)[0]))
+                       .format(unicode(timer).rsplit(".", 1)[0]))
             self.using_timer(True)
         else:
             message = "enabled"
@@ -380,7 +382,7 @@
     def property_changed(self, property=None, **kwargs):
         """Call self.update() if old value is not new value.
         This overrides the method from MandosClientPropertyCache"""
-        property_name = str(property)
+        property_name = unicode(property)
         old_value = self.properties.get(property_name)
         super(MandosClientWidget, self).property_changed(
             property=property, **kwargs)
@@ -404,7 +406,7 @@
     """This is the entire user interface - the whole screen
     with boxes, lists of client widgets, etc.
     """
-    def __init__(self, max_log_length=1000, log_level=1):
+    def __init__(self, max_log_length=1000):
         DBusGMainLoop(set_as_default=True)
         
         self.screen = urwid.curses_display.Screen()
@@ -413,21 +415,20 @@
                 ("normal",
                  "default", "default", None),
                 ("bold",
-                 "bold", "default", "bold"),
+                 "default", "default", "bold"),
                 ("underline-blink",
-                 "underline,blink", "default", "underline,blink"),
+                 "default", "default", "underline"),
                 ("standout",
-                 "standout", "default", "standout"),
+                 "default", "default", "standout"),
                 ("bold-underline-blink",
-                 "bold,underline,blink", "default", "bold,underline,blink"),
+                 "default", "default", ("bold", "underline")),
                 ("bold-standout",
-                 "bold,standout", "default", "bold,standout"),
+                 "default", "default", ("bold", "standout")),
                 ("underline-blink-standout",
-                 "underline,blink,standout", "default",
-                 "underline,blink,standout"),
+                 "default", "default", ("underline", "standout")),
                 ("bold-underline-blink-standout",
-                 "bold,underline,blink,standout", "default",
-                 "bold,underline,blink,standout"),
+                 "default", "default", ("bold", "underline",
+                                          "standout")),
                 ))
         
         if urwid.supports_unicode():
@@ -448,8 +449,6 @@
         self.log = []
         self.max_log_length = max_log_length
         
-        self.log_level = log_level
-        
         # We keep a reference to the log widget so we can remove it
         # from the ListWalker without it getting destroyed
         self.logbox = ConstrainedListBox(self.log)
@@ -489,18 +488,12 @@
             self.uilist.append(self.logbox)
         self.topwidget = urwid.Pile(self.uilist)
     
-    def log_message(self, message, level=1):
-        """Log message formatted with timestamp"""
-        if level < self.log_level:
-            return
+    def log_message(self, message):
         timestamp = datetime.datetime.now().isoformat()
-        self.log_message_raw("{0}: {1}".format(timestamp, message),
-                             level=level)
+        self.log_message_raw(timestamp + ": " + message)
     
-    def log_message_raw(self, markup, level=1):
+    def log_message_raw(self, markup):
         """Add a log message to the log buffer."""
-        if level < self.log_level:
-            return
         self.log.append(urwid.Text(markup, wrap=self.log_wrap))
         if (self.max_log_length
             and len(self.log) > self.max_log_length):
@@ -513,8 +506,8 @@
         """Toggle visibility of the log buffer."""
         self.log_visible = not self.log_visible
         self.rebuild()
-        self.log_message("Log visibility changed to: {0}"
-                         .format(self.log_visible), level=0)
+        #self.log_message("Log visibility changed to: "
+        #                 + unicode(self.log_visible))
     
     def change_log_display(self):
         """Change type of log display.
@@ -525,8 +518,7 @@
             self.log_wrap = "clip"
         for textwidget in self.log:
             textwidget.set_wrap_mode(self.log_wrap)
-        self.log_message("Wrap mode: {0}".format(self.log_wrap),
-                         level=0)
+        #self.log_message("Wrap mode: " + self.log_wrap)
     
     def find_and_remove_client(self, path, name):
         """Find a client by its object path and remove it.
@@ -561,7 +553,7 @@
         if path is None:
             path = client.proxy.object_path
         self.clients_dict[path] = client
-        self.clients.sort(key=lambda c: c.properties["Name"])
+        self.clients.sort(None, lambda c: c.properties["Name"])
         self.refresh()
     
     def remove_client(self, client, path=None):
@@ -569,6 +561,11 @@
         if path is None:
             path = client.proxy.object_path
         del self.clients_dict[path]
+        if not self.clients_dict:
+            # Work around bug in Urwid 0.9.8.3 - if a SimpleListWalker
+            # is completely emptied, we need to recreate it.
+            self.clients = urwid.SimpleListWalker([])
+            self.rebuild()
         self.refresh()
     
     def refresh(self):
@@ -587,10 +584,7 @@
         try:
             mandos_clients = (self.mandos_serv
                               .GetAllClientsWithProperties())
-            if not mandos_clients:
-                self.log_message_raw(("bold", "Note: Server has no clients."))
         except dbus.exceptions.DBusException:
-            self.log_message_raw(("bold", "Note: No Mandos server running."))
             mandos_clients = dbus.Dictionary()
         
         (self.mandos_serv
@@ -608,7 +602,7 @@
                             self.client_not_found,
                             dbus_interface=server_interface,
                             byte_arrays=True))
-        for path, client in mandos_clients.items():
+        for path, client in mandos_clients.iteritems():
             client_proxy_object = self.bus.get_object(self.busname,
                                                       path)
             self.add_client(MandosClientWidget(server_proxy_object
@@ -661,8 +655,7 @@
             elif key == "window resize":
                 self.size = self.screen.get_cols_rows()
                 self.refresh()
-            elif key == "ctrl l":
-                self.screen.clear()
+            elif key == "\f":  # Ctrl-L
                 self.refresh()
             elif key == "l" or key == "D":
                 self.toggle_log_display()
@@ -680,9 +673,7 @@
                                             "?: Help",
                                             "l: Log window toggle",
                                             "TAB: Switch window",
-                                            "w: Wrap (log lines)",
-                                            "v: Toggle verbose log",
-                                            ))))
+                                            "w: Wrap (log)"))))
                 self.log_message_raw(("bold",
                                       "  "
                                       .join(("Clients:",
@@ -701,13 +692,6 @@
                 else:
                     self.topwidget.set_focus(self.logbox)
                 self.refresh()
-            elif key == "v":
-                if self.log_level == 0:
-                    self.log_level = 1
-                    self.log_message("Verbose mode: Off")
-                else:
-                    self.log_level = 0
-                    self.log_message("Verbose mode: On")
             #elif (key == "end" or key == "meta >" or key == "G"
             #      or key == ">"):
             #    pass            # xxx end-of-buffer
@@ -736,7 +720,7 @@
     ui.run()
 except KeyboardInterrupt:
     ui.screen.stop()
-except Exception as e:
-    ui.log_message(str(e))
+except Exception, e:
+    ui.log_message(unicode(e))
     ui.screen.stop()
     raise

=== modified file 'mandos-monitor.xml'
--- mandos-monitor.xml	2014-07-14 21:41:08 +0000
+++ mandos-monitor.xml	2011-12-31 23:05:34 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-monitor">
-<!ENTITY TIMESTAMP "2014-07-14">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -129,10 +129,6 @@
 	<entry>Toggle log window line wrap</entry>
       </row>
       <row>
-	<entry>v</entry>
-	<entry>Toggle verbose logging</entry>
-      </row>
-      <row>
 	<entry>Up, Ctrl-P, k</entry>
 	<entry>Move up a line</entry>
       </row>

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2014-06-15 02:48:49 +0000
+++ mandos-options.xml	2012-06-17 14:55:31 +0000
@@ -46,24 +46,11 @@
     <emphasis>not</emphasis> run in debug mode.
   </para>
   
-  <para id="priority_compat">
-    GnuTLS priority string for the <acronym>TLS</acronym> handshake.
-    The default is <quote><literal
-    >SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:+SIGN-RSA-SHA224:</literal>
-    <literal>+SIGN-RSA-RMD160</literal></quote>.
-    See <citerefentry><refentrytitle
-    >gnutls_priority_init</refentrytitle>
-    <manvolnum>3</manvolnum></citerefentry> for the syntax.
-    <emphasis>Warning</emphasis>: changing this may make the
-    <acronym>TLS</acronym> handshake fail, making server-client
-    communication impossible.
-  </para>
-  
   <para id="priority">
     GnuTLS priority string for the <acronym>TLS</acronym> handshake.
     The default is <quote><literal
     >SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP</literal></quote>.  See
-    <citerefentry><refentrytitle >gnutls_priority_init</refentrytitle>
+    <citerefentry><refentrytitle>gnutls_priority_init</refentrytitle>
     <manvolnum>3</manvolnum></citerefentry> for the syntax.
     <emphasis>Warning</emphasis>: changing this may make the
     <acronym>TLS</acronym> handshake fail, making server-client
@@ -123,11 +110,4 @@
     implies this option.
   </para>
   
-  <para id="zeroconf">
-    This option controls whether the server will announce its
-    existence using Zeroconf.  Default is to use Zeroconf.  If
-    Zeroconf is not used, a <option>port</option> number or a
-    <option>socket</option> is required.
-  </para>
-  
 </section>

=== modified file 'mandos.conf'
--- mandos.conf	2014-06-15 02:48:49 +0000
+++ mandos.conf	2012-06-17 14:55:31 +0000
@@ -23,7 +23,7 @@
 ;debug = False
 
 # GnuTLS priority for the TLS handshake.  See gnutls_priority_init(3).
-;priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:+SIGN-RSA-SHA224:+SIGN-RSA-RMD160
+;priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP
 
 # Zeroconf service name.  You need to change this if you for some
 # reason want to run more than one server on the same *host*.
@@ -45,9 +45,3 @@
 
 # Whether to run in the foreground
 ;foreground = False
-
-# File descriptor number to use for network socket
-;socket = 
-
-# Whether to use ZeroConf; if false, requires port or socket
-;zeroconf = True

=== modified file 'mandos.conf.xml'
--- mandos.conf.xml	2013-10-24 20:21:45 +0000
+++ mandos.conf.xml	2012-05-26 22:21:17 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/mandos.conf</filename>">
-<!ENTITY TIMESTAMP "2013-10-23">
+<!ENTITY TIMESTAMP "2012-05-26">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -36,7 +36,6 @@
       <year>2009</year>
       <year>2011</year>
       <year>2012</year>
-      <year>2013</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -121,8 +120,7 @@
 	<term><option>priority<literal> = </literal><replaceable
 	>STRING</replaceable></option></term>
 	<listitem>
-	  <xi:include href="mandos-options.xml"
-                      xpointer="priority_compat"/>
+	  <xi:include href="mandos-options.xml" xpointer="priority"/>
 	</listitem>
       </varlistentry>
       

=== modified file 'mandos.lsm'
--- mandos.lsm	2014-07-17 03:24:57 +0000
+++ mandos.lsm	2012-06-01 18:39:03 +0000
@@ -1,23 +1,22 @@
 Begin4
 Title:		Mandos
-Version:	1.6.7
-Entered-date:	2014-07-17
+Version:	1.5.5
+Entered-date:	2012-06-01
 Description:	The Mandos system allows computers to have encrypted
-		root file systems and at the same time be capable of
-		remote and/or unattended reboots.
+root file systems and at the same time be capable of remote and/or
+unattended reboots.
 Keywords:	boot, encryption, luks, cryptsetup, network, openpgp,
-		tls, dm-crypt
+tls, dm-crypt
 Author:		teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
 Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
-Primary-site:	http://www.recompile.se/mandos
-		161K mandos_1.6.7.orig.tar.gz
-Alternate-site:	ftp://ftp.recompile.se/pub/mandos
-		161K mandos_1.6.7.orig.tar.gz
+Primary-site: http://www.recompile.se/mandos
+	      148K mandos_1.5.5.orig.tar.gz
+Alternate-site: ftp://ftp.recompile.se/pub/mandos
+		148K mandos_1.5.5.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
-		various other libraries.  While made for Debian
-		GNU/Linux, it is probably portable to other
-		distributions, but not other Unixes.
-Copying-policy:	GNU General Public License version 3.0 or later
+various other libraries.  While made for Debian GNU/Linux, it is
+probably portable to other distributions, but not other Unixes.
+Copying-policy: GNU General Public License version 3.0 or later
 End

=== removed file 'mandos.service'
--- mandos.service	2013-12-31 16:02:18 +0000
+++ mandos.service	1970-01-01 00:00:00 +0000
@@ -1,21 +0,0 @@
-[Unit]
-Description=Server of encrypted passwords to Mandos clients
-
-[Service]
-Type=simple
-## Type=dbus is not appropriate, because Mandos also needs to announce
-## its ZeroConf service and be reachable on the network.
-#Type=dbus
-BusName=se.recompile.Mandos
-# If you add --no-dbus, also comment out BusName above, and vice versa
-ExecStart=/usr/sbin/mandos --foreground
-Restart=always
-KillMode=process
-## Using socket activation won't work either, because systemd always
-## does bind() on the socket, and also won't announce the ZeroConf
-## service.
-#ExecStart=/usr/sbin/mandos --foreground --socket=0
-#StandardInput=socket
-
-[Install]
-WantedBy=multi-user.target

=== modified file 'mandos.xml'
--- mandos.xml	2014-06-15 02:48:49 +0000
+++ mandos.xml	2012-06-17 14:55:31 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2014-06-15">
+<!ENTITY TIMESTAMP "2012-06-17">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -36,7 +36,6 @@
       <year>2010</year>
       <year>2011</year>
       <year>2012</year>
-      <year>2013</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -106,8 +105,6 @@
       <replaceable>FD</replaceable></option></arg>
       <sbr/>
       <arg><option>--foreground</option></arg>
-      <sbr/>
-      <arg><option>--no-zeroconf</option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -236,8 +233,7 @@
 	<term><option>--priority <replaceable>
 	PRIORITY</replaceable></option></term>
 	<listitem>
-	  <xi:include href="mandos-options.xml"
-                      xpointer="priority_compat"/>
+	  <xi:include href="mandos-options.xml" xpointer="priority"/>
 	</listitem>
       </varlistentry>
       
@@ -325,13 +321,6 @@
 	</listitem>
       </varlistentry>
       
-      <varlistentry>
-	<term><option>--no-zeroconf</option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="zeroconf"/>
-	</listitem>
-      </varlistentry>
-      
     </variablelist>
   </refsect1>
   
@@ -527,15 +516,11 @@
 	</listitem>
       </varlistentry>
       <varlistentry>
-	<term><filename>/run/mandos.pid</filename></term>
+	<term><filename>/var/run/mandos.pid</filename></term>
 	<listitem>
 	  <para>
 	    The file containing the process id of the
 	    <command>&COMMANDNAME;</command> process started last.
-	    <emphasis >Note:</emphasis> If the <filename
-	    class="directory">/run</filename> directory does not
-	    exist, <filename>/var/run/mandos.pid</filename> will be
-	    used instead.
 	  </para>
 	</listitem>
       </varlistentry>

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2014-07-16 01:41:23 +0000
+++ plugin-runner.c	2011-12-31 23:05:34 +0000
@@ -2,8 +2,8 @@
 /*
  * Mandos plugin runner - Run Mandos plugins
  *
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2012 Teddy Hogeborn
+ * Copyright © 2008-2012 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -23,37 +23,38 @@
  */
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), getline(),
-				   O_CLOEXEC, pipe2() */
+				   asprintf(), O_CLOEXEC */
 #include <stddef.h>		/* size_t, NULL */
 #include <stdlib.h>		/* malloc(), exit(), EXIT_SUCCESS,
 				   realloc() */
 #include <stdbool.h>		/* bool, true, false */
 #include <stdio.h>		/* fileno(), fprintf(),
-				   stderr, STDOUT_FILENO, fclose() */
-#include <sys/types.h>	        /* fstat(), struct stat, waitpid(),
-				   WIFEXITED(), WEXITSTATUS(), wait(),
-				   pid_t, uid_t, gid_t, getuid(),
-				   getgid() */
+				   stderr, STDOUT_FILENO */
+#include <sys/types.h>	        /* DIR, fdopendir(), stat(), struct
+				   stat, waitpid(), WIFEXITED(),
+				   WEXITSTATUS(), wait(), pid_t,
+				   uid_t, gid_t, getuid(), getgid(),
+				   dirfd() */
 #include <sys/select.h>		/* fd_set, select(), FD_ZERO(),
 				   FD_SET(), FD_ISSET(), FD_CLR */
 #include <sys/wait.h>		/* wait(), waitpid(), WIFEXITED(),
 				   WEXITSTATUS(), WTERMSIG(),
 				   WCOREDUMP() */
-#include <sys/stat.h>		/* struct stat, fstat(), S_ISREG() */
+#include <sys/stat.h>		/* struct stat, stat(), S_ISREG() */
 #include <iso646.h>		/* and, or, not */
-#include <dirent.h>		/* struct dirent, scandirat() */
-#include <unistd.h>		/* fcntl(), F_GETFD, F_SETFD,
-				   FD_CLOEXEC, write(), STDOUT_FILENO,
-				   struct stat, fstat(), close(),
-				   setgid(), setuid(), S_ISREG(),
-				   faccessat() pipe2(), fork(),
-				   _exit(), dup2(), fexecve(), read()
-				*/
+#include <dirent.h>		/* DIR, struct dirent, fdopendir(),
+				   readdir(), closedir(), dirfd() */
+#include <unistd.h>		/* struct stat, stat(), S_ISREG(),
+				   fcntl(), setuid(), setgid(),
+				   F_GETFD, F_SETFD, FD_CLOEXEC,
+				   access(), pipe(), fork(), close()
+				   dup2(), STDOUT_FILENO, _exit(),
+				   execv(), write(), read(),
+				   close() */
 #include <fcntl.h>		/* fcntl(), F_GETFD, F_SETFD,
-				   FD_CLOEXEC, openat(), scandirat(),
-				   pipe2() */
-#include <string.h>		/* strsep, strlen(), strsignal(),
-				   strcmp(), strncmp() */
+				   FD_CLOEXEC */
+#include <string.h>		/* strsep, strlen(), asprintf(),
+				   strsignal(), strcmp(), strncmp() */
 #include <errno.h>		/* errno */
 #include <argp.h>		/* struct argp_option, struct
 				   argp_state, struct argp,
@@ -71,7 +72,6 @@
 				   EX_CONFIG, EX_UNAVAILABLE, EX_OK */
 #include <errno.h> 		/* errno */
 #include <error.h>		/* error() */
-#include <fnmatch.h>		/* fnmatch() */
 
 #define BUFFER_SIZE 256
 
@@ -105,7 +105,6 @@
 
 /* Gets an existing plugin based on name,
    or if none is found, creates a new one */
-__attribute__((warn_unused_result))
 static plugin *getplugin(char *name){
   /* Check for existing plugin with that name */
   for(plugin *p = plugin_list; p != NULL; p = p->next){
@@ -172,20 +171,18 @@
 }
 
 /* Helper function for add_argument and add_environment */
-__attribute__((nonnull, warn_unused_result))
+__attribute__((nonnull))
 static bool add_to_char_array(const char *new, char ***array,
 			      int *len){
   /* Resize the pointed-to array to hold one more pointer */
-  char **new_array = NULL;
   do {
-    new_array = realloc(*array, sizeof(char *)
-			* (size_t) ((*len) + 2));
-  } while(new_array == NULL and errno == EINTR);
+    *array = realloc(*array, sizeof(char *)
+		     * (size_t) ((*len) + 2));
+  } while(*array == NULL and errno == EINTR);
   /* Malloc check */
-  if(new_array == NULL){
+  if(*array == NULL){
     return false;
   }
-  *array = new_array;
   /* Make a copy of the new string */
   char *copy;
   do {
@@ -203,7 +200,7 @@
 }
 
 /* Add to a plugin's argument vector */
-__attribute__((nonnull(2), warn_unused_result))
+__attribute__((nonnull(2)))
 static bool add_argument(plugin *p, const char *arg){
   if(p == NULL){
     return false;
@@ -212,7 +209,7 @@
 }
 
 /* Add to a plugin's environment */
-__attribute__((nonnull(2), warn_unused_result))
+__attribute__((nonnull(2)))
 static bool add_environment(plugin *p, const char *def, bool replace){
   if(p == NULL){
     return false;
@@ -220,19 +217,19 @@
   /* namelen = length of name of environment variable */
   size_t namelen = (size_t)(strchrnul(def, '=') - def);
   /* Search for this environment variable */
-  for(char **envdef = p->environ; *envdef != NULL; envdef++){
-    if(strncmp(*envdef, def, namelen + 1) == 0){
+  for(char **e = p->environ; *e != NULL; e++){
+    if(strncmp(*e, def, namelen + 1) == 0){
       /* It already exists */
       if(replace){
-	char *new_envdef;
+	char *new;
 	do {
-	  new_envdef = realloc(*envdef, strlen(def) + 1);
-	} while(new_envdef == NULL and errno == EINTR);
-	if(new_envdef == NULL){
+	  new = realloc(*e, strlen(def) + 1);
+	} while(new == NULL and errno == EINTR);
+	if(new == NULL){
 	  return false;
 	}
-	*envdef = new_envdef;
-	strcpy(*envdef, def);
+	*e = new;
+	strcpy(*e, def);
       }
       return true;
     }
@@ -240,13 +237,11 @@
   return add_to_char_array(def, &(p->environ), &(p->envc));
 }
 
-#ifndef O_CLOEXEC
 /*
  * Based on the example in the GNU LibC manual chapter 13.13 "File
  * Descriptor Flags".
  | [[info:libc:Descriptor%20Flags][File Descriptor Flags]] |
  */
-__attribute__((warn_unused_result))
 static int set_cloexec_flag(int fd){
   int ret = (int)TEMP_FAILURE_RETRY(fcntl(fd, F_GETFD, 0));
   /* If reading the flags failed, return error indication now. */
@@ -257,7 +252,6 @@
   return (int)TEMP_FAILURE_RETRY(fcntl(fd, F_SETFD,
 				       ret | FD_CLOEXEC));
 }
-#endif	/* not O_CLOEXEC */
 
 
 /* Mark processes as completed when they exit, and save their exit
@@ -295,7 +289,7 @@
 }
 
 /* Prints out a password to stdout */
-__attribute__((nonnull, warn_unused_result))
+__attribute__((nonnull))
 static bool print_out_password(const char *buffer, size_t length){
   ssize_t ret;
   for(size_t written = 0; written < length; written += (size_t)ret){
@@ -349,7 +343,9 @@
   char *plugindir = NULL;
   char *argfile = NULL;
   FILE *conffp;
-  struct dirent **direntries = NULL;
+  size_t d_name_len;
+  DIR *dir = NULL;
+  struct dirent *dirst;
   struct stat st;
   fd_set rfds_all;
   int ret, maxfd = 0;
@@ -363,7 +359,6 @@
 				      .sa_flags = SA_NOCLDSTOP };
   char **custom_argv = NULL;
   int custom_argc = 0;
-  int dir_fd = -1;
   
   /* Establish a signal handler */
   sigemptyset(&sigchld_action.sa_mask);
@@ -440,13 +435,10 @@
 	    break;
 	  }
 	}
-	errno = 0;
       }
       break;
     case 'G':			/* --global-env */
-      if(add_environment(getplugin(NULL), arg, true)){
-	errno = 0;
-      }
+      add_environment(getplugin(NULL), arg, true);
       break;
     case 'o':			/* --options-for */
       {
@@ -469,7 +461,6 @@
 	    break;
 	  }
 	}
-	errno = 0;
       }
       break;
     case 'E':			/* --env-for */
@@ -487,9 +478,7 @@
 	  errno = EINVAL;
 	  break;
 	}
-	if(add_environment(getplugin(arg), envdef, true)){
-	  errno = 0;
-	}
+	add_environment(getplugin(arg), envdef, true);
       }
       break;
     case 'd':			/* --disable */
@@ -497,7 +486,6 @@
 	plugin *p = getplugin(arg);
 	if(p != NULL){
 	  p->disabled = true;
-	  errno = 0;
 	}
       }
       break;
@@ -506,16 +494,12 @@
 	plugin *p = getplugin(arg);
 	if(p != NULL){
 	  p->disabled = false;
-	  errno = 0;
 	}
       }
       break;
     case 128:			/* --plugin-dir */
       free(plugindir);
       plugindir = strdup(arg);
-      if(plugindir != NULL){
-	errno = 0;
-      }
       break;
     case 129:			/* --config-file */
       /* This is already done by parse_opt_config_file() */
@@ -529,7 +513,6 @@
 	break;
       }
       uid = (uid_t)tmp_id;
-      errno = 0;
       break;
     case 131:			/* --groupid */
       tmp_id = strtoimax(arg, &tmp, 10);
@@ -540,7 +523,6 @@
 	break;
       }
       gid = (gid_t)tmp_id;
-      errno = 0;
       break;
     case 132:			/* --debug */
       debug = true;
@@ -594,9 +576,6 @@
     case 129:			/* --config-file */
       free(argfile);
       argfile = strdup(arg);
-      if(argfile != NULL){
-	errno = 0;
-      }
       break;
     case 130:			/* --userid */
     case 131:			/* --groupid */
@@ -685,19 +664,13 @@
 	}
 	
 	custom_argc += 1;
-	{
-	  char **new_argv = realloc(custom_argv, sizeof(char *)
-				    * ((unsigned int)
-				       custom_argc + 1));
-	  if(new_argv == NULL){
-	    error(0, errno, "realloc");
-	    exitstatus = EX_OSERR;
-	    free(new_arg);
-	    free(org_line);
-	    goto fallback;
-	  } else {
-	    custom_argv = new_argv;
-	  }
+	custom_argv = realloc(custom_argv, sizeof(char *)
+			      * ((unsigned int) custom_argc + 1));
+	if(custom_argv == NULL){
+	  error(0, errno, "realloc");
+	  exitstatus = EX_OSERR;
+	  free(org_line);
+	  goto fallback;
 	}
 	custom_argv[custom_argc-1] = new_arg;
 	custom_argv[custom_argc] = NULL;
@@ -780,9 +753,7 @@
        <http://bugs.debian.org/633582> */
     int plugindir_fd = open(/* plugindir or */ PDIR, O_RDONLY);
     if(plugindir_fd == -1){
-      if(errno != ENOENT){
-	error(0, errno, "open(\"" PDIR "\")");
-      }
+      error(0, errno, "open");
     } else {
       ret = (int)TEMP_FAILURE_RETRY(fstat(plugindir_fd, &st));
       if(ret == -1){
@@ -800,7 +771,7 @@
   }
   
   /* Lower permissions */
-  ret = setgid(gid);
+  setgid(gid);
   if(ret == -1){
     error(0, errno, "setgid");
   }
@@ -811,13 +782,24 @@
   
   /* Open plugin directory with close_on_exec flag */
   {
-    dir_fd = open(plugindir != NULL ? plugindir : PDIR, O_RDONLY |
-#ifdef O_CLOEXEC
-		  O_CLOEXEC
-#else  /* not O_CLOEXEC */
-		  0
-#endif	/* not O_CLOEXEC */
-		  );
+    int dir_fd = -1;
+    if(plugindir == NULL){
+      dir_fd = open(PDIR, O_RDONLY |
+#ifdef O_CLOEXEC
+		    O_CLOEXEC
+#else  /* not O_CLOEXEC */
+		    0
+#endif	/* not O_CLOEXEC */
+		    );
+    } else {
+      dir_fd = open(plugindir, O_RDONLY |
+#ifdef O_CLOEXEC
+		    O_CLOEXEC
+#else  /* not O_CLOEXEC */
+		    0
+#endif	/* not O_CLOEXEC */
+		    );
+    }
     if(dir_fd == -1){
       error(0, errno, "Could not open plugin dir");
       exitstatus = EX_UNAVAILABLE;
@@ -829,104 +811,129 @@
     ret = set_cloexec_flag(dir_fd);
     if(ret < 0){
       error(0, errno, "set_cloexec_flag");
+      TEMP_FAILURE_RETRY(close(dir_fd));
       exitstatus = EX_OSERR;
       goto fallback;
     }
 #endif	/* O_CLOEXEC */
-  }
-  
-  int good_name(const struct dirent * const dirent){
-    const char * const patterns[] = { ".*", "#*#", "*~", "*.dpkg-new",
-				      "*.dpkg-old", "*.dpkg-bak",
-				      "*.dpkg-divert", NULL };
-#ifdef __GNUC__
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wcast-qual"
-#endif
-    for(const char **pat = (const char **)patterns;
-	*pat != NULL; pat++){
-#ifdef __GNUC__
-#pragma GCC diagnostic pop
-#endif
-      if(fnmatch(*pat, dirent->d_name, FNM_FILE_NAME | FNM_PERIOD)
-	 != FNM_NOMATCH){
-	if(debug){
-	    fprintf(stderr, "Ignoring plugin dir entry \"%s\""
-		    " matching pattern %s\n", dirent->d_name, *pat);
-	}
-	return 0;
-      }
+    
+    dir = fdopendir(dir_fd);
+    if(dir == NULL){
+      error(0, errno, "Could not open plugin dir");
+      TEMP_FAILURE_RETRY(close(dir_fd));
+      exitstatus = EX_OSERR;
+      goto fallback;
     }
-    return 1;
-  }
-  
-#ifdef __GLIBC__
-#if __GLIBC_PREREQ(2, 15)
-  int numplugins = scandirat(dir_fd, ".", &direntries, good_name,
-			     alphasort);
-#else  /* not __GLIBC_PREREQ(2, 15) */
-  int numplugins = scandir(plugindir != NULL ? plugindir : PDIR,
-			   &direntries, good_name, alphasort);
-#endif	/* not __GLIBC_PREREQ(2, 15) */
-#else	/* not __GLIBC__ */
-  int numplugins = scandir(plugindir != NULL ? plugindir : PDIR,
-			   &direntries, good_name, alphasort);
-#endif	/* not __GLIBC__ */
-  if(numplugins == -1){
-    error(0, errno, "Could not scan plugin dir");
-    direntries = NULL;
-    exitstatus = EX_OSERR;
-    goto fallback;
   }
   
   FD_ZERO(&rfds_all);
   
   /* Read and execute any executable in the plugin directory*/
-  for(int i = 0; i < numplugins; i++){
-    
-    int plugin_fd = openat(dir_fd, direntries[i]->d_name, O_RDONLY);
-    if(plugin_fd == -1){
-      error(0, errno, "Could not open plugin");
-      free(direntries[i]);
+  while(true){
+    do {
+      dirst = readdir(dir);
+    } while(dirst == NULL and errno == EINTR);
+    
+    /* All directory entries have been processed */
+    if(dirst == NULL){
+      if(errno == EBADF){
+	error(0, errno, "readdir");
+	exitstatus = EX_IOERR;
+	goto fallback;
+      }
+      break;
+    }
+    
+    d_name_len = strlen(dirst->d_name);
+    
+    /* Ignore dotfiles, backup files and other junk */
+    {
+      bool bad_name = false;
+      
+      const char const *bad_prefixes[] = { ".", "#", NULL };
+      
+      const char const *bad_suffixes[] = { "~", "#", ".dpkg-new",
+					   ".dpkg-old",
+					   ".dpkg-bak",
+					   ".dpkg-divert", NULL };
+      for(const char **pre = bad_prefixes; *pre != NULL; pre++){
+	size_t pre_len = strlen(*pre);
+	if((d_name_len >= pre_len)
+	   and strncmp((dirst->d_name), *pre, pre_len) == 0){
+	  if(debug){
+	    fprintf(stderr, "Ignoring plugin dir entry \"%s\""
+		    " with bad prefix %s\n", dirst->d_name, *pre);
+	  }
+	  bad_name = true;
+	  break;
+	}
+      }
+      if(bad_name){
+	continue;
+      }
+      for(const char **suf = bad_suffixes; *suf != NULL; suf++){
+	size_t suf_len = strlen(*suf);
+	if((d_name_len >= suf_len)
+	   and (strcmp((dirst->d_name) + d_name_len-suf_len, *suf)
+		== 0)){
+	  if(debug){
+	    fprintf(stderr, "Ignoring plugin dir entry \"%s\""
+		    " with bad suffix %s\n", dirst->d_name, *suf);
+	  }
+	  bad_name = true;
+	  break;
+	}
+      }
+      
+      if(bad_name){
+	continue;
+      }
+    }
+    
+    char *filename;
+    if(plugindir == NULL){
+      ret = (int)TEMP_FAILURE_RETRY(asprintf(&filename, PDIR "/%s",
+					     dirst->d_name));
+    } else {
+      ret = (int)TEMP_FAILURE_RETRY(asprintf(&filename, "%s/%s",
+					     plugindir,
+					     dirst->d_name));
+    }
+    if(ret < 0){
+      error(0, errno, "asprintf");
       continue;
     }
-    ret = (int)TEMP_FAILURE_RETRY(fstat(plugin_fd, &st));
+    
+    ret = (int)TEMP_FAILURE_RETRY(stat(filename, &st));
     if(ret == -1){
       error(0, errno, "stat");
-      TEMP_FAILURE_RETRY(close(plugin_fd));
-      free(direntries[i]);
+      free(filename);
       continue;
     }
     
     /* Ignore non-executable files */
     if(not S_ISREG(st.st_mode)
-       or (TEMP_FAILURE_RETRY(faccessat(dir_fd, direntries[i]->d_name,
-					X_OK, 0)) != 0)){
+       or (TEMP_FAILURE_RETRY(access(filename, X_OK)) != 0)){
       if(debug){
-	fprintf(stderr, "Ignoring plugin dir entry \"%s/%s\""
-		" with bad type or mode\n",
-		plugindir != NULL ? plugindir : PDIR,
-		direntries[i]->d_name);
+	fprintf(stderr, "Ignoring plugin dir entry \"%s\""
+		" with bad type or mode\n", filename);
       }
-      TEMP_FAILURE_RETRY(close(plugin_fd));
-      free(direntries[i]);
+      free(filename);
       continue;
     }
     
-    plugin *p = getplugin(direntries[i]->d_name);
+    plugin *p = getplugin(dirst->d_name);
     if(p == NULL){
       error(0, errno, "getplugin");
-      TEMP_FAILURE_RETRY(close(plugin_fd));
-      free(direntries[i]);
+      free(filename);
       continue;
     }
     if(p->disabled){
       if(debug){
 	fprintf(stderr, "Ignoring disabled plugin \"%s\"\n",
-		direntries[i]->d_name);
+		dirst->d_name);
       }
-      TEMP_FAILURE_RETRY(close(plugin_fd));
-      free(direntries[i]);
+      free(filename);
       continue;
     }
     {
@@ -946,8 +953,9 @@
 	}
       }
     }
-    /* If this plugin has any environment variables, we need to
-       duplicate the environment from this process, too. */
+    /* If this plugin has any environment variables, we will call
+       using execve and need to duplicate the environment from this
+       process, too. */
     if(p->environ[0] != NULL){
       for(char **e = environ; *e != NULL; e++){
 	if(not add_environment(p, *e, false)){
@@ -957,47 +965,25 @@
     }
     
     int pipefd[2];
-#ifndef O_CLOEXEC
     ret = (int)TEMP_FAILURE_RETRY(pipe(pipefd));
-#else  /* O_CLOEXEC */
-    ret = (int)TEMP_FAILURE_RETRY(pipe2(pipefd, O_CLOEXEC));
-#endif	/* O_CLOEXEC */
     if(ret == -1){
       error(0, errno, "pipe");
       exitstatus = EX_OSERR;
-      free(direntries[i]);
-      goto fallback;
-    }
-    if(pipefd[0] >= FD_SETSIZE){
-      fprintf(stderr, "pipe()[0] (%d) >= FD_SETSIZE (%d)", pipefd[0],
-	      FD_SETSIZE);
-      TEMP_FAILURE_RETRY(close(pipefd[0]));
-      TEMP_FAILURE_RETRY(close(pipefd[1]));
-      exitstatus = EX_OSERR;
-      free(direntries[i]);
-      goto fallback;
-    }
-#ifndef O_CLOEXEC
+      goto fallback;
+    }
     /* Ask OS to automatic close the pipe on exec */
     ret = set_cloexec_flag(pipefd[0]);
     if(ret < 0){
       error(0, errno, "set_cloexec_flag");
-      TEMP_FAILURE_RETRY(close(pipefd[0]));
-      TEMP_FAILURE_RETRY(close(pipefd[1]));
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
     ret = set_cloexec_flag(pipefd[1]);
     if(ret < 0){
       error(0, errno, "set_cloexec_flag");
-      TEMP_FAILURE_RETRY(close(pipefd[0]));
-      TEMP_FAILURE_RETRY(close(pipefd[1]));
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
-#endif	/* not O_CLOEXEC */
     /* Block SIGCHLD until process is safely in process list */
     ret = (int)TEMP_FAILURE_RETRY(sigprocmask(SIG_BLOCK,
 					      &sigchld_action.sa_mask,
@@ -1005,7 +991,6 @@
     if(ret < 0){
       error(0, errno, "sigprocmask");
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
     /* Starting a new process to be watched */
@@ -1015,12 +1000,7 @@
     } while(pid == -1 and errno == EINTR);
     if(pid == -1){
       error(0, errno, "fork");
-      TEMP_FAILURE_RETRY(sigprocmask(SIG_UNBLOCK,
-				     &sigchld_action.sa_mask, NULL));
-      TEMP_FAILURE_RETRY(close(pipefd[0]));
-      TEMP_FAILURE_RETRY(close(pipefd[1]));
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
     if(pid == 0){
@@ -1042,20 +1022,29 @@
 	_exit(EX_OSERR);
       }
       
-      if(fexecve(plugin_fd, p->argv,
-		(p->environ[0] != NULL) ? p->environ : environ) < 0){
-	error(0, errno, "fexecve for %s/%s",
-	      plugindir != NULL ? plugindir : PDIR,
-	      direntries[i]->d_name);
-	_exit(EX_OSERR);
+      if(dirfd(dir) < 0){
+	/* If dir has no file descriptor, we could not set FD_CLOEXEC
+	   above and must now close it manually here. */
+	closedir(dir);
+      }
+      if(p->environ[0] == NULL){
+	if(execv(filename, p->argv) < 0){
+	  error(0, errno, "execv for %s", filename);
+	  _exit(EX_OSERR);
+	}
+      } else {
+	if(execve(filename, p->argv, p->environ) < 0){
+	  error(0, errno, "execve for %s", filename);
+	  _exit(EX_OSERR);
+	}
       }
       /* no return */
     }
     /* Parent process */
     TEMP_FAILURE_RETRY(close(pipefd[1])); /* Close unused write end of
 					     pipe */
-    TEMP_FAILURE_RETRY(close(plugin_fd));
-    plugin *new_plugin = getplugin(direntries[i]->d_name);
+    free(filename);
+    plugin *new_plugin = getplugin(dirst->d_name);
     if(new_plugin == NULL){
       error(0, errno, "getplugin");
       ret = (int)(TEMP_FAILURE_RETRY
@@ -1065,10 +1054,8 @@
         error(0, errno, "sigprocmask");
       }
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
-    free(direntries[i]);
     
     new_plugin->pid = pid;
     new_plugin->fd = pipefd[0];
@@ -1084,30 +1071,16 @@
       goto fallback;
     }
     
-#if defined (__GNUC__) and defined (__GLIBC__)
-#if not __GLIBC_PREREQ(2, 16)
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wsign-conversion"
-#endif
-#endif
     FD_SET(new_plugin->fd, &rfds_all); /* Spurious warning from
-					  -Wconversion in GNU libc
-					  before 2.16 */
-#if defined (__GNUC__) and defined (__GLIBC__)
-#if not __GLIBC_PREREQ(2, 16)
-#pragma GCC diagnostic pop
-#endif
-#endif
+					  -Wconversion */
     
     if(maxfd < new_plugin->fd){
       maxfd = new_plugin->fd;
     }
   }
   
-  free(direntries);
-  direntries = NULL;
-  TEMP_FAILURE_RETRY(close(dir_fd));
-  dir_fd = -1;
+  TEMP_FAILURE_RETRY(closedir(dir));
+  dir = NULL;
   free_plugin(getplugin(NULL));
   
   for(plugin *p = plugin_list; p != NULL; p = p->next){
@@ -1159,20 +1132,8 @@
 	  }
 	  
 	  /* Remove the plugin */
-#if defined (__GNUC__) and defined (__GLIBC__)
-#if not __GLIBC_PREREQ(2, 16)
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wsign-conversion"
-#endif
-#endif
 	  FD_CLR(proc->fd, &rfds_all); /* Spurious warning from
-					  -Wconversion in GNU libc
-					  before 2.16 */
-#if defined (__GNUC__) and defined (__GLIBC__)
-#if not __GLIBC_PREREQ(2, 16)
-#pragma GCC diagnostic pop
-#endif
-#endif
+					  -Wconversion */
 	  
 	  /* Block signal while modifying process_list */
 	  ret = (int)TEMP_FAILURE_RETRY(sigprocmask
@@ -1218,37 +1179,22 @@
       }
       
       /* This process has not completed.  Does it have any output? */
-#if defined (__GNUC__) and defined (__GLIBC__)
-#if not __GLIBC_PREREQ(2, 16)
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wsign-conversion"
-#endif
-#endif
       if(proc->eof or not FD_ISSET(proc->fd, &rfds)){ /* Spurious
 							 warning from
-							 -Wconversion
-							 in GNU libc
-							 before
-							 2.16 */
-#if defined (__GNUC__) and defined (__GLIBC__)
-#if not __GLIBC_PREREQ(2, 16)
-#pragma GCC diagnostic pop
-#endif
-#endif
+							 -Wconversion */
 	/* This process had nothing to say at this time */
 	proc = proc->next;
 	continue;
       }
       /* Before reading, make the process' data buffer large enough */
       if(proc->buffer_length + BUFFER_SIZE > proc->buffer_size){
-	char *new_buffer = realloc(proc->buffer, proc->buffer_size
-				   + (size_t) BUFFER_SIZE);
-	if(new_buffer == NULL){
+	proc->buffer = realloc(proc->buffer, proc->buffer_size
+			       + (size_t) BUFFER_SIZE);
+	if(proc->buffer == NULL){
 	  error(0, errno, "malloc");
 	  exitstatus = EX_OSERR;
 	  goto fallback;
 	}
-	proc->buffer = new_buffer;
 	proc->buffer_size += BUFFER_SIZE;
       }
       /* Read from the process */
@@ -1307,10 +1253,8 @@
     free(custom_argv);
   }
   
-  free(direntries);
-  
-  if(dir_fd != -1){
-    TEMP_FAILURE_RETRY(close(dir_fd));
+  if(dir != NULL){
+    closedir(dir);
   }
   
   /* Kill the processes */

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2014-03-29 02:38:15 +0000
+++ plugins.d/askpass-fifo.c	2011-12-31 23:05:34 +0000
@@ -2,8 +2,8 @@
 /*
  * Askpass-FIFO - Read a password from a FIFO and output it
  * 
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2012 Teddy Hogeborn
+ * Copyright © 2008-2012 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -55,7 +55,7 @@
   
   va_start(ap, formatstring);
   ret = vasprintf(&text, formatstring, ap);
-  if(ret == -1){
+  if (ret == -1){
     fprintf(stderr, "Mandos plugin %s: ",
 	    program_invocation_short_name);
     vfprintf(stderr, formatstring, ap);

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2014-07-15 23:52:00 +0000
+++ plugins.d/mandos-client.c	2012-06-17 12:23:31 +0000
@@ -9,8 +9,8 @@
  * "browse_callback", and parts of "main".
  * 
  * Everything else is
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2012 Teddy Hogeborn
+ * Copyright © 2008-2012 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -32,15 +32,15 @@
 /* Needed by GPGME, specifically gpgme_data_seek() */
 #ifndef _LARGEFILE_SOURCE
 #define _LARGEFILE_SOURCE
-#endif	/* not _LARGEFILE_SOURCE */
+#endif
 #ifndef _FILE_OFFSET_BITS
 #define _FILE_OFFSET_BITS 64
-#endif	/* not _FILE_OFFSET_BITS */
+#endif
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), asprintf() */
 
 #include <stdio.h>		/* fprintf(), stderr, fwrite(),
-				   stdout, ferror() */
+				   stdout, ferror(), remove() */
 #include <stdint.h> 		/* uint16_t, uint32_t, intptr_t */
 #include <stddef.h>		/* NULL, size_t, ssize_t */
 #include <stdlib.h> 		/* free(), EXIT_SUCCESS, srand(),
@@ -55,9 +55,8 @@
 				   opendir(), DIR */
 #include <sys/stat.h>		/* open(), S_ISREG */
 #include <sys/socket.h>		/* socket(), struct sockaddr_in6,
-				   inet_pton(), connect(),
-				   getnameinfo() */
-#include <fcntl.h>		/* open(), unlinkat() */
+				   inet_pton(), connect() */
+#include <fcntl.h>		/* open() */
 #include <dirent.h>		/* opendir(), struct dirent, readdir()
 				 */
 #include <inttypes.h>		/* PRIu16, PRIdMAX, intmax_t,
@@ -73,9 +72,8 @@
 				*/
 #include <unistd.h>		/* close(), SEEK_SET, off_t, write(),
 				   getuid(), getgid(), seteuid(),
-				   setgid(), pause(), _exit(),
-				   unlinkat() */
-#include <arpa/inet.h>		/* inet_pton(), htons() */
+				   setgid(), pause(), _exit() */
+#include <arpa/inet.h>		/* inet_pton(), htons, inet_ntop() */
 #include <iso646.h>		/* not, or, and */
 #include <argp.h>		/* struct argp_option, error_t, struct
 				   argp_state, struct argp,
@@ -93,8 +91,6 @@
 				   argz_delete(), argz_append(),
 				   argz_stringify(), argz_add(),
 				   argz_count() */
-#include <netdb.h>		/* getnameinfo(), NI_NUMERICHOST,
-				   EAI_SYSTEM, gai_strerror() */
 
 #ifdef __linux__
 #include <sys/klog.h> 		/* klogctl() */
@@ -142,7 +138,6 @@
 static const char sys_class_net[] = "/sys/class/net";
 char *connect_to = NULL;
 const char *hookdir = HOOKDIR;
-int hookdir_fd = -1;
 uid_t uid = 65534;
 gid_t gid = 65534;
 
@@ -185,14 +180,14 @@
   perror(print_text);
 }
 
-__attribute__((format (gnu_printf, 2, 3), nonnull))
+__attribute__((format (gnu_printf, 2, 3)))
 int fprintf_plus(FILE *stream, const char *format, ...){
   va_list ap;
   va_start (ap, format);
   
   TEMP_FAILURE_RETRY(fprintf(stream, "Mandos plugin %s: ",
 			     program_invocation_short_name));
-  return (int)TEMP_FAILURE_RETRY(vfprintf(stream, format, ap));
+  return TEMP_FAILURE_RETRY(vfprintf(stream, format, ap));
 }
 
 /*
@@ -200,26 +195,19 @@
  * bytes. "buffer_capacity" is how much is currently allocated,
  * "buffer_length" is how much is already used.
  */
-__attribute__((nonnull, warn_unused_result))
 size_t incbuffer(char **buffer, size_t buffer_length,
 		 size_t buffer_capacity){
   if(buffer_length + BUFFER_SIZE > buffer_capacity){
-    char *new_buf = realloc(*buffer, buffer_capacity + BUFFER_SIZE);
-    if(new_buf == NULL){
-      int old_errno = errno;
-      free(*buffer);
-      errno = old_errno;
-      *buffer = NULL;
+    *buffer = realloc(*buffer, buffer_capacity + BUFFER_SIZE);
+    if(buffer == NULL){
       return 0;
     }
-    *buffer = new_buf;
     buffer_capacity += BUFFER_SIZE;
   }
   return buffer_capacity;
 }
 
 /* Add server to set of servers to retry periodically */
-__attribute__((nonnull, warn_unused_result))
 bool add_server(const char *ip, in_port_t port, AvahiIfIndex if_index,
 		int af, server **current_server){
   int ret;
@@ -234,21 +222,6 @@
 			  .af = af };
   if(new_server->ip == NULL){
     perror_plus("strdup");
-    free(new_server);
-    return false;
-  }
-  ret = clock_gettime(CLOCK_MONOTONIC, &(new_server->last_seen));
-  if(ret == -1){
-    perror_plus("clock_gettime");
-#ifdef __GNUC__
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wcast-qual"
-#endif
-    free((char *)(new_server->ip));
-#ifdef __GNUC__
-#pragma GCC diagnostic pop
-#endif
-    free(new_server);
     return false;
   }
   /* Special case of first server */
@@ -256,31 +229,33 @@
     new_server->next = new_server;
     new_server->prev = new_server;
     *current_server = new_server;
+  /* Place the new server last in the list */
   } else {
-    /* Place the new server last in the list */
     new_server->next = *current_server;
     new_server->prev = (*current_server)->prev;
     new_server->prev->next = new_server;
     (*current_server)->prev = new_server;
   }
+  ret = clock_gettime(CLOCK_MONOTONIC, &(*current_server)->last_seen);
+  if(ret == -1){
+    perror_plus("clock_gettime");
+    return false;
+  }
   return true;
 }
 
 /* 
  * Initialize GPGME.
  */
-__attribute__((nonnull, warn_unused_result))
-static bool init_gpgme(const char * const seckey,
-		       const char * const pubkey,
-		       const char * const tempdir,
-		       mandos_context *mc){
+static bool init_gpgme(const char *seckey, const char *pubkey,
+		       const char *tempdir, mandos_context *mc){
   gpgme_error_t rc;
   gpgme_engine_info_t engine_info;
   
   /*
    * Helper function to insert pub and seckey to the engine keyring.
    */
-  bool import_key(const char * const filename){
+  bool import_key(const char *filename){
     int ret;
     int fd;
     gpgme_data_t pgp_data;
@@ -367,7 +342,6 @@
  * Decrypt OpenPGP data.
  * Returns -1 on error
  */
-__attribute__((nonnull, warn_unused_result))
 static ssize_t pgp_packet_decrypt(const char *cryptotext,
 				  size_t crypto_size,
 				  char **plaintext,
@@ -493,8 +467,7 @@
   return plaintext_length;
 }
 
-__attribute__((warn_unused_result))
-static const char *safer_gnutls_strerror(int value){
+static const char * safer_gnutls_strerror(int value){
   const char *ret = gnutls_strerror(value);
   if(ret == NULL)
     ret = "(unknown)";
@@ -502,13 +475,11 @@
 }
 
 /* GnuTLS log function callback */
-__attribute__((nonnull))
 static void debuggnutls(__attribute__((unused)) int level,
 			const char* string){
   fprintf_plus(stderr, "GnuTLS: %s", string);
 }
 
-__attribute__((nonnull, warn_unused_result))
 static int init_gnutls_global(const char *pubkeyfilename,
 			      const char *seckeyfilename,
 			      mandos_context *mc){
@@ -588,7 +559,6 @@
   return -1;
 }
 
-__attribute__((nonnull, warn_unused_result))
 static int init_gnutls_session(gnutls_session_t *session,
 			       mandos_context *mc){
   int ret;
@@ -651,13 +621,15 @@
 		      __attribute__((unused)) const char *txt){}
 
 /* Called when a Mandos server is found */
-__attribute__((nonnull, warn_unused_result))
 static int start_mandos_communication(const char *ip, in_port_t port,
 				      AvahiIfIndex if_index,
 				      int af, mandos_context *mc){
   int ret, tcp_sd = -1;
   ssize_t sret;
-  struct sockaddr_storage to;
+  union {
+    struct sockaddr_in in;
+    struct sockaddr_in6 in6;
+  } to;
   char *buffer = NULL;
   char *decrypted_buffer = NULL;
   size_t buffer_length = 0;
@@ -744,11 +716,11 @@
   
   memset(&to, 0, sizeof(to));
   if(af == AF_INET6){
-    ((struct sockaddr_in6 *)&to)->sin6_family = (sa_family_t)af;
-    ret = inet_pton(af, ip, &((struct sockaddr_in6 *)&to)->sin6_addr);
+    to.in6.sin6_family = (sa_family_t)af;
+    ret = inet_pton(af, ip, &to.in6.sin6_addr);
   } else {			/* IPv4 */
-    ((struct sockaddr_in *)&to)->sin_family = (sa_family_t)af;
-    ret = inet_pton(af, ip, &((struct sockaddr_in *)&to)->sin_addr);
+    to.in.sin_family = (sa_family_t)af;
+    ret = inet_pton(af, ip, &to.in.sin_addr);
   }
   if(ret < 0 ){
     int e = errno;
@@ -763,9 +735,10 @@
     goto mandos_end;
   }
   if(af == AF_INET6){
-    ((struct sockaddr_in6 *)&to)->sin6_port = htons(port);
-    if(IN6_IS_ADDR_LINKLOCAL
-       (&((struct sockaddr_in6 *)&to)->sin6_addr)){
+    to.in6.sin6_port = htons(port);    
+    if(IN6_IS_ADDR_LINKLOCAL /* Spurious warnings from */
+       (&to.in6.sin6_addr)){ /* -Wstrict-aliasing=2 or lower and
+				-Wunreachable-code*/
       if(if_index == AVAHI_IF_UNSPEC){
 	fprintf_plus(stderr, "An IPv6 link-local address is"
 		     " incomplete without a network interface\n");
@@ -773,10 +746,12 @@
 	goto mandos_end;
       }
       /* Set the network interface number as scope */
-      ((struct sockaddr_in6 *)&to)->sin6_scope_id = (uint32_t)if_index;
+      to.in6.sin6_scope_id = (uint32_t)if_index;
     }
   } else {
-    ((struct sockaddr_in *)&to)->sin_port = htons(port);
+    to.in.sin_port = htons(port); /* Spurious warnings from
+				     -Wconversion and
+				     -Wunreachable-code */
   }
   
   if(quit_now){
@@ -799,23 +774,20 @@
     }
     char addrstr[(INET_ADDRSTRLEN > INET6_ADDRSTRLEN) ?
 		 INET_ADDRSTRLEN : INET6_ADDRSTRLEN] = "";
+    const char *pcret;
     if(af == AF_INET6){
-      ret = getnameinfo((struct sockaddr *)&to,
-			sizeof(struct sockaddr_in6),
-			addrstr, sizeof(addrstr), NULL, 0,
-			NI_NUMERICHOST);
+      pcret = inet_ntop(af, &(to.in6.sin6_addr), addrstr,
+			sizeof(addrstr));
     } else {
-      ret = getnameinfo((struct sockaddr *)&to,
-			sizeof(struct sockaddr_in),
-			addrstr, sizeof(addrstr), NULL, 0,
-			NI_NUMERICHOST);
+      pcret = inet_ntop(af, &(to.in.sin_addr), addrstr,
+			sizeof(addrstr));
     }
-    if(ret == EAI_SYSTEM){
-      perror_plus("getnameinfo");
-    } else if(ret != 0) {
-      fprintf_plus(stderr, "getnameinfo: %s", gai_strerror(ret));
-    } else if(strcmp(addrstr, ip) != 0){
-      fprintf_plus(stderr, "Canonical address form: %s\n", addrstr);
+    if(pcret == NULL){
+      perror_plus("inet_ntop");
+    } else {
+      if(strcmp(addrstr, ip) != 0){
+	fprintf_plus(stderr, "Canonical address form: %s\n", addrstr);
+      }
     }
   }
   
@@ -825,14 +797,12 @@
   }
   
   if(af == AF_INET6){
-    ret = connect(tcp_sd, (struct sockaddr *)&to,
-		  sizeof(struct sockaddr_in6));
+    ret = connect(tcp_sd, &to.in6, sizeof(to));
   } else {
-    ret = connect(tcp_sd, (struct sockaddr *)&to, /* IPv4 */
-		  sizeof(struct sockaddr_in));
+    ret = connect(tcp_sd, &to.in, sizeof(to)); /* IPv4 */
   }
   if(ret < 0){
-    if((errno != ECONNREFUSED and errno != ENETUNREACH) or debug){
+    if ((errno != ECONNREFUSED and errno != ENETUNREACH) or debug){
       int e = errno;
       perror_plus("connect");
       errno = e;
@@ -1053,7 +1023,6 @@
   return retval;
 }
 
-__attribute__((nonnull))
 static void resolve_callback(AvahiSServiceResolver *r,
 			     AvahiIfIndex interface,
 			     AvahiProtocol proto,
@@ -1067,7 +1036,7 @@
 			     AVAHI_GCC_UNUSED AvahiStringList *txt,
 			     AVAHI_GCC_UNUSED AvahiLookupResultFlags
 			     flags,
-			     void *mc){
+			     void* mc){
   if(r == NULL){
     return;
   }
@@ -1076,7 +1045,6 @@
      timed out */
   
   if(quit_now){
-    avahi_s_service_resolver_free(r);
     return;
   }
   
@@ -1127,7 +1095,7 @@
 			    const char *domain,
 			    AVAHI_GCC_UNUSED AvahiLookupResultFlags
 			    flags,
-			    void *mc){
+			    void* mc){
   if(b == NULL){
     return;
   }
@@ -1193,7 +1161,6 @@
   errno = old_errno;
 }
 
-__attribute__((nonnull, warn_unused_result))
 bool get_flags(const char *ifname, struct ifreq *ifr){
   int ret;
   error_t ret_errno;
@@ -1218,7 +1185,6 @@
   return true;
 }
 
-__attribute__((nonnull, warn_unused_result))
 bool good_flags(const char *ifname, const struct ifreq *ifr){
   
   /* Reject the loopback device */
@@ -1266,7 +1232,6 @@
  * corresponds to an acceptable network device.
  * (This function is passed to scandir(3) as a filter function.)
  */
-__attribute__((nonnull, warn_unused_result))
 int good_interface(const struct dirent *if_entry){
   if(if_entry->d_name[0] == '.'){
     return 0;
@@ -1290,7 +1255,6 @@
 /* 
  * This function determines if a network interface is up.
  */
-__attribute__((nonnull, warn_unused_result))
 bool interface_is_up(const char *interface){
   struct ifreq ifr;
   if(not get_flags(interface, &ifr)){
@@ -1307,7 +1271,6 @@
 /* 
  * This function determines if a network interface is running
  */
-__attribute__((nonnull, warn_unused_result))
 bool interface_is_running(const char *interface){
   struct ifreq ifr;
   if(not get_flags(interface, &ifr)){
@@ -1321,7 +1284,6 @@
   return (bool)(ifr.ifr_flags & IFF_RUNNING);
 }
 
-__attribute__((nonnull, pure, warn_unused_result))
 int notdotentries(const struct dirent *direntry){
   /* Skip "." and ".." */
   if(direntry->d_name[0] == '.'
@@ -1334,7 +1296,6 @@
 }
 
 /* Is this directory entry a runnable program? */
-__attribute__((nonnull, warn_unused_result))
 int runnable_hook(const struct dirent *direntry){
   int ret;
   size_t sret;
@@ -1348,7 +1309,7 @@
   sret = strspn(direntry->d_name, "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
 		"abcdefghijklmnopqrstuvwxyz"
 		"0123456789"
-		"_.-");
+		"_-");
   if((direntry->d_name)[sret] != '\0'){
     /* Contains non-allowed characters */
     if(debug){
@@ -1358,7 +1319,14 @@
     return 0;
   }
   
-  ret = fstatat(hookdir_fd, direntry->d_name, &st, 0);
+  char *fullname = NULL;
+  ret = asprintf(&fullname, "%s/%s", hookdir, direntry->d_name);
+  if(ret < 0){
+    perror_plus("asprintf");
+    return 0;
+  }
+  
+  ret = stat(fullname, &st);
   if(ret == -1){
     if(debug){
       perror_plus("Could not stat hook");
@@ -1388,7 +1356,6 @@
   return 1;
 }
 
-__attribute__((nonnull, warn_unused_result))
 int avahi_loop_with_timeout(AvahiSimplePoll *s, int retry_interval,
 			    mandos_context *mc){
   int ret;
@@ -1398,13 +1365,13 @@
   
   while(true){
     if(mc->current_server == NULL){
-      if(debug){
+      if (debug){
 	fprintf_plus(stderr, "Wait until first server is found."
 		     " No timeout!\n");
       }
       ret = avahi_simple_poll_iterate(s, -1);
     } else {
-      if(debug){
+      if (debug){
 	fprintf_plus(stderr, "Check current_server if we should run"
 		     " it, or wait\n");
       }
@@ -1427,7 +1394,7 @@
 		     - ((intmax_t)waited_time.tv_sec * 1000))
 		    - ((intmax_t)waited_time.tv_nsec / 1000000));
       
-      if(debug){
+      if (debug){
 	fprintf_plus(stderr, "Blocking for %" PRIdMAX " ms\n",
 		     block_time);
       }
@@ -1455,7 +1422,7 @@
       ret = avahi_simple_poll_iterate(s, (int)block_time);
     }
     if(ret != 0){
-      if(ret > 0 or errno != EINTR){
+      if (ret > 0 or errno != EINTR){
 	return (ret != 1) ? ret : 0;
       }
     }
@@ -1463,19 +1430,18 @@
 }
 
 /* Set effective uid to 0, return errno */
-__attribute__((warn_unused_result))
 error_t raise_privileges(void){
   error_t old_errno = errno;
   error_t ret_errno = 0;
   if(seteuid(0) == -1){
     ret_errno = errno;
+    perror_plus("seteuid");
   }
   errno = old_errno;
   return ret_errno;
 }
 
 /* Set effective and real user ID to 0.  Return errno. */
-__attribute__((warn_unused_result))
 error_t raise_privileges_permanently(void){
   error_t old_errno = errno;
   error_t ret_errno = raise_privileges();
@@ -1485,218 +1451,175 @@
   }
   if(setuid(0) == -1){
     ret_errno = errno;
+    perror_plus("seteuid");
   }
   errno = old_errno;
   return ret_errno;
 }
 
 /* Set effective user ID to unprivileged saved user ID */
-__attribute__((warn_unused_result))
 error_t lower_privileges(void){
   error_t old_errno = errno;
   error_t ret_errno = 0;
   if(seteuid(uid) == -1){
     ret_errno = errno;
+    perror_plus("seteuid");
   }
   errno = old_errno;
   return ret_errno;
 }
 
 /* Lower privileges permanently */
-__attribute__((warn_unused_result))
 error_t lower_privileges_permanently(void){
   error_t old_errno = errno;
   error_t ret_errno = 0;
   if(setuid(uid) == -1){
     ret_errno = errno;
+    perror_plus("setuid");
   }
   errno = old_errno;
   return ret_errno;
 }
 
-__attribute__((nonnull))
-void run_network_hooks(const char *mode, const char *interface,
+bool run_network_hooks(const char *mode, const char *interface,
 		       const float delay){
-  struct dirent **direntries = NULL;
-  if(hookdir_fd == -1){
-    hookdir_fd = open(hookdir, O_RDONLY);
-    if(hookdir_fd == -1){
-      if(errno == ENOENT){
-	if(debug){
-	  fprintf_plus(stderr, "Network hook directory \"%s\" not"
-		       " found\n", hookdir);
-	}
-      } else {
-	perror_plus("open");
-      }
-      return;
-    }
-  }
-#ifdef __GLIBC__
-#if __GLIBC_PREREQ(2, 15)
-  int numhooks = scandirat(hookdir_fd, ".", &direntries,
-			   runnable_hook, alphasort);
-#else  /* not __GLIBC_PREREQ(2, 15) */
-  int numhooks = scandir(hookdir, &direntries, runnable_hook,
-			 alphasort);
-#endif	/* not __GLIBC_PREREQ(2, 15) */
-#else	/* not __GLIBC__ */
-  int numhooks = scandir(hookdir, &direntries, runnable_hook,
-			 alphasort);
-#endif	/* not __GLIBC__ */
+  struct dirent **direntries;
+  struct dirent *direntry;
+  int ret;
+  int numhooks = scandir(hookdir, &direntries, runnable_hook,
+			 alphasort);
   if(numhooks == -1){
-    perror_plus("scandir");
-    return;
-  }
-  struct dirent *direntry;
-  int ret;
-  int devnull = open("/dev/null", O_RDONLY);
-  for(int i = 0; i < numhooks; i++){
-    direntry = direntries[i];
-    if(debug){
-      fprintf_plus(stderr, "Running network hook \"%s\"\n",
-		   direntry->d_name);
+    if(errno == ENOENT){
+      if(debug){
+	fprintf_plus(stderr, "Network hook directory \"%s\" not"
+		     " found\n", hookdir);
+      }
+    } else {
+      perror_plus("scandir");
     }
-    pid_t hook_pid = fork();
-    if(hook_pid == 0){
-      /* Child */
-      /* Raise privileges */
-      errno = raise_privileges_permanently();
-      if(errno != 0){
-	perror_plus("Failed to raise privileges");
-	_exit(EX_NOPERM);
-      }
-      /* Set group */
-      errno = 0;
-      ret = setgid(0);
-      if(ret == -1){
-	perror_plus("setgid");
-	_exit(EX_NOPERM);
-      }
-      /* Reset supplementary groups */
-      errno = 0;
-      ret = setgroups(0, NULL);
-      if(ret == -1){
-	perror_plus("setgroups");
-	_exit(EX_NOPERM);
-      }
-      ret = dup2(devnull, STDIN_FILENO);
-      if(ret == -1){
-	perror_plus("dup2(devnull, STDIN_FILENO)");
-	_exit(EX_OSERR);
-      }
-      ret = close(devnull);
-      if(ret == -1){
-	perror_plus("close");
-	_exit(EX_OSERR);
-      }
-      ret = dup2(STDERR_FILENO, STDOUT_FILENO);
-      if(ret == -1){
-	perror_plus("dup2(STDERR_FILENO, STDOUT_FILENO)");
-	_exit(EX_OSERR);
-      }
-      ret = setenv("MANDOSNETHOOKDIR", hookdir, 1);
-      if(ret == -1){
-	perror_plus("setenv");
-	_exit(EX_OSERR);
-      }
-      ret = setenv("DEVICE", interface, 1);
-      if(ret == -1){
-	perror_plus("setenv");
-	_exit(EX_OSERR);
-      }
-      ret = setenv("VERBOSITY", debug ? "1" : "0", 1);
-      if(ret == -1){
-	perror_plus("setenv");
-	_exit(EX_OSERR);
-      }
-      ret = setenv("MODE", mode, 1);
-      if(ret == -1){
-	perror_plus("setenv");
-	_exit(EX_OSERR);
-      }
-      char *delaystring;
-      ret = asprintf(&delaystring, "%f", (double)delay);
-      if(ret == -1){
+  } else {
+    int devnull = open("/dev/null", O_RDONLY);
+    for(int i = 0; i < numhooks; i++){
+      direntry = direntries[i];
+      char *fullname = NULL;
+      ret = asprintf(&fullname, "%s/%s", hookdir, direntry->d_name);
+      if(ret < 0){
 	perror_plus("asprintf");
-	_exit(EX_OSERR);
-      }
-      ret = setenv("DELAY", delaystring, 1);
-      if(ret == -1){
+	continue;
+      }
+      if(debug){
+	fprintf_plus(stderr, "Running network hook \"%s\"\n",
+		     direntry->d_name);
+      }
+      pid_t hook_pid = fork();
+      if(hook_pid == 0){
+	/* Child */
+	/* Raise privileges */
+	raise_privileges_permanently();
+	/* Set group */
+	errno = 0;
+	ret = setgid(0);
+	if(ret == -1){
+	  perror_plus("setgid");
+	}
+	/* Reset supplementary groups */
+	errno = 0;
+	ret = setgroups(0, NULL);
+	if(ret == -1){
+	  perror_plus("setgroups");
+	}
+	dup2(devnull, STDIN_FILENO);
+	close(devnull);
+	dup2(STDERR_FILENO, STDOUT_FILENO);
+	ret = setenv("MANDOSNETHOOKDIR", hookdir, 1);
+	if(ret == -1){
+	  perror_plus("setenv");
+	  _exit(EX_OSERR);
+	}
+	ret = setenv("DEVICE", interface, 1);
+	if(ret == -1){
+	  perror_plus("setenv");
+	  _exit(EX_OSERR);
+	}
+	ret = setenv("VERBOSITY", debug ? "1" : "0", 1);
+	if(ret == -1){
+	  perror_plus("setenv");
+	  _exit(EX_OSERR);
+	}
+	ret = setenv("MODE", mode, 1);
+	if(ret == -1){
+	  perror_plus("setenv");
+	  _exit(EX_OSERR);
+	}
+	char *delaystring;
+	ret = asprintf(&delaystring, "%f", delay);
+	if(ret == -1){
+	  perror_plus("asprintf");
+	  _exit(EX_OSERR);
+	}
+	ret = setenv("DELAY", delaystring, 1);
+	if(ret == -1){
+	  free(delaystring);
+	  perror_plus("setenv");
+	  _exit(EX_OSERR);
+	}
 	free(delaystring);
-	perror_plus("setenv");
-	_exit(EX_OSERR);
-      }
-      free(delaystring);
-      if(connect_to != NULL){
-	ret = setenv("CONNECT", connect_to, 1);
-	if(ret == -1){
-	  perror_plus("setenv");
-	  _exit(EX_OSERR);
-	}
-      }
-      int hook_fd = openat(hookdir_fd, direntry->d_name, O_RDONLY);
-      if(hook_fd == -1){
-	perror_plus("openat");
-	_exit(EXIT_FAILURE);
-      }
-      if((int)TEMP_FAILURE_RETRY(close(hookdir_fd)) == -1){
-	perror_plus("close");
-	_exit(EXIT_FAILURE);
-      }
-      if(fexecve(hook_fd, (char *const []){ direntry->d_name, NULL },
-		 environ) == -1){
-	perror_plus("fexecve");
-	_exit(EXIT_FAILURE);
-      }
-    } else {
-      int status;
-      if(TEMP_FAILURE_RETRY(waitpid(hook_pid, &status, 0)) == -1){
-	perror_plus("waitpid");
-	free(direntry);
-	continue;
-      }
-      if(WIFEXITED(status)){
-	if(WEXITSTATUS(status) != 0){
-	  fprintf_plus(stderr, "Warning: network hook \"%s\" exited"
-		       " with status %d\n", direntry->d_name,
-		       WEXITSTATUS(status));
-	  free(direntry);
-	  continue;
-	}
-      } else if(WIFSIGNALED(status)){
-	fprintf_plus(stderr, "Warning: network hook \"%s\" died by"
-		     " signal %d\n", direntry->d_name,
-		     WTERMSIG(status));
-	free(direntry);
-	continue;
+	if(connect_to != NULL){
+	  ret = setenv("CONNECT", connect_to, 1);
+	  if(ret == -1){
+	    perror_plus("setenv");
+	    _exit(EX_OSERR);
+	  }
+	}
+	if(execl(fullname, direntry->d_name, mode, NULL) == -1){
+	  perror_plus("execl");
+	  _exit(EXIT_FAILURE);
+	}
       } else {
-	fprintf_plus(stderr, "Warning: network hook \"%s\""
-		     " crashed\n", direntry->d_name);
-	free(direntry);
-	continue;
-      }
-    }
-    if(debug){
-      fprintf_plus(stderr, "Network hook \"%s\" ran successfully\n",
-		   direntry->d_name);
-    }
-    free(direntry);
-  }
-  free(direntries);
-  if((int)TEMP_FAILURE_RETRY(close(hookdir_fd)) == -1){
-    perror_plus("close");
-  } else {
-    hookdir_fd = -1;
-  }
-  close(devnull);
+	int status;
+	if(TEMP_FAILURE_RETRY(waitpid(hook_pid, &status, 0)) == -1){
+	  perror_plus("waitpid");
+	  free(fullname);
+	  continue;
+	}
+	if(WIFEXITED(status)){
+	  if(WEXITSTATUS(status) != 0){
+	    fprintf_plus(stderr, "Warning: network hook \"%s\" exited"
+			 " with status %d\n", direntry->d_name,
+			 WEXITSTATUS(status));
+	    free(fullname);
+	    continue;
+	  }
+	} else if(WIFSIGNALED(status)){
+	  fprintf_plus(stderr, "Warning: network hook \"%s\" died by"
+		       " signal %d\n", direntry->d_name,
+		       WTERMSIG(status));
+	  free(fullname);
+	  continue;
+	} else {
+	  fprintf_plus(stderr, "Warning: network hook \"%s\""
+		       " crashed\n", direntry->d_name);
+	  free(fullname);
+	  continue;
+	}
+      }
+      free(fullname);
+      if(debug){
+	fprintf_plus(stderr, "Network hook \"%s\" ran successfully\n",
+		     direntry->d_name);
+      }
+    }
+    close(devnull);
+  }
+  return true;
 }
 
-__attribute__((nonnull, warn_unused_result))
 error_t bring_up_interface(const char *const interface,
 			   const float delay){
+  int sd = -1;
   error_t old_errno = errno;
-  int ret;
+  error_t ret_errno = 0;
+  int ret, ret_setflags;
   struct ifreq network;
   unsigned int if_index = if_nametoindex(interface);
   if(if_index == 0){
@@ -1711,29 +1634,24 @@
   }
   
   if(not interface_is_up(interface)){
-    error_t ret_errno = 0, ioctl_errno = 0;
-    if(not get_flags(interface, &network)){
+    if(not get_flags(interface, &network) and debug){
       ret_errno = errno;
       fprintf_plus(stderr, "Failed to get flags for interface "
 		   "\"%s\"\n", interface);
-      errno = old_errno;
       return ret_errno;
     }
-    network.ifr_flags |= IFF_UP; /* set flag */
+    network.ifr_flags |= IFF_UP;
     
-    int sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
-    if(sd == -1){
+    sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
+    if(sd < 0){
       ret_errno = errno;
       perror_plus("socket");
       errno = old_errno;
       return ret_errno;
     }
-    
+  
     if(quit_now){
-      ret = (int)TEMP_FAILURE_RETRY(close(sd));
-      if(ret == -1){
-	perror_plus("close");
-      }
+      close(sd);
       errno = old_errno;
       return EINTR;
     }
@@ -1743,29 +1661,21 @@
 		   interface);
     }
     
-    /* Raise privileges */
-    ret_errno = raise_privileges();
-    if(ret_errno != 0){
-      errno = ret_errno;
-      perror_plus("Failed to raise privileges");
-    }
+    /* Raise priviliges */
+    raise_privileges();
     
 #ifdef __linux__
-    int ret_linux;
-    bool restore_loglevel = false;
-    if(ret_errno == 0){
-      /* Lower kernel loglevel to KERN_NOTICE to avoid KERN_INFO
-	 messages about the network interface to mess up the prompt */
-      ret_linux = klogctl(8, NULL, 5);
-      if(ret_linux == -1){
-	perror_plus("klogctl");
-      } else {
-	restore_loglevel = true;
-      }
+    /* Lower kernel loglevel to KERN_NOTICE to avoid KERN_INFO
+       messages about the network interface to mess up the prompt */
+    int ret_linux = klogctl(8, NULL, 5);
+    bool restore_loglevel = true;
+    if(ret_linux == -1){
+      restore_loglevel = false;
+      perror_plus("klogctl");
     }
 #endif	/* __linux__ */
-    int ret_setflags = ioctl(sd, SIOCSIFFLAGS, &network);
-    ioctl_errno = errno;
+    ret_setflags = ioctl(sd, SIOCSIFFLAGS, &network);
+    ret_errno = errno;
 #ifdef __linux__
     if(restore_loglevel){
       ret_linux = klogctl(7, NULL, 0);
@@ -1775,15 +1685,8 @@
     }
 #endif	/* __linux__ */
     
-    /* If raise_privileges() succeeded above */
-    if(ret_errno == 0){
-      /* Lower privileges */
-      ret_errno = lower_privileges();
-      if(ret_errno != 0){
-	errno = ret_errno;
-	perror_plus("Failed to lower privileges");
-      }
-    }
+    /* Lower privileges */
+    lower_privileges();
     
     /* Close the socket */
     ret = (int)TEMP_FAILURE_RETRY(close(sd));
@@ -1792,10 +1695,10 @@
     }
     
     if(ret_setflags == -1){
-      errno = ioctl_errno;
+      errno = ret_errno;
       perror_plus("ioctl SIOCSIFFLAGS +IFF_UP");
       errno = old_errno;
-      return ioctl_errno;
+      return ret_errno;
     }
   } else if(debug){
     fprintf_plus(stderr, "Interface \"%s\" is already up; good\n",
@@ -1819,9 +1722,11 @@
   return 0;
 }
 
-__attribute__((nonnull, warn_unused_result))
 error_t take_down_interface(const char *const interface){
+  int sd = -1;
   error_t old_errno = errno;
+  error_t ret_errno = 0;
+  int ret, ret_setflags;
   struct ifreq network;
   unsigned int if_index = if_nametoindex(interface);
   if(if_index == 0){
@@ -1830,18 +1735,16 @@
     return ENXIO;
   }
   if(interface_is_up(interface)){
-    error_t ret_errno = 0, ioctl_errno = 0;
     if(not get_flags(interface, &network) and debug){
       ret_errno = errno;
       fprintf_plus(stderr, "Failed to get flags for interface "
 		   "\"%s\"\n", interface);
-      errno = old_errno;
       return ret_errno;
     }
     network.ifr_flags &= ~(short)IFF_UP; /* clear flag */
     
-    int sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
-    if(sd == -1){
+    sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
+    if(sd < 0){
       ret_errno = errno;
       perror_plus("socket");
       errno = old_errno;
@@ -1853,37 +1756,26 @@
 		   interface);
     }
     
-    /* Raise privileges */
-    ret_errno = raise_privileges();
-    if(ret_errno != 0){
-      errno = ret_errno;
-      perror_plus("Failed to raise privileges");
-    }
-    
-    int ret_setflags = ioctl(sd, SIOCSIFFLAGS, &network);
-    ioctl_errno = errno;
-    
-    /* If raise_privileges() succeeded above */
-    if(ret_errno == 0){
-      /* Lower privileges */
-      ret_errno = lower_privileges();
-      if(ret_errno != 0){
-	errno = ret_errno;
-	perror_plus("Failed to lower privileges");
-      }
-    }
+    /* Raise priviliges */
+    raise_privileges();
+    
+    ret_setflags = ioctl(sd, SIOCSIFFLAGS, &network);
+    ret_errno = errno;
+    
+    /* Lower privileges */
+    lower_privileges();
     
     /* Close the socket */
-    int ret = (int)TEMP_FAILURE_RETRY(close(sd));
+    ret = (int)TEMP_FAILURE_RETRY(close(sd));
     if(ret == -1){
       perror_plus("close");
     }
     
     if(ret_setflags == -1){
-      errno = ioctl_errno;
+      errno = ret_errno;
       perror_plus("ioctl SIOCSIFFLAGS -IFF_UP");
       errno = old_errno;
-      return ioctl_errno;
+      return ret_errno;
     }
   } else if(debug){
     fprintf_plus(stderr, "Interface \"%s\" is already down; odd\n",
@@ -1897,7 +1789,7 @@
 int main(int argc, char *argv[]){
   mandos_context mc = { .server = NULL, .dh_bits = 1024,
 			.priority = "SECURE256:!CTYPE-X.509:"
-			"+CTYPE-OPENPGP", .current_server = NULL,
+			"+CTYPE-OPENPGP", .current_server = NULL, 
 			.interfaces = NULL, .interfaces_size = 0 };
   AvahiSServiceBrowser *sb = NULL;
   error_t ret_errno;
@@ -1907,13 +1799,13 @@
   int exitcode = EXIT_SUCCESS;
   char *interfaces_to_take_down = NULL;
   size_t interfaces_to_take_down_size = 0;
-  char run_tempdir[] = "/run/tmp/mandosXXXXXX";
-  char old_tempdir[] = "/tmp/mandosXXXXXX";
-  char *tempdir = NULL;
+  char tempdir[] = "/tmp/mandosXXXXXX";
+  bool tempdir_created = false;
   AvahiIfIndex if_index = AVAHI_IF_UNSPEC;
   const char *seckey = PATHDIR "/" SECKEY;
   const char *pubkey = PATHDIR "/" PUBKEY;
   char *interfaces_hooks = NULL;
+  size_t interfaces_hooks_size = 0;
   
   bool gnutls_initialized = false;
   bool gpgme_initialized = false;
@@ -2097,12 +1989,8 @@
     /* Work around Debian bug #633582:
        <http://bugs.debian.org/633582> */
     
-    /* Re-raise privileges */
-    ret_errno = raise_privileges();
-    if(ret_errno != 0){
-      errno = ret_errno;
-      perror_plus("Failed to raise privileges");
-    } else {
+    /* Re-raise priviliges */
+    if(raise_privileges() == 0){
       struct stat st;
       
       if(strcmp(seckey, PATHDIR "/" SECKEY) == 0){
@@ -2148,11 +2036,7 @@
       }
     
       /* Lower privileges */
-      ret_errno = lower_privileges();
-      if(ret_errno != 0){
-	errno = ret_errno;
-	perror_plus("Failed to lower privileges");
-      }
+      lower_privileges();
     }
   }
   
@@ -2182,10 +2066,14 @@
 	goto end;
       }
       memcpy(interfaces_hooks, mc.interfaces, mc.interfaces_size);
-      argz_stringify(interfaces_hooks, mc.interfaces_size, (int)',');
-    }
-    run_network_hooks("start", interfaces_hooks != NULL ?
-		      interfaces_hooks : "", delay);
+      interfaces_hooks_size = mc.interfaces_size;
+      argz_stringify(interfaces_hooks, interfaces_hooks_size,
+		     (int)',');
+    }
+    if(not run_network_hooks("start", interfaces_hooks != NULL ?
+			     interfaces_hooks : "", delay)){
+      goto end;
+    }
   }
   
   if(not debug){
@@ -2269,7 +2157,7 @@
   
   /* If no interfaces were specified, make a list */
   if(mc.interfaces == NULL){
-    struct dirent **direntries = NULL;
+    struct dirent **direntries;
     /* Look for any good interfaces */
     ret = scandir(sys_class_net, &direntries, good_interface,
 		  alphasort);
@@ -2279,22 +2167,17 @@
 	ret_errno = argz_add(&mc.interfaces, &mc.interfaces_size,
 			     direntries[i]->d_name);
 	if(ret_errno != 0){
-	  errno = ret_errno;
 	  perror_plus("argz_add");
-	  free(direntries[i]);
 	  continue;
 	}
 	if(debug){
 	  fprintf_plus(stderr, "Will use interface \"%s\"\n",
 		       direntries[i]->d_name);
 	}
-	free(direntries[i]);
       }
       free(direntries);
     } else {
-      if(ret == 0){
-	free(direntries);
-      }
+      free(direntries);
       fprintf_plus(stderr, "Could not find a network interface\n");
       exitcode = EXIT_FAILURE;
       goto end;
@@ -2323,17 +2206,15 @@
 	break;
       }
       bool interface_was_up = interface_is_up(interface);
-      errno = bring_up_interface(interface, delay);
+      ret = bring_up_interface(interface, delay);
       if(not interface_was_up){
-	if(errno != 0){
+	if(ret != 0){
+	  errno = ret;
 	  perror_plus("Failed to bring up interface");
 	} else {
-	  errno = argz_add(&interfaces_to_take_down,
-			   &interfaces_to_take_down_size,
-			   interface);
-	  if(errno != 0){
-	    perror_plus("argz_add");
-	  }
+	  ret_errno = argz_add(&interfaces_to_take_down,
+			       &interfaces_to_take_down_size,
+			       interface);
 	}
       }
     }
@@ -2368,19 +2249,11 @@
     goto end;
   }
   
-  /* Try /run/tmp before /tmp */
-  tempdir = mkdtemp(run_tempdir);
-  if(tempdir == NULL and errno == ENOENT){
-      if(debug){
-	fprintf_plus(stderr, "Tempdir %s did not work, trying %s\n",
-		     run_tempdir, old_tempdir);
-      }
-      tempdir = mkdtemp(old_tempdir);
-  }
-  if(tempdir == NULL){
+  if(mkdtemp(tempdir) == NULL){
     perror_plus("mkdtemp");
     goto end;
   }
+  tempdir_created = true;
   
   if(quit_now){
     goto end;
@@ -2458,10 +2331,10 @@
 	fprintf_plus(stderr, "Retrying in %d seconds\n",
 		     (int)retry_interval);
       }
-      sleep((unsigned int)retry_interval);
+      sleep((int)retry_interval);
     }
     
-    if(not quit_now){
+    if (not quit_now){
       exitcode = EXIT_SUCCESS;
     }
     
@@ -2522,7 +2395,7 @@
   if(debug){
     fprintf_plus(stderr, "Starting Avahi loop search\n");
   }
-  
+
   ret = avahi_loop_with_timeout(simple_poll,
 				(int)(retry_interval * 1000), &mc);
   if(debug){
@@ -2564,102 +2437,76 @@
     mc.current_server->prev->next = NULL;
     while(mc.current_server != NULL){
       server *next = mc.current_server->next;
-#ifdef __GNUC__
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wcast-qual"
-#endif
-      free((char *)(mc.current_server->ip));
-#ifdef __GNUC__
-#pragma GCC diagnostic pop
-#endif
       free(mc.current_server);
       mc.current_server = next;
     }
   }
   
-  /* Re-raise privileges */
+  /* Re-raise priviliges */
   {
-    ret_errno = raise_privileges();
-    if(ret_errno != 0){
-      errno = ret_errno;
-      perror_plus("Failed to raise privileges");
-    } else {
-      
-      /* Run network hooks */
-      run_network_hooks("stop", interfaces_hooks != NULL ?
-			interfaces_hooks : "", delay);
-      
-      /* Take down the network interfaces which were brought up */
-      {
-	char *interface = NULL;
-	while((interface=argz_next(interfaces_to_take_down,
-				   interfaces_to_take_down_size,
-				   interface))){
-	  ret_errno = take_down_interface(interface);
-	  if(ret_errno != 0){
-	    errno = ret_errno;
-	    perror_plus("Failed to take down interface");
-	  }
-	}
-	if(debug and (interfaces_to_take_down == NULL)){
-	  fprintf_plus(stderr, "No interfaces needed to be taken"
-		       " down\n");
-	}
-      }
-    }
-    
-    ret_errno = lower_privileges_permanently();
-    if(ret_errno != 0){
-      errno = ret_errno;
-      perror_plus("Failed to lower privileges permanently");
-    }
+    raise_privileges();
+    
+    /* Run network hooks */
+    run_network_hooks("stop", interfaces_hooks != NULL ?
+		      interfaces_hooks : "", delay);
+    
+    /* Take down the network interfaces which were brought up */
+    {
+      char *interface = NULL;
+      while((interface=argz_next(interfaces_to_take_down,
+				 interfaces_to_take_down_size,
+				 interface))){
+	ret_errno = take_down_interface(interface);
+	if(ret_errno != 0){
+	  errno = ret_errno;
+	  perror_plus("Failed to take down interface");
+	}
+      }
+      if(debug and (interfaces_to_take_down == NULL)){
+	fprintf_plus(stderr, "No interfaces needed to be taken"
+		     " down\n");
+      }
+    }
+    
+    lower_privileges_permanently();
   }
   
   free(interfaces_to_take_down);
   free(interfaces_hooks);
   
   /* Removes the GPGME temp directory and all files inside */
-  if(tempdir != NULL){
+  if(tempdir_created){
     struct dirent **direntries = NULL;
-    int tempdir_fd = (int)TEMP_FAILURE_RETRY(open(tempdir, O_RDONLY |
-						  O_NOFOLLOW));
-    if(tempdir_fd == -1){
-      perror_plus("open");
-    } else {
-#ifdef __GLIBC__
-#if __GLIBC_PREREQ(2, 15)
-      int numentries = scandirat(tempdir_fd, ".", &direntries,
-				 notdotentries, alphasort);
-#else  /* not __GLIBC_PREREQ(2, 15) */
-      int numentries = scandir(tempdir, &direntries, notdotentries,
-			       alphasort);
-#endif	/* not __GLIBC_PREREQ(2, 15) */
-#else	/* not __GLIBC__ */
-      int numentries = scandir(tempdir, &direntries, notdotentries,
-			       alphasort);
-#endif	/* not __GLIBC__ */
-      if(numentries >= 0){
-	for(int i = 0; i < numentries; i++){
-	  ret = unlinkat(tempdir_fd, direntries[i]->d_name, 0);
-	  if(ret == -1){
-	    fprintf_plus(stderr, "unlinkat(open(\"%s\", O_RDONLY),"
-			 " \"%s\", 0): %s\n", tempdir,
-			 direntries[i]->d_name, strerror(errno));
-	  }
-	  free(direntries[i]);
-	}
-	
-	/* need to clean even if 0 because man page doesn't specify */
-	free(direntries);
-	if(numentries == -1){
-	  perror_plus("scandir");
-	}
-	ret = rmdir(tempdir);
-	if(ret == -1 and errno != ENOENT){
-	  perror_plus("rmdir");
-	}
+    struct dirent *direntry = NULL;
+    int numentries = scandir(tempdir, &direntries, notdotentries,
+			     alphasort);
+    if (numentries > 0){
+      for(int i = 0; i < numentries; i++){
+	direntry = direntries[i];
+	char *fullname = NULL;
+	ret = asprintf(&fullname, "%s/%s", tempdir,
+		       direntry->d_name);
+	if(ret < 0){
+	  perror_plus("asprintf");
+	  continue;
+	}
+	ret = remove(fullname);
+	if(ret == -1){
+	  fprintf_plus(stderr, "remove(\"%s\"): %s\n", fullname,
+		       strerror(errno));
+	}
+	free(fullname);
       }
-      TEMP_FAILURE_RETRY(close(tempdir_fd));
+    }
+
+    /* need to clean even if 0 because man page doesn't specify */
+    free(direntries);
+    if (numentries == -1){
+      perror_plus("scandir");
+    }
+    ret = rmdir(tempdir);
+    if(ret == -1 and errno != ENOENT){
+      perror_plus("rmdir");
     }
   }
   

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2014-06-22 02:19:30 +0000
+++ plugins.d/mandos-client.xml	2012-06-17 02:30:59 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2014-06-22">
+<!ENTITY TIMESTAMP "2012-06-17">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -34,8 +34,6 @@
       <year>2008</year>
       <year>2009</year>
       <year>2012</year>
-      <year>2013</year>
-      <year>2014</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -220,9 +218,8 @@
 	    assumed to separate the address from the port number.
 	  </para>
 	  <para>
-	    Normally, Zeroconf would be used to locate Mandos servers,
-	    in which case this option would only be used when testing
-	    and debugging.
+	    This option is normally only useful for testing and
+	    debugging.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -261,9 +258,10 @@
 	  <para>
 	    <replaceable>NAME</replaceable> can be the string
 	    <quote><literal>none</literal></quote>; this will make
-	    <command>&COMMANDNAME;</command> only bring up interfaces
-	    specified <emphasis>before</emphasis> this string.  This
-	    is not recommended, and only meant for advanced users.
+	    <command>&COMMANDNAME;</command> not bring up
+	    <emphasis>any</emphasis> interfaces specified
+	    <emphasis>after</emphasis> this string.  This is not
+	    recommended, and only meant for advanced users.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -514,7 +512,7 @@
 	      It is not necessary to print any non-executable files
 	      already in the network hook directory, these will be
 	      copied implicitly if they otherwise satisfy the name
-	      requirements.
+	      requirement.
 	    </para>
 	  </listitem>
 	</varlistentry>
@@ -668,7 +666,7 @@
     </para>
     <informalexample>
       <para>
-	Normal invocation needs no options, if the network interfaces
+	Normal invocation needs no options, if the network interface
 	can be automatically determined:
       </para>
       <para>
@@ -677,8 +675,8 @@
     </informalexample>
     <informalexample>
       <para>
-	Search for Mandos servers (and connect to them) using one
-	specific interface:
+	Search for Mandos servers (and connect to them) using another
+	interface:
       </para>
       <para>
 	<!-- do not wrap this line -->
@@ -748,9 +746,8 @@
     <para>
       It will also help if the checker program on the server is
       configured to request something from the client which can not be
-      spoofed by someone else on the network, like SSH server key
-      fingerprints, and unlike unencrypted <acronym>ICMP</acronym>
-      echo (<quote>ping</quote>) replies.
+      spoofed by someone else on the network, unlike unencrypted
+      <acronym>ICMP</acronym> echo (<quote>ping</quote>) replies.
     </para>
     <para>
       <emphasis>Note</emphasis>: This makes it completely insecure to
@@ -849,7 +846,7 @@
 	      <para>
 		This client uses IPv6 link-local addresses, which are
 		immediately usable since a link-local addresses is
-		automatically assigned to a network interface when it
+		automatically assigned to a network interfaces when it
 		is brought up.
 	      </para>
 	    </listitem>

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2014-03-29 02:38:15 +0000
+++ plugins.d/password-prompt.c	2011-12-31 23:05:34 +0000
@@ -2,8 +2,8 @@
 /*
  * Password-prompt - Read a password from the terminal and print it
  * 
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2012 Teddy Hogeborn
+ * Copyright © 2008-2012 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -72,6 +72,16 @@
 /* Needed for conflict resolution */
 const char plymouth_name[] = "plymouthd";
 
+__attribute__((format (gnu_printf, 2, 3), nonnull(1)))
+int fprintf_plus(FILE *stream, const char *format, ...){
+  va_list ap;
+  va_start (ap, format);
+  
+  TEMP_FAILURE_RETRY(fprintf(stream, "Mandos plugin %s: ",
+			     program_invocation_short_name));
+  return TEMP_FAILURE_RETRY(vfprintf(stream, format, ap));
+}
+
 /* Function to use when printing errors */
 __attribute__((format (gnu_printf, 3, 4)))
 void error_plus(int status, int errnum, const char *formatstring,
@@ -82,7 +92,7 @@
   
   va_start(ap, formatstring);
   ret = vasprintf(&text, formatstring, ap);
-  if(ret == -1){
+  if (ret == -1){
     fprintf(stderr, "Mandos plugin %s: ",
 	    program_invocation_short_name);
     vfprintf(stderr, formatstring, ap);
@@ -212,7 +222,7 @@
   struct dirent **direntries = NULL;
   int ret;
   ret = scandir("/proc", &direntries, is_plymouth, alphasort);
-  if(ret == -1){
+  if (ret == -1){
     error_plus(1, errno, "scandir");
   }
   free(direntries);
@@ -303,7 +313,7 @@
     fprintf(stderr, "Starting %s\n", argv[0]);
   }
 
-  if(conflict_detection()){
+  if (conflict_detection()){
     if(debug){
       fprintf(stderr, "Stopping %s because of conflict\n", argv[0]);
     }

=== modified file 'plugins.d/plymouth.c'
--- plugins.d/plymouth.c	2014-03-29 02:38:15 +0000
+++ plugins.d/plymouth.c	2011-12-31 23:05:34 +0000
@@ -2,8 +2,8 @@
 /*
  * Plymouth - Read a password from Plymouth and output it
  * 
- * Copyright © 2010-2014 Teddy Hogeborn
- * Copyright © 2010-2014 Björn Påhlsson
+ * Copyright © 2010-2012 Teddy Hogeborn
+ * Copyright © 2010-2012 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -84,7 +84,7 @@
   
   va_start(ap, formatstring);
   ret = vasprintf(&text, formatstring, ap);
-  if(ret == -1){
+  if (ret == -1){
     fprintf(stderr, "Mandos plugin %s: ",
 	    program_invocation_short_name);
     vfprintf(stderr, formatstring, ap);
@@ -156,7 +156,7 @@
 
 __attribute__((nonnull (2, 3)))
 bool exec_and_wait(pid_t *pid_return, const char *path,
-		   const char * const *argv, bool interruptable,
+		   const char **argv, bool interruptable,
 		   bool daemonize){
   int status;
   int ret;
@@ -179,7 +179,7 @@
     int i = 0;
     for (; argv[i]!=NULL; i++){
       tmp = realloc(new_argv, sizeof(const char *) * ((size_t)i + 1));
-      if(tmp == NULL){
+      if (tmp == NULL){
 	error_plus(0, errno, "realloc");
 	free(new_argv);
 	_exit(EX_OSERR);
@@ -290,12 +290,12 @@
   if(proc_id == 0){
     struct dirent **direntries = NULL;
     ret = scandir("/proc", &direntries, is_plymouth, alphasort);
-    if(ret == -1){
+    if (ret == -1){
       error_plus(0, errno, "scandir");
     }
-    if(ret > 0){
+    if (ret > 0){
       ret = sscanf(direntries[0]->d_name, "%" SCNuMAX, &proc_id);
-      if(ret < 0){
+      if (ret < 0){
 	error_plus(0, errno, "sscanf");
       }
     }
@@ -312,7 +312,7 @@
   return 0;
 }
 
-const char * const * getargv(pid_t pid){
+const char **getargv(pid_t pid){
   int cl_fd;
   char *cmdline_filename;
   ssize_t sret;
@@ -379,7 +379,7 @@
     return NULL;
   }
   argz_extract(cmdline, cmdline_len, argv); /* Create argv */
-  return (const char * const *)argv;
+  return (const char **)argv;
 }
 
 int main(__attribute__((unused))int argc,
@@ -460,7 +460,7 @@
   }
   kill_and_wait(plymouth_command_pid);
   
-  const char * const *plymouthd_argv;
+  const char **plymouthd_argv;
   pid_t pid = get_pid();
   if(pid == 0){
     error_plus(0, 0, "plymouthd pid not found");

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2014-03-29 02:38:15 +0000
+++ plugins.d/splashy.c	2011-12-31 23:05:34 +0000
@@ -2,8 +2,8 @@
 /*
  * Splashy - Read a password from splashy and output it
  * 
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2012 Teddy Hogeborn
+ * Copyright © 2008-2012 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -70,7 +70,7 @@
   
   va_start(ap, formatstring);
   ret = vasprintf(&text, formatstring, ap);
-  if(ret == -1){
+  if (ret == -1){
     fprintf(stderr, "Mandos plugin %s: ",
 	    program_invocation_short_name);
     vfprintf(stderr, formatstring, ap);

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2014-03-29 02:38:15 +0000
+++ plugins.d/usplash.c	2011-12-31 23:05:34 +0000
@@ -2,8 +2,8 @@
 /*
  * Usplash - Read a password from usplash and output it
  * 
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2012 Teddy Hogeborn
+ * Copyright © 2008-2012 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -67,7 +67,7 @@
   
   va_start(ap, formatstring);
   ret = vasprintf(&text, formatstring, ap);
-  if(ret == -1){
+  if (ret == -1){
     fprintf(stderr, "Mandos plugin %s: ",
 	    program_invocation_short_name);
     vfprintf(stderr, formatstring, ap);

